# Autogenerated file. Changes will be overwritten.

try:
    import coriolis
except ImportError:
    import CRL, Hurricane, Viewer, Cfg
    from Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from helpers import u, l
    from helpers.technology import setEnclosures
    from helpers.overlay import CfgCache, UpdateSession
else:
    from coriolis import CRL, Hurricane, Viewer, Cfg
    from coriolis.Hurricane import (
        Technology, DataBase, DbU, Library,
        Layer, BasicLayer,
        Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
        Instance, Transformation,
        NetExternalComponents,
    )
    from coriolis.helpers import u, l
    from coriolis.helpers.technology import setEnclosures
    from coriolis.helpers.overlay import CfgCache, UpdateSession

__all__ = ["setup"]

def createRL(tech, net, layer, coords):
    coords = [Point(u(x), u(y)) for x,y in coords]
    Rectilinear.create(net, tech.getLayer(layer), coords)

def _routing():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()

    rg = CRL.RoutingGauge.create('StdCell5V0Lib')
    rg.setSymbolic(False)
    metal = tech.getLayer('Metal1')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.0), u(0.06)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.PinOnly, 0, 0.0,
        u(0.0), u(0.66), u(0.26), u(0.23), u(0.26), u(0.23),
    ))
    metal = tech.getLayer('Metal2')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.01), u(0.06)))
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 1, 0.0,
        u(0.0), u(0.66), u(0.38), u(0.28), u(0.26), u(0.28),
    ))
    metal = tech.getLayer('Metal3')
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 2, 0.0,
        u(0.0), u(0.66), u(0.38), u(0.28), u(0.26), u(0.28),
    ))
    metal = tech.getLayer('Metal4')
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 3, 0.0,
        u(0.0), u(0.66), u(0.38), u(0.28), u(0.26), u(0.28),
    ))
    metal = tech.getLayer('Metal5')
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.06), u(0.06)))
    via = tech.getLayer('Metal5_Via5_MetalTop')
    setEnclosures(via, metal, (u(0.06), u(0.09)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 4, 0.0,
        u(0.0), u(0.66), u(0.38), u(0.28), u(0.26), u(0.28),
    ))
    metal = tech.getLayer('MetalTop')
    via = tech.getLayer('Metal5_Via5_MetalTop')
    setEnclosures(via, metal, (u(0.06), u(0.09)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 5, 0.0,
        u(0.0), u(0.876), u(0.44), u(0.44), u(0.26), u(0.436),
    ))
    af.addRoutingGauge(rg)
    af.setRoutingGauge('StdCell5V0Lib')

    cg = CRL.CellGauge.create(
        'StdCell5V0Lib', 'Metal2',
        u(1.6), u(16.0), u(1.6),
    )
    af.addCellGauge(cg)
    af.setCellGauge('StdCell5V0Lib')

    # Place & Route setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        cfg.lefImport.minTerminalWidth = 0.0
        cfg.crlcore.groundName = 'vss'
        cfg.crlcore.powerName = 'vdd'
        cfg.etesian.aspectRatio = 1.00
        cfg.etesian.aspectRatio = [10, 1000]
        cfg.etesian.spaceMargin = 0.10
        cfg.etesian.uniformDensity = True
        cfg.etesian.routingDriven = False
        cfg.etesian.latchUpDistance = u(30.0 - 1.0)
        cfg.etesian.diodeName = 'diode_w1'
        cfg.etesian.antennaInsertThreshold = 0.50
        cfg.etesian.antennaMaxWL = u(250.0)
        cfg.etesian.feedNames = 'tie,decap_w0'
        cfg.etesian.cell.zero = 'zero_x1'
        cfg.etesian.cell.one = 'one_x1'
        cfg.etesian.bloat = 'disabled'
        cfg.etesian.effort = 2
        cfg.etesian.effort = (
            ('Fast', 1),
            ('Standard', 2),
            ('High', 3 ),
            ('Extreme', 4 ),
        )
        cfg.etesian.graphics = 2
        cfg.etesian.graphics = (
            ('Show every step', 1),
            ('Show lower bound', 2),
            ('Show result only', 3),
        )
        cfg.anabatic.routingGauge = 'StdCell5V0Lib'
        cfg.anabatic.globalLengthThreshold = 1450
        cfg.anabatic.saturateRatio = 0.90
        cfg.anabatic.saturateRp = 10
        cfg.anabatic.topRoutingLayer = 'MetalTop'
        cfg.anabatic.edgeLength = 48
        cfg.anabatic.edgeWidth = 8
        cfg.anabatic.edgeCostH = 9.0
        cfg.anabatic.edgeCostK = -10.0
        cfg.anabatic.edgeHInc = 1.0
        cfg.anabatic.edgeHScaling = 1.0
        cfg.anabatic.globalIterations = 10
        cfg.anabatic.globalIterations = [ 1, 100 ]
        cfg.anabatic.gcell.displayMode = 1
        cfg.anabatic.gcell.displayMode = (("Boundary", 1), ("Density", 2))
        cfg.katana.hTracksReservedLocal = 4
        cfg.katana.hTracksReservedLocal = [0, 20]
        cfg.katana.vTracksReservedLocal = 3
        cfg.katana.vTracksReservedLocal = [0, 20]
        cfg.katana.termSatReservedLocal = 8
        cfg.katana.termSatThreshold = 9
        cfg.katana.eventsLimit = 4000002
        cfg.katana.ripupCost = 3
        cfg.katana.ripupCost = [0, None]
        cfg.katana.strapRipupLimit = 16
        cfg.katana.strapRipupLimit = [1, None]
        cfg.katana.localRipupLimit = 9
        cfg.katana.localRipupLimit = [1, None]
        cfg.katana.globalRipupLimit = 5
        cfg.katana.globalRipupLimit = [1, None]
        cfg.katana.longGlobalRipupLimit = 5
        cfg.chip.padCoreSide = 'South'

    # Plugins setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        cfg.viewer.minimumSize = 500
        cfg.viewer.pixelThreshold = 10
        cfg.chip.block.rails.count = 5
        cfg.chip.block.rails.hWidth = u(2.68)
        cfg.chip.block.rails.vWidth = u(2.68)
        cfg.chip.block.rails.hSpacing = u(0.7)
        cfg.chip.block.rails.vSpacing = u(0.7)
        cfg.clockTree.minimumSide = l(600)
        cfg.clockTree.buffer = 'buf_x1'
        cfg.clockTree.placerEngine = 'Etesian'
        cfg.block.spareSide = 10
        cfg.spares.buffer = 'buf_x4'
        cfg.spares.maxSinks = 31


def _load():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()
    rootlib = db.getRootLibrary()

    lib = Library.create(rootlib, 'StdCell5V0Lib')
    new_cells = {
        'a2_x2': Cell.create(lib, 'a2_x2'),
        'a3_x2': Cell.create(lib, 'a3_x2'),
        'a4_x2': Cell.create(lib, 'a4_x2'),
        'ao22_x2': Cell.create(lib, 'ao22_x2'),
        'mx2_x2': Cell.create(lib, 'mx2_x2'),
        'mx3_x2': Cell.create(lib, 'mx3_x2'),
        'nsnrlatch_x1': Cell.create(lib, 'nsnrlatch_x1'),
        'nxr2_x1': Cell.create(lib, 'nxr2_x1'),
        'o2_x2': Cell.create(lib, 'o2_x2'),
        'o3_x2': Cell.create(lib, 'o3_x2'),
        'o4_x2': Cell.create(lib, 'o4_x2'),
        'oa22_x2': Cell.create(lib, 'oa22_x2'),
        'powmid_x0': Cell.create(lib, 'powmid_x0'),
        'sff1_x4': Cell.create(lib, 'sff1_x4'),
        'sff1r_x4': Cell.create(lib, 'sff1r_x4'),
        'xr2_x1': Cell.create(lib, 'xr2_x1'),
        'fill': Cell.create(lib, 'fill'),
        'tie': Cell.create(lib, 'tie'),
        'tie_diff': Cell.create(lib, 'tie_diff'),
        'tie_poly': Cell.create(lib, 'tie_poly'),
        'fill_w2': Cell.create(lib, 'fill_w2'),
        'tie_w2': Cell.create(lib, 'tie_w2'),
        'tie_diff_w2': Cell.create(lib, 'tie_diff_w2'),
        'tie_poly_w2': Cell.create(lib, 'tie_poly_w2'),
        'fill_w4': Cell.create(lib, 'fill_w4'),
        'tie_w4': Cell.create(lib, 'tie_w4'),
        'tie_diff_w4': Cell.create(lib, 'tie_diff_w4'),
        'tie_poly_w4': Cell.create(lib, 'tie_poly_w4'),
        'diode_w1': Cell.create(lib, 'diode_w1'),
        'zero_x1': Cell.create(lib, 'zero_x1'),
        'one_x1': Cell.create(lib, 'one_x1'),
        'zeroone_x1': Cell.create(lib, 'zeroone_x1'),
        'decap_w0': Cell.create(lib, 'decap_w0'),
        'inv_x0': Cell.create(lib, 'inv_x0'),
        'inv_x1': Cell.create(lib, 'inv_x1'),
        'inv_x2': Cell.create(lib, 'inv_x2'),
        'inv_x4': Cell.create(lib, 'inv_x4'),
        'buf_x1': Cell.create(lib, 'buf_x1'),
        'buf_x2': Cell.create(lib, 'buf_x2'),
        'buf_x4': Cell.create(lib, 'buf_x4'),
        'nand2_x0': Cell.create(lib, 'nand2_x0'),
        'nand3_x0': Cell.create(lib, 'nand3_x0'),
        'nand4_x0': Cell.create(lib, 'nand4_x0'),
        'nor2_x0': Cell.create(lib, 'nor2_x0'),
        'nor3_x0': Cell.create(lib, 'nor3_x0'),
        'nor4_x0': Cell.create(lib, 'nor4_x0'),
    }

    cell = new_cells['a2_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((1.3,2.48),(1.3,5.52),(1.9,5.52),(1.9,2.48),(1.3,2.48)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,0.96),(2.9,4.0),(5.1,4.0),(5.1,0.96),(2.9,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,1.11),(3.89,1.33),(4.11,1.33),(4.11,1.11),(3.89,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.61),(3.89,1.83),(4.11,1.83),(4.11,1.61),(3.89,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((5.1,8.8),(5.1,15.2),(5.78,15.2),(5.78,8.8),(5.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,0.96),(5.1,4.0),(5.78,4.0),(5.78,0.96),(5.1,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,2.15),(5.43,3.905),(5.47,3.905),(5.47,8.995),(5.43,8.995),(5.43,13.85),(5.77,13.85),(5.77,8.995),(5.73,8.995),(5.73,3.905),(5.77,3.905),(5.77,2.15),(5.43,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,2.18),(5.49,2.4),(5.71,2.4),(5.71,2.18),(5.49,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.68),(5.49,2.9),(5.71,2.9),(5.71,2.68),(5.49,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.18),(5.49,3.4),(5.71,3.4),(5.71,3.18),(5.49,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.68),(5.49,3.9),(5.71,3.9),(5.71,3.68),(5.49,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.0),(5.49,9.22),(5.71,9.22),(5.71,9.0),(5.49,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.5),(5.49,9.72),(5.71,9.72),(5.71,9.5),(5.49,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.0),(5.49,10.22),(5.71,10.22),(5.71,10.0),(5.49,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.5),(5.49,10.72),(5.71,10.72),(5.71,10.5),(5.49,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.0),(5.49,11.22),(5.71,11.22),(5.71,11.0),(5.49,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.5),(5.49,11.72),(5.71,11.72),(5.71,11.5),(5.49,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.0),(5.49,12.22),(5.71,12.22),(5.71,12.0),(5.49,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.5),(5.49,12.72),(5.71,12.72),(5.71,12.5),(5.49,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.0),(5.49,13.22),(5.71,13.22),(5.71,13.0),(5.49,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.5),(5.49,13.72),(5.71,13.72),(5.71,13.5),(5.49,13.5)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((2.09,0.73),(2.09,2.25),(0.46,2.25),(0.46,5.75),(2.71,5.75),(2.71,4.23),(5.94,4.23),(5.94,0.73),(2.09,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.92,14.17),(1.92,15.27),(2.88,15.27),(2.88,14.17),(1.92,14.17)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((3.66,8.57),(3.66,10.17),(0.46,10.17),(0.46,14.97),(1.14,14.97),(1.14,13.83),(3.66,13.83),(3.66,15.43),(5.94,15.43),(5.94,8.57),(3.66,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,4.22),(4.66,4.22),(4.66,6.22),(2.38,6.22),(2.38,6.58),(4.66,6.58),(4.66,8.58),(4.5,8.58),(4.5,15.42),(5.1,15.42),(5.1,8.58),(4.94,8.58),(4.94,4.22),(5.1,4.22),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.48),(0.62,5.52),(1.3,5.52),(1.3,2.48),(0.62,2.48)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,10.4),(1.9,13.6),(2.9,13.6),(2.9,10.4),(1.9,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.15),(0.63,5.365),(0.97,5.365),(0.97,3.315),(2.285,3.315),(2.285,10.635),(2.23,10.635),(2.23,13.85),(2.57,13.85),(2.57,10.635),(2.515,10.635),(2.515,6.515),(2.73,6.515),(2.73,6.285),(2.515,6.285),(2.515,3.085),(0.97,3.085),(0.97,2.15),(0.63,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.64),(0.69,2.86),(0.91,2.86),(0.91,2.64),(0.69,2.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.14),(0.69,3.36),(0.91,3.36),(0.91,3.14),(0.69,3.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.64),(0.69,3.86),(0.91,3.86),(0.91,3.64),(0.69,3.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.14),(0.69,4.36),(0.91,4.36),(0.91,4.14),(0.69,4.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.64),(0.69,4.86),(0.91,4.86),(0.91,4.64),(0.69,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,5.14),(0.69,5.36),(0.91,5.36),(0.91,5.14),(0.69,5.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,10.64),(2.29,10.86),(2.51,10.86),(2.51,10.64),(2.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.14),(2.29,11.36),(2.51,11.36),(2.51,11.14),(2.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.64),(2.29,11.86),(2.51,11.86),(2.51,11.64),(2.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.14),(2.29,12.36),(2.51,12.36),(2.51,12.14),(2.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.64),(2.29,12.86),(2.51,12.86),(2.51,12.64),(2.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,13.14),(2.29,13.36),(2.51,13.36),(2.51,13.14),(2.29,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.45,6.29),(2.45,6.51),(2.67,6.51),(2.67,6.29),(2.45,6.29)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((3.82,8.8),(3.82,10.4),(2.9,10.4),(2.9,13.6),(3.82,13.6),(3.82,15.2),(5.1,15.2),(5.1,8.8),(3.82,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,14.74),(0.98,14.74),(0.98,13.6),(1.9,13.6),(1.9,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,14.4),(2.08,15.04),(2.72,15.04),(2.72,14.4),(2.08,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(6.88,17.28),(6.88,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,14.25),(3.89,14.47),(4.11,14.47),(4.11,14.25),(3.89,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.75),(3.89,14.97),(4.11,14.97),(4.11,14.75),(3.89,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((2.25,0.96),(2.25,2.48),(1.9,2.48),(1.9,5.52),(2.55,5.52),(2.55,4.0),(2.9,4.0),(2.9,0.96),(2.25,0.96)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.26),(1.3,5.74),(1.46,5.74),(1.46,7.82),(0.78,7.82),(0.78,8.18),(1.46,8.18),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,5.74),(1.9,5.74),(1.9,2.26),(1.3,2.26)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,5.595),(0.67,13.85),(0.93,13.85),(0.93,8.115),(1.13,8.115),(1.13,7.885),(0.93,7.885),(0.93,5.595),(0.67,5.595)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(5.595), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(5.595), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((3.22,7.82),(3.22,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,8.18),(4.02,8.18),(4.02,7.82),(3.22,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.9,0.74),(2.9,4.22),(3.22,4.22),(3.22,4.98),(4.02,4.98),(4.02,4.62),(3.5,4.62),(3.5,0.74),(2.9,0.74)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,2.15),(3.87,4.685),(3.67,4.685),(3.67,4.915),(3.87,4.915),(3.87,7.885),(3.67,7.885),(3.67,8.115),(3.87,8.115),(3.87,13.85),(4.13,13.85),(4.13,2.15),(3.87,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.73,4.69),(3.73,4.91),(3.95,4.91),(3.95,4.69),(3.73,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.73,7.89),(3.73,8.11),(3.95,8.11),(3.95,7.89),(3.73,7.89)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['a3_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((3.68,14.4),(3.68,15.04),(4.32,15.04),(4.32,14.4),(3.68,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,14.74),(2.58,14.74),(2.58,13.6),(3.5,13.6),(3.5,10.4),(1.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,8.8),(5.42,10.4),(4.5,10.4),(4.5,13.6),(5.42,13.6),(5.42,15.2),(6.7,15.2),(6.7,8.8),(5.42,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(8.48,17.28),(8.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,14.61),(3.89,14.83),(4.11,14.83),(4.11,14.61),(3.89,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.25),(5.49,14.47),(5.71,14.47),(5.71,14.25),(5.49,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.75),(5.49,14.97),(5.71,14.97),(5.71,14.75),(5.49,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.45),(2.29,14.67),(2.51,14.67),(2.51,14.45),(2.29,14.45)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.38,15.2),(7.38,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.38,4.0),(7.38,0.96),(6.7,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,2.15),(7.03,3.905),(7.07,3.905),(7.07,8.995),(7.03,8.995),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.33,8.995),(7.33,3.905),(7.37,3.905),(7.37,2.15),(7.03,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.18),(7.09,2.4),(7.31,2.4),(7.31,2.18),(7.09,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.68),(7.09,2.9),(7.31,2.9),(7.31,2.68),(7.09,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.18),(7.09,3.4),(7.31,3.4),(7.31,3.18),(7.09,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.68),(7.09,3.9),(7.31,3.9),(7.31,3.68),(7.09,3.68)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((3.52,0.57),(3.52,1.67),(4.48,1.67),(4.48,0.57),(3.52,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((5.26,8.57),(5.26,10.17),(0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,14.97),(2.74,14.97),(2.74,13.83),(5.26,13.83),(5.26,15.43),(7.54,15.43),(7.54,8.57),(5.26,8.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.52,14.17),(3.52,15.27),(4.48,15.27),(4.48,14.17),(3.52,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.26,0.73),(5.26,2.17),(0.46,2.17),(0.46,5.83),(5.94,5.83),(5.94,4.23),(7.54,4.23),(7.54,0.73),(5.26,0.73)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(5.58,6.22),(5.58,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,10.4),(3.5,13.6),(4.5,13.6),(4.5,10.4),(3.5,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,5.6),(1.3,5.6),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.5),(0.63,3.77),(0.97,3.77),(0.97,3.315),(5.485,3.315),(5.485,12.685),(4.17,12.685),(4.17,12.23),(3.83,12.23),(3.83,12.685),(0.97,12.685),(0.97,12.23),(0.63,12.23),(0.63,13.495),(0.97,13.495),(0.97,12.915),(3.83,12.915),(3.83,13.495),(4.17,13.495),(4.17,12.915),(5.715,12.915),(5.715,6.515),(5.93,6.515),(5.93,6.285),(5.715,6.285),(5.715,3.085),(0.97,3.085),(0.97,2.5),(0.63,2.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.27),(3.89,12.49),(4.11,12.49),(4.11,12.27),(3.89,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.77),(3.89,12.99),(4.11,12.99),(4.11,12.77),(3.89,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.27),(3.89,13.49),(4.11,13.49),(4.11,13.27),(3.89,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.65,6.29),(5.65,6.51),(5.87,6.51),(5.87,6.29),(5.65,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.505),(0.69,2.725),(0.91,2.725),(0.91,2.505),(0.69,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.005),(0.69,3.225),(0.91,3.225),(0.91,3.005),(0.69,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.505),(0.69,3.725),(0.91,3.725),(0.91,3.505),(0.69,3.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.27),(0.69,12.49),(0.91,12.49),(0.91,12.27),(0.69,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.77),(0.69,12.99),(0.91,12.99),(0.91,12.77),(0.69,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.27),(0.69,13.49),(0.91,13.49),(0.91,13.27),(0.69,13.27)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((5.42,0.96),(5.42,2.4),(4.5,2.4),(4.5,5.6),(5.78,5.6),(5.78,4.0),(6.7,4.0),(6.7,0.96),(5.42,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,0.8),(3.68,1.44),(4.32,1.44),(4.32,0.8),(3.68,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,2.4),(2.9,5.6),(3.5,5.6),(3.5,2.4),(2.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,2.4),(1.3,5.6),(1.9,5.6),(1.9,2.4),(1.3,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,1.11),(5.49,1.33),(5.71,1.33),(5.71,1.11),(5.49,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.61),(5.49,1.83),(5.71,1.83),(5.71,1.61),(5.49,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.01),(3.89,1.23),(4.11,1.23),(4.11,1.01),(3.89,1.01)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,5.82),(1.46,5.82),(1.46,6.22),(0.78,6.22),(0.78,6.58),(1.46,6.58),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,5.82),(1.9,5.82),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,4.0),(0.67,12.0),(0.93,12.0),(0.93,6.515),(1.13,6.515),(1.13,6.285),(0.93,6.285),(0.93,4.0),(0.67,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(4.0), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(4.0), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,5.6),(2.9,5.6),(2.9,2.4),(1.9,2.4)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,5.6),(4.5,5.6),(4.5,2.4),(3.5,2.4)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,5.82),(3.06,5.82),(3.06,7.82),(2.38,7.82),(2.38,8.18),(3.06,8.18),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,5.82),(3.5,5.82),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,3.545),(2.27,12.455),(2.53,12.455),(2.53,8.115),(2.73,8.115),(2.73,7.885),(2.53,7.885),(2.53,3.545),(2.27,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(3.545), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(3.545), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.45,7.89),(2.45,8.11),(2.67,8.11),(2.67,7.89),(2.45,7.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,5.82),(4.66,5.82),(4.66,7.82),(3.98,7.82),(3.98,8.18),(4.66,8.18),(4.66,10.18),(4.5,10.18),(4.5,13.82),(5.1,13.82),(5.1,10.18),(4.94,10.18),(4.94,5.82),(5.1,5.82),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,3.545),(3.87,12.0),(4.13,12.0),(4.13,8.115),(4.33,8.115),(4.33,7.885),(4.13,7.885),(4.13,3.545),(3.87,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(3.545), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(3.545), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((4.05,7.89),(4.05,8.11),(4.27,8.11),(4.27,7.89),(4.05,7.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['a4_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(9.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((5.28,14.4),(5.28,15.04),(5.92,15.04),(5.92,14.4),(5.28,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.02,8.8),(7.02,10.4),(6.1,10.4),(6.1,13.6),(7.02,13.6),(7.02,15.2),(8.3,15.2),(8.3,8.8),(7.02,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,14.74),(0.98,14.74),(0.98,13.6),(1.9,13.6),(1.9,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,10.4),(2.9,13.6),(3.82,13.6),(3.82,14.74),(4.18,14.74),(4.18,13.6),(5.1,13.6),(5.1,10.4),(2.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,14.4),(2.08,15.04),(2.72,15.04),(2.72,14.4),(2.08,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(10.08,17.28),(10.08,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(9.6,16.0),(9.6,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.8), u(9.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.61),(5.49,14.83),(5.71,14.83),(5.71,14.61),(5.49,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.25),(7.09,14.47),(7.31,14.47),(7.31,14.25),(7.09,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.75),(7.09,14.97),(7.31,14.97),(7.31,14.75),(7.09,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.45),(3.89,14.67),(4.11,14.67),(4.11,14.45),(3.89,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((8.3,8.8),(8.3,15.2),(8.98,15.2),(8.98,8.8),(8.3,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((8.3,0.96),(8.3,4.0),(8.98,4.0),(8.98,0.96),(8.3,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.63,2.15),(8.63,3.905),(8.67,3.905),(8.67,8.995),(8.63,8.995),(8.63,13.85),(8.97,13.85),(8.97,8.995),(8.93,8.995),(8.93,3.905),(8.97,3.905),(8.97,2.15),(8.63,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,2.18),(8.69,2.4),(8.91,2.4),(8.91,2.18),(8.69,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,2.68),(8.69,2.9),(8.91,2.9),(8.91,2.68),(8.69,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.18),(8.69,3.4),(8.91,3.4),(8.91,3.18),(8.69,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.68),(8.69,3.9),(8.91,3.9),(8.91,3.68),(8.69,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,9.0),(8.69,9.22),(8.91,9.22),(8.91,9.0),(8.69,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,9.5),(8.69,9.72),(8.91,9.72),(8.91,9.5),(8.69,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,10.0),(8.69,10.22),(8.91,10.22),(8.91,10.0),(8.69,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,10.5),(8.69,10.72),(8.91,10.72),(8.91,10.5),(8.69,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,11.0),(8.69,11.22),(8.91,11.22),(8.91,11.0),(8.69,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,11.5),(8.69,11.72),(8.91,11.72),(8.91,11.5),(8.69,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.0),(8.69,12.22),(8.91,12.22),(8.91,12.0),(8.69,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.5),(8.69,12.72),(8.91,12.72),(8.91,12.5),(8.69,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.0),(8.69,13.22),(8.91,13.22),(8.91,13.0),(8.69,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.5),(8.69,13.72),(8.91,13.72),(8.91,13.5),(8.69,13.5)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((6.86,8.57),(6.86,10.17),(0.46,10.17),(0.46,14.97),(1.14,14.97),(1.14,13.83),(3.66,13.83),(3.66,14.97),(4.34,14.97),(4.34,13.83),(6.86,13.83),(6.86,15.43),(9.14,15.43),(9.14,8.57),(6.86,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((5.12,0.57),(5.12,1.67),(6.08,1.67),(6.08,0.57),(5.12,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.92,0.57),(1.92,1.67),(2.88,1.67),(2.88,0.57),(1.92,0.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(10.0,16.4),(10.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(9.605,16.005),(9.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((6.86,0.73),(6.86,2.17),(0.46,2.17),(0.46,5.83),(7.54,5.83),(7.54,4.23),(9.14,4.23),(9.14,0.73),(6.86,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.12,14.17),(5.12,15.27),(6.08,15.27),(6.08,14.17),(5.12,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.92,14.17),(1.92,15.27),(2.88,15.27),(2.88,14.17),(1.92,14.17)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Poly2',
            ((7.7,0.74),(7.7,4.22),(7.86,4.22),(7.86,7.02),(7.18,7.02),(7.18,7.38),(7.86,7.38),(7.86,8.58),(7.7,8.58),(7.7,15.42),(8.3,15.42),(8.3,8.58),(8.14,8.58),(8.14,4.22),(8.3,4.22),(8.3,0.74),(7.7,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,10.4),(5.1,13.6),(6.1,13.6),(6.1,10.4),(5.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,10.4),(1.9,13.6),(2.9,13.6),(2.9,10.4),(1.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,5.6),(1.3,5.6),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.5),(0.63,3.77),(0.97,3.77),(0.97,3.315),(7.085,3.315),(7.085,12.685),(5.77,12.685),(5.77,12.23),(5.43,12.23),(5.43,12.685),(2.57,12.685),(2.57,12.23),(2.23,12.23),(2.23,13.495),(2.57,13.495),(2.57,12.915),(5.43,12.915),(5.43,13.495),(5.77,13.495),(5.77,12.915),(7.315,12.915),(7.315,7.315),(7.53,7.315),(7.53,7.085),(7.315,7.085),(7.315,3.085),(0.97,3.085),(0.97,2.5),(0.63,2.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.25,7.09),(7.25,7.31),(7.47,7.31),(7.47,7.09),(7.25,7.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.505),(0.69,2.725),(0.91,2.725),(0.91,2.505),(0.69,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.005),(0.69,3.225),(0.91,3.225),(0.91,3.005),(0.69,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.505),(0.69,3.725),(0.91,3.725),(0.91,3.505),(0.69,3.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.27),(5.49,12.49),(5.71,12.49),(5.71,12.27),(5.49,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.77),(5.49,12.99),(5.71,12.99),(5.71,12.77),(5.49,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.27),(5.49,13.49),(5.71,13.49),(5.71,13.27),(5.49,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.27),(2.29,12.49),(2.51,12.49),(2.51,12.27),(2.29,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.77),(2.29,12.99),(2.51,12.99),(2.51,12.77),(2.29,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,13.27),(2.29,13.49),(2.51,13.49),(2.51,13.27),(2.29,13.27)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((1.3,2.4),(1.3,5.6),(1.9,5.6),(1.9,2.4),(1.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.02,0.96),(7.02,2.4),(6.1,2.4),(6.1,5.6),(7.38,5.6),(7.38,4.0),(8.3,4.0),(8.3,0.96),(7.02,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,0.8),(2.08,1.44),(2.72,1.44),(2.72,0.8),(2.08,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.28,0.8),(5.28,1.44),(5.92,1.44),(5.92,0.8),(5.28,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,2.4),(2.9,5.6),(3.5,5.6),(3.5,2.4),(2.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,2.4),(4.5,5.6),(5.1,5.6),(5.1,2.4),(4.5,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(9.6,1.92),(9.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.8), u(9.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.01),(2.29,1.23),(2.51,1.23),(2.51,1.01),(2.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.11),(7.09,1.33),(7.31,1.33),(7.31,1.11),(7.09,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.61),(7.09,1.83),(7.31,1.83),(7.31,1.61),(7.09,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.01),(5.49,1.23),(5.71,1.23),(5.71,1.01),(5.49,1.01)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,5.82),(1.46,5.82),(1.46,7.82),(0.78,7.82),(0.78,8.18),(1.46,8.18),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,5.82),(1.9,5.82),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,4.0),(0.67,13.85),(0.93,13.85),(0.93,8.115),(1.13,8.115),(1.13,7.885),(0.93,7.885),(0.93,4.0),(0.67,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(4.0), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(4.0), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,5.6),(2.9,5.6),(2.9,2.4),(1.9,2.4)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,5.82),(3.06,5.82),(3.06,9.42),(2.38,9.42),(2.38,9.78),(3.06,9.78),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,5.82),(3.5,5.82),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,3.545),(2.27,12.0),(2.53,12.0),(2.53,9.715),(2.73,9.715),(2.73,9.485),(2.53,9.485),(2.53,3.545),(2.27,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(3.545), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(3.545), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.45,9.49),(2.45,9.71),(2.67,9.71),(2.67,9.49),(2.45,9.49)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,5.6),(4.5,5.6),(4.5,2.4),(3.5,2.4)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,5.82),(4.66,5.82),(4.66,7.82),(3.98,7.82),(3.98,8.18),(4.66,8.18),(4.66,10.18),(4.5,10.18),(4.5,13.82),(5.1,13.82),(5.1,10.18),(4.94,10.18),(4.94,5.82),(5.1,5.82),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,3.545),(3.87,12.455),(4.13,12.455),(4.13,8.115),(4.33,8.115),(4.33,7.885),(4.13,7.885),(4.13,3.545),(3.87,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(3.545), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(3.545), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((4.05,7.89),(4.05,8.11),(4.27,8.11),(4.27,7.89),(4.05,7.89)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((5.1,2.4),(5.1,5.6),(6.1,5.6),(6.1,2.4),(5.1,2.4)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.18),(6.1,5.82),(6.26,5.82),(6.26,6.22),(5.58,6.22),(5.58,6.58),(6.26,6.58),(6.26,10.18),(6.1,10.18),(6.1,13.82),(6.7,13.82),(6.7,10.18),(6.54,10.18),(6.54,5.82),(6.7,5.82),(6.7,2.18),(6.1,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.47,3.545),(5.47,12.0),(5.73,12.0),(5.73,6.515),(5.93,6.515),(5.93,6.285),(5.73,6.285),(5.73,3.545),(5.47,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(3.545), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(3.545), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.65,6.29),(5.65,6.51),(5.87,6.51),(5.87,6.29),(5.65,6.29)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['ao22_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.62,10.08),(0.62,14.74),(0.98,14.74),(0.98,13.28),(1.9,13.28),(1.9,10.08),(0.62,10.08)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.6,14.4),(3.6,15.04),(4.4,15.04),(4.4,14.4),(3.6,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,10.08),(2.9,13.28),(3.5,13.28),(3.5,10.08),(2.9,10.08)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,8.8),(5.42,10.08),(4.5,10.08),(4.5,13.28),(5.42,13.28),(5.42,15.2),(6.7,15.2),(6.7,8.8),(5.42,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(8.48,17.28),(8.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,14.61),(3.89,14.83),(4.11,14.83),(4.11,14.61),(3.89,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.25),(5.49,14.47),(5.71,14.47),(5.71,14.25),(5.49,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.75),(5.49,14.97),(5.71,14.97),(5.71,14.75),(5.49,14.75)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.38,4.0),(7.38,0.96),(6.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.38,15.2),(7.38,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,2.15),(7.03,3.905),(7.07,3.905),(7.07,8.995),(7.03,8.995),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.33,8.995),(7.33,3.905),(7.37,3.905),(7.37,2.15),(7.03,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.18),(7.09,2.4),(7.31,2.4),(7.31,2.18),(7.09,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.68),(7.09,2.9),(7.31,2.9),(7.31,2.68),(7.09,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.18),(7.09,3.4),(7.31,3.4),(7.31,3.18),(7.09,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.68),(7.09,3.9),(7.31,3.9),(7.31,3.68),(7.09,3.68)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((5.26,8.57),(5.26,9.85),(0.46,9.85),(0.46,14.97),(1.14,14.97),(1.14,13.51),(5.26,13.51),(5.26,15.43),(7.54,15.43),(7.54,8.57),(5.26,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((3.44,0.57),(3.44,1.67),(4.56,1.67),(4.56,0.57),(3.44,0.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.44,14.17),(3.44,15.27),(4.56,15.27),(4.56,14.17),(3.44,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.26,0.73),(5.26,2.17),(0.46,2.17),(0.46,4.23),(2.06,4.23),(2.06,5.21),(2.74,5.21),(2.74,4.23),(7.54,4.23),(7.54,0.73),(5.26,0.73)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(3.98,6.22),(3.98,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,10.08),(3.5,13.28),(4.5,13.28),(4.5,10.08),(3.5,10.08)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,4.0),(2.22,4.0),(2.22,4.98),(2.58,4.98),(2.58,4.0),(2.9,4.0),(2.9,2.4),(1.9,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.32),(3.89,10.54),(4.11,10.54),(4.11,10.32),(3.89,10.32)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.82),(3.89,11.04),(4.11,11.04),(4.11,10.82),(3.89,10.82)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.32),(3.89,11.54),(4.11,11.54),(4.11,11.32),(3.89,11.32)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.82),(3.89,12.04),(4.11,12.04),(4.11,11.82),(3.89,11.82)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.32),(3.89,12.54),(4.11,12.54),(4.11,12.32),(3.89,12.32)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.82),(3.89,13.04),(4.11,13.04),(4.11,12.82),(3.89,12.82)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.05,6.29),(4.05,6.51),(4.27,6.51),(4.27,6.29),(4.05,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,4.69),(2.29,4.91),(2.51,4.91),(2.51,4.69),(2.29,4.69)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.23,4.685),(2.23,4.915),(3.885,4.915),(3.885,10.315),(3.83,10.315),(3.83,13.045),(4.17,13.045),(4.17,10.315),(4.115,10.315),(4.115,6.515),(4.33,6.515),(4.33,6.285),(4.115,6.285),(4.115,4.685),(2.23,4.685)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((5.42,0.96),(5.42,2.4),(4.5,2.4),(4.5,4.0),(6.7,4.0),(6.7,0.96),(5.42,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,2.4),(2.9,4.0),(3.5,4.0),(3.5,2.4),(2.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.6,0.8),(3.6,1.44),(4.4,1.44),(4.4,0.8),(3.6,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,2.4),(1.3,4.0),(1.9,4.0),(1.9,2.4),(1.3,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,1.11),(5.49,1.33),(5.71,1.33),(5.71,1.11),(5.49,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.61),(5.49,1.83),(5.71,1.83),(5.71,1.61),(5.49,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.01),(3.89,1.23),(4.11,1.23),(4.11,1.01),(3.89,1.01)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((1.9,10.08),(1.9,13.28),(2.9,13.28),(2.9,10.08),(1.9,10.08)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.46,4.22),(1.46,6.22),(0.78,6.22),(0.78,6.58),(1.46,6.58),(1.46,9.86),(1.3,9.86),(1.3,13.5),(1.9,13.5),(1.9,9.86),(1.74,9.86),(1.74,4.22),(1.9,4.22),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,4.045),(0.67,13.85),(0.93,13.85),(0.93,6.515),(1.13,6.515),(1.13,6.285),(0.93,6.285),(0.93,4.045),(0.67,4.045)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(4.045), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(4.045), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,4.0),(4.5,4.0),(4.5,2.4),(3.5,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.585),(0.63,3.815),(0.97,3.815),(0.97,3.44),(3.83,3.44),(3.83,3.815),(4.17,3.815),(4.17,2.585),(3.83,2.585),(3.83,2.96),(0.97,2.96),(0.97,2.585),(0.63,2.585)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.59),(0.69,2.81),(0.91,2.81),(0.91,2.59),(0.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.59),(0.69,3.81),(0.91,3.81),(0.91,3.59),(0.69,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.59),(3.89,2.81),(4.11,2.81),(4.11,2.59),(3.89,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.09),(3.89,3.31),(4.11,3.31),(4.11,3.09),(3.89,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.59),(3.89,3.81),(4.11,3.81),(4.11,3.59),(3.89,3.59)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.06,4.22),(3.06,7.82),(2.38,7.82),(2.38,8.18),(3.06,8.18),(3.06,9.86),(2.9,9.86),(2.9,13.5),(3.5,13.5),(3.5,9.86),(3.34,9.86),(3.34,4.22),(3.5,4.22),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,5.6),(2.27,13.85),(2.53,13.85),(2.53,8.115),(2.73,8.115),(2.73,7.885),(2.53,7.885),(2.53,5.6),(2.27,5.6)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(5.6), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(5.6), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.45,7.89),(2.45,8.11),(2.67,8.11),(2.67,7.89),(2.45,7.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((4.82,7.82),(4.82,9.86),(4.5,9.86),(4.5,13.5),(5.1,13.5),(5.1,8.18),(5.62,8.18),(5.62,7.82),(4.82,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,4.22),(4.82,4.22),(4.82,4.98),(5.62,4.98),(5.62,4.62),(5.1,4.62),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.47,2.15),(5.47,4.685),(5.27,4.685),(5.27,4.915),(5.47,4.915),(5.47,7.885),(5.27,7.885),(5.27,8.115),(5.47,8.115),(5.47,13.85),(5.73,13.85),(5.73,2.15),(5.47,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.33,4.69),(5.33,4.91),(5.55,4.91),(5.55,4.69),(5.33,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.33,7.89),(5.33,8.11),(5.55,8.11),(5.55,7.89),(5.33,7.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['mx2_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(11.200000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            'cmd': Net.create(cell, 'cmd'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,14.74),(2.58,14.74),(2.58,13.6),(3.5,13.6),(3.5,10.4),(1.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,10.4),(4.5,13.6),(5.1,13.6),(5.1,10.4),(4.5,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.88,14.4),(6.88,15.04),(7.52,15.04),(7.52,14.4),(6.88,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,10.4),(6.1,13.6),(6.7,13.6),(6.7,10.4),(6.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((8.62,8.8),(8.62,10.4),(7.7,10.4),(7.7,13.6),(8.62,13.6),(8.62,15.2),(9.9,15.2),(9.9,8.8),(8.62,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(11.68,17.28),(11.68,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(11.2,16.0),(11.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,14.25),(8.69,14.47),(8.91,14.47),(8.91,14.25),(8.69,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,14.75),(8.69,14.97),(8.91,14.97),(8.91,14.75),(8.69,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.61),(7.09,14.83),(7.31,14.83),(7.31,14.61),(7.09,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.45),(2.29,14.67),(2.51,14.67),(2.51,14.45),(2.29,14.45)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((9.9,0.96),(9.9,4.0),(10.58,4.0),(10.58,0.96),(9.9,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,8.8),(9.9,15.2),(10.58,15.2),(10.58,8.8),(9.9,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.23,2.15),(10.23,3.905),(10.27,3.905),(10.27,8.995),(10.23,8.995),(10.23,13.85),(10.57,13.85),(10.57,8.995),(10.53,8.995),(10.53,3.905),(10.57,3.905),(10.57,2.15),(10.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(10.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(10.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((10.29,9.0),(10.29,9.22),(10.51,9.22),(10.51,9.0),(10.29,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,9.5),(10.29,9.72),(10.51,9.72),(10.51,9.5),(10.29,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.0),(10.29,10.22),(10.51,10.22),(10.51,10.0),(10.29,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.5),(10.29,10.72),(10.51,10.72),(10.51,10.5),(10.29,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.0),(10.29,11.22),(10.51,11.22),(10.51,11.0),(10.29,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.5),(10.29,11.72),(10.51,11.72),(10.51,11.5),(10.29,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.0),(10.29,12.22),(10.51,12.22),(10.51,12.0),(10.29,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.5),(10.29,12.72),(10.51,12.72),(10.51,12.5),(10.29,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.0),(10.29,13.22),(10.51,13.22),(10.51,13.0),(10.29,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.5),(10.29,13.72),(10.51,13.72),(10.51,13.5),(10.29,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.18),(10.29,2.4),(10.51,2.4),(10.51,2.18),(10.29,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.68),(10.29,2.9),(10.51,2.9),(10.51,2.68),(10.29,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.18),(10.29,3.4),(10.51,3.4),(10.51,3.18),(10.29,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.68),(10.29,3.9),(10.51,3.9),(10.51,3.68),(10.29,3.68)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((6.72,0.57),(6.72,1.67),(7.68,1.67),(7.68,0.57),(6.72,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((8.46,8.57),(8.46,10.17),(0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,14.97),(2.74,14.97),(2.74,13.83),(8.46,13.83),(8.46,15.43),(10.74,15.43),(10.74,8.57),(8.46,8.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(11.6,16.4),(11.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(11.205,16.005),(11.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,0.73),(0.46,3.61),(1.14,3.61),(1.14,2.63),(5.26,2.63),(5.26,5.21),(5.94,5.21),(5.94,4.23),(10.74,4.23),(10.74,0.73),(8.46,0.73),(8.46,2.33),(5.94,2.33),(5.94,0.73),(0.46,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((6.72,14.17),(6.72,15.27),(7.68,15.27),(7.68,14.17),(6.72,14.17)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Poly2',
            ((9.3,0.74),(9.3,4.22),(9.46,4.22),(9.46,7.82),(5.58,7.82),(5.58,8.18),(9.46,8.18),(9.46,8.58),(9.3,8.58),(9.3,15.42),(9.9,15.42),(9.9,8.58),(9.74,8.58),(9.74,4.22),(9.9,4.22),(9.9,0.74),(9.3,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,0.96),(5.1,2.4),(5.42,2.4),(5.42,4.98),(5.78,4.98),(5.78,4.0),(6.1,4.0),(6.1,2.56),(5.78,2.56),(5.78,0.96),(5.1,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,10.4),(5.1,13.6),(6.1,13.6),(6.1,10.4),(5.1,10.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,4.69),(5.49,4.91),(5.71,4.91),(5.71,4.69),(5.49,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.65,7.89),(5.65,8.11),(5.87,8.11),(5.87,7.89),(5.65,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.64),(5.49,10.86),(5.71,10.86),(5.71,10.64),(5.49,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.14),(5.49,11.36),(5.71,11.36),(5.71,11.14),(5.49,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.64),(5.49,11.86),(5.71,11.86),(5.71,11.64),(5.49,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.14),(5.49,12.36),(5.71,12.36),(5.71,12.14),(5.49,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.64),(5.49,12.86),(5.71,12.86),(5.71,12.64),(5.49,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.14),(5.49,13.36),(5.71,13.36),(5.71,13.14),(5.49,13.14)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,4.685),(5.43,4.915),(5.485,4.915),(5.485,10.635),(5.43,10.635),(5.43,13.85),(5.77,13.85),(5.77,10.635),(5.715,10.635),(5.715,8.115),(5.93,8.115),(5.93,7.885),(5.715,7.885),(5.715,4.915),(5.77,4.915),(5.77,4.685),(5.43,4.685)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((6.1,2.56),(6.1,4.0),(6.7,4.0),(6.7,2.56),(6.1,2.56)),
        )
        createRL(
            tech, net, 'COMP',
            ((8.62,0.96),(8.62,2.56),(7.7,2.56),(7.7,4.0),(9.9,4.0),(9.9,0.96),(8.62,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,0.96),(1.3,2.4),(3.5,2.4),(3.5,0.96),(1.3,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.88,0.8),(6.88,1.44),(7.52,1.44),(7.52,0.8),(6.88,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,0.96),(4.5,2.4),(5.1,2.4),(5.1,0.96),(4.5,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(11.2,1.92),(11.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,1.11),(8.69,1.33),(8.91,1.33),(8.91,1.11),(8.69,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,1.61),(8.69,1.83),(8.91,1.83),(8.91,1.61),(8.69,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.01),(7.09,1.23),(7.31,1.23),(7.31,1.01),(7.09,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.11),(2.29,1.33),(2.51,1.33),(2.51,1.11),(2.29,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.61),(2.29,1.83),(2.51,1.83),(2.51,1.61),(2.29,1.61)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'COMP',
            ((6.7,10.4),(6.7,13.6),(7.7,13.6),(7.7,10.4),(6.7,10.4)),
        )
        net = nets['_net5']
        createRL(
            tech, net, 'Poly2',
            ((6.42,9.42),(6.42,10.18),(6.1,10.18),(6.1,13.82),(6.7,13.82),(6.7,9.78),(6.82,9.78),(6.82,9.42),(6.42,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,3.02),(4.46,3.02),(4.46,3.38),(4.82,3.38),(4.82,2.62),(5.1,2.62),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,0.96),(0.62,3.38),(0.98,3.38),(0.98,2.4),(1.3,2.4),(1.3,0.96),(0.62,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,3.085),(0.63,3.315),(0.685,3.315),(0.685,10.635),(0.63,10.635),(0.63,13.365),(0.97,13.365),(0.97,10.635),(0.915,10.635),(0.915,3.315),(6.685,3.315),(6.685,9.485),(6.47,9.485),(6.47,9.715),(6.915,9.715),(6.915,3.085),(0.63,3.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.53,3.09),(4.53,3.31),(4.75,3.31),(4.75,3.09),(4.53,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.53,9.49),(6.53,9.71),(6.75,9.71),(6.75,9.49),(6.53,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.64),(0.69,10.86),(0.91,10.86),(0.91,10.64),(0.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.14),(0.69,11.36),(0.91,11.36),(0.91,11.14),(0.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.64),(0.69,11.86),(0.91,11.86),(0.91,11.64),(0.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.14),(0.69,12.36),(0.91,12.36),(0.91,12.14),(0.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.64),(0.69,12.86),(0.91,12.86),(0.91,12.64),(0.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.14),(0.69,13.36),(0.91,13.36),(0.91,13.14),(0.69,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((3.5,0.96),(3.5,2.4),(4.5,2.4),(4.5,0.96),(3.5,0.96)),
        )
        net = nets['cmd']
        createRL(
            tech, net, 'Poly2',
            ((1.3,0.74),(1.3,2.62),(1.46,2.62),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,6.58),(4.66,6.58),(4.66,10.18),(4.5,10.18),(4.5,13.82),(5.1,13.82),(5.1,10.18),(4.94,10.18),(4.94,6.58),(6.38,6.58),(6.38,4.22),(6.7,4.22),(6.7,2.34),(6.1,2.34),(6.1,6.22),(1.74,6.22),(1.74,2.62),(1.9,2.62),(1.9,0.74),(1.3,0.74)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,3.545),(3.87,6.285),(3.83,6.285),(3.83,6.515),(3.87,6.515),(3.87,13.85),(4.13,13.85),(4.13,6.515),(4.17,6.515),(4.17,6.285),(4.13,6.285),(4.13,3.545),(3.87,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(3.545), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(3.545), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,6.29),(3.89,6.51),(4.11,6.51),(4.11,6.29),(3.89,6.29)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'COMP',
            ((3.5,10.4),(3.5,13.6),(4.5,13.6),(4.5,10.4),(3.5,10.4)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((6.7,2.56),(6.7,4.0),(7.7,4.0),(7.7,2.56),(6.7,2.56)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((2.9,0.74),(2.9,4.62),(2.38,4.62),(2.38,4.98),(3.18,4.98),(3.18,2.62),(3.5,2.62),(3.5,0.74),(2.9,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.38,9.42),(2.38,9.78),(2.9,9.78),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.18,10.18),(3.18,9.42),(2.38,9.42)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.45,9.49),(2.45,9.71),(2.67,9.71),(2.67,9.49),(2.45,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.45,4.69),(2.45,4.91),(2.67,4.91),(2.67,4.69),(2.45,4.69)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,3.545),(2.27,13.85),(2.53,13.85),(2.53,9.715),(2.73,9.715),(2.73,9.485),(2.53,9.485),(2.53,4.915),(2.73,4.915),(2.73,4.685),(2.53,4.685),(2.53,3.545),(2.27,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(3.545), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(3.545), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((7.7,2.34),(7.7,4.22),(8.02,4.22),(8.02,4.98),(8.82,4.98),(8.82,4.62),(8.3,4.62),(8.3,2.34),(7.7,2.34)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.66,9.42),(7.66,9.78),(7.7,9.78),(7.7,13.82),(8.3,13.82),(8.3,10.18),(8.02,10.18),(8.02,9.42),(7.66,9.42)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.67,2.15),(8.67,4.685),(8.47,4.685),(8.47,4.915),(8.67,4.915),(8.67,9.485),(7.67,9.485),(7.67,9.715),(8.67,9.715),(8.67,13.85),(8.93,13.85),(8.93,2.15),(8.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.53,4.69),(8.53,4.91),(8.75,4.91),(8.75,4.69),(8.53,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.73,9.49),(7.73,9.71),(7.95,9.71),(7.95,9.49),(7.73,9.49)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['cmd'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['mx3_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(17.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net10': Net.create(cell, '_net10'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_net6': Net.create(cell, '_net6'),
            '_net7': Net.create(cell, '_net7'),
            '_net8': Net.create(cell, '_net8'),
            '_net9': Net.create(cell, '_net9'),
            'cmd0': Net.create(cell, 'cmd0'),
            'cmd1': Net.create(cell, 'cmd1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net5']
        createRL(
            tech, net, 'COMP',
            ((13.1,1.12),(13.1,3.04),(13.78,3.04),(13.78,1.12),(13.1,1.12)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,10.4),(5.42,12.0),(5.1,12.0),(5.1,15.2),(5.78,15.2),(5.78,13.6),(6.1,13.6),(6.1,10.4),(5.42,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((13.1,12.0),(13.1,15.2),(13.78,15.2),(13.78,12.0),(13.1,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,1.76),(5.1,3.68),(5.42,3.68),(5.42,4.98),(5.78,4.98),(5.78,4.48),(6.1,4.48),(6.1,2.56),(5.78,2.56),(5.78,1.76),(5.1,1.76)),
        )
        createRL(
            tech, net, 'Poly2',
            ((15.7,2.18),(15.7,5.82),(15.86,5.82),(15.86,6.22),(15.18,6.22),(15.18,6.58),(15.86,6.58),(15.86,8.58),(15.7,8.58),(15.7,15.42),(16.3,15.42),(16.3,8.58),(16.14,8.58),(16.14,5.82),(16.3,5.82),(16.3,2.18),(15.7,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.6),(5.49,10.82),(5.71,10.82),(5.71,10.6),(5.49,10.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.1),(5.49,11.32),(5.71,11.32),(5.71,11.1),(5.49,11.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.6),(5.49,11.82),(5.71,11.82),(5.71,11.6),(5.49,11.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.1),(5.49,12.32),(5.71,12.32),(5.71,12.1),(5.49,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,4.69),(5.49,4.91),(5.71,4.91),(5.71,4.69),(5.49,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.25,6.29),(15.25,6.51),(15.47,6.51),(15.47,6.29),(15.25,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,2.2),(13.49,2.42),(13.71,2.42),(13.71,2.2),(13.49,2.2)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,2.7),(13.49,2.92),(13.71,2.92),(13.71,2.7),(13.49,2.7)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,12.1),(13.49,12.32),(13.71,12.32),(13.71,12.1),(13.49,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,12.6),(13.49,12.82),(13.71,12.82),(13.71,12.6),(13.49,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.1),(13.49,13.32),(13.71,13.32),(13.71,13.1),(13.49,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.6),(13.49,13.82),(13.71,13.82),(13.71,13.6),(13.49,13.6)),
        )
        createRL(
            tech, net, 'Metal1',
            ((13.43,2.15),(13.43,2.925),(13.54,2.925),(13.54,3.315),(15.085,3.315),(15.085,11.085),(7.315,11.085),(7.315,4.685),(5.43,4.685),(5.43,4.915),(7.085,4.915),(7.085,11.085),(5.77,11.085),(5.77,10.595),(5.43,10.595),(5.43,12.455),(5.77,12.455),(5.77,11.315),(13.485,11.315),(13.485,12.095),(13.43,12.095),(13.43,13.85),(13.77,13.85),(13.77,12.095),(13.715,12.095),(13.715,11.315),(15.315,11.315),(15.315,6.515),(15.53,6.515),(15.53,6.285),(15.315,6.285),(15.315,3.085),(13.77,3.085),(13.77,2.15),(13.43,2.15)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((2.9,12.0),(2.9,15.2),(3.5,15.2),(3.5,12.0),(2.9,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.3,12.0),(9.3,15.2),(11.5,15.2),(11.5,12.0),(9.3,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,10.4),(7.7,13.6),(8.3,13.6),(8.3,10.4),(7.7,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((14.1,8.8),(14.1,11.04),(15.02,11.04),(15.02,15.2),(16.3,15.2),(16.3,8.8),(14.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,12.0),(12.5,15.2),(13.1,15.2),(13.1,12.0),(12.5,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,10.4),(6.1,13.6),(6.7,13.6),(6.7,10.4),(6.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.88,14.4),(6.88,15.04),(7.52,15.04),(7.52,14.4),(6.88,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,8.8),(0.62,14.74),(0.98,14.74),(0.98,11.04),(1.9,11.04),(1.9,8.8),(0.62,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,12.0),(4.5,15.2),(5.1,15.2),(5.1,12.0),(4.5,12.0)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(18.08,17.28),(18.08,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((15.03,11.545),(15.03,14.08),(10.57,14.08),(10.57,12.235),(10.23,12.235),(10.23,14.08),(0.0,14.08),(0.0,16.0),(17.6,16.0),(17.6,14.08),(15.37,14.08),(15.37,11.545),(15.03,11.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(17.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(17.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((15.09,11.73),(15.09,11.95),(15.31,11.95),(15.31,11.73),(15.09,11.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.23),(15.09,12.45),(15.31,12.45),(15.31,12.23),(15.09,12.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.73),(15.09,12.95),(15.31,12.95),(15.31,12.73),(15.09,12.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.23),(15.09,13.45),(15.31,13.45),(15.31,13.23),(15.09,13.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.73),(15.09,13.95),(15.31,13.95),(15.31,13.73),(15.09,13.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,14.23),(15.09,14.45),(15.31,14.45),(15.31,14.23),(15.09,14.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,14.73),(15.09,14.95),(15.31,14.95),(15.31,14.73),(15.09,14.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.61),(7.09,14.83),(7.31,14.83),(7.31,14.61),(7.09,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.24),(10.29,12.46),(10.51,12.46),(10.51,12.24),(10.29,12.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.74),(10.29,12.96),(10.51,12.96),(10.51,12.74),(10.29,12.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.24),(10.29,13.46),(10.51,13.46),(10.51,13.24),(10.29,13.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.74),(10.29,13.96),(10.51,13.96),(10.51,13.74),(10.29,13.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.24),(10.29,14.46),(10.51,14.46),(10.51,14.24),(10.29,14.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.74),(10.29,14.96),(10.51,14.96),(10.51,14.74),(10.29,14.74)),
        )
        net = nets['_net6']
        createRL(
            tech, net, 'COMP',
            ((6.7,10.4),(6.7,13.6),(7.7,13.6),(7.7,10.4),(6.7,10.4)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((6.72,0.57),(6.72,1.67),(7.68,1.67),(7.68,0.57),(6.72,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,8.57),(0.46,14.97),(1.14,14.97),(1.14,13.6),(2.06,13.6),(2.06,15.43),(5.94,15.43),(5.94,13.83),(8.46,13.83),(8.46,15.43),(13.94,15.43),(13.94,13.6),(14.86,13.6),(14.86,15.43),(17.14,15.43),(17.14,8.57),(13.26,8.57),(13.26,8.8),(2.74,8.8),(2.74,8.57),(0.46,8.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(18.0,16.4),(18.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(17.605,16.005),(17.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((8.46,0.89),(8.46,2.33),(5.94,2.33),(5.94,1.53),(2.06,1.53),(2.06,2.4),(1.14,2.4),(1.14,1.03),(0.46,1.03),(0.46,6.15),(2.74,6.15),(2.74,5.6),(13.26,5.6),(13.26,5.83),(17.14,5.83),(17.14,2.17),(15.54,2.17),(15.54,1.03),(14.86,1.03),(14.86,2.4),(13.94,2.4),(13.94,0.89),(8.46,0.89)),
        )
        createRL(
            tech, net, 'Nplus',
            ((6.72,14.17),(6.72,15.27),(7.68,15.27),(7.68,14.17),(6.72,14.17)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Poly2',
            ((4.5,1.54),(4.5,4.62),(4.46,4.62),(4.46,4.98),(4.82,4.98),(4.82,3.9),(5.1,3.9),(5.1,1.54),(4.5,1.54)),
        )
        createRL(
            tech, net, 'Poly2',
            ((5.82,9.42),(5.82,9.78),(6.1,9.78),(6.1,13.82),(6.7,13.82),(6.7,10.18),(6.38,10.18),(6.38,9.42),(5.82,9.42)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,8.8),(1.9,11.04),(2.58,11.04),(2.58,8.8),(1.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,4.64),(1.9,5.92),(2.58,5.92),(2.58,4.64),(1.9,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.53,4.69),(4.53,4.91),(4.75,4.91),(4.75,4.69),(4.53,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,4.92),(2.29,5.14),(2.51,5.14),(2.51,4.92),(2.29,4.92)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,5.42),(2.29,5.64),(2.51,5.64),(2.51,5.42),(2.29,5.42)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,9.0),(2.29,9.22),(2.51,9.22),(2.51,9.0),(2.29,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,9.5),(2.29,9.72),(2.51,9.72),(2.51,9.5),(2.29,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,10.0),(2.29,10.22),(2.51,10.22),(2.51,10.0),(2.29,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,10.5),(2.29,10.72),(2.51,10.72),(2.51,10.5),(2.29,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.89,9.49),(5.89,9.71),(6.11,9.71),(6.11,9.49),(5.89,9.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.34,4.685),(2.34,4.915),(2.23,4.915),(2.23,5.645),(2.285,5.645),(2.285,8.995),(2.23,8.995),(2.23,10.855),(2.57,10.855),(2.57,9.715),(6.17,9.715),(6.17,9.485),(2.57,9.485),(2.57,8.995),(2.515,8.995),(2.515,5.645),(2.57,5.645),(2.57,4.915),(4.81,4.915),(4.81,4.685),(2.34,4.685)),
        )
        net = nets['_net9']
        createRL(
            tech, net, 'COMP',
            ((3.5,1.76),(3.5,3.68),(4.5,3.68),(4.5,1.76),(3.5,1.76)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((2.9,1.76),(2.9,3.68),(3.5,3.68),(3.5,1.76),(2.9,1.76)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.02,1.26),(15.02,4.64),(14.1,4.64),(14.1,5.6),(16.3,5.6),(16.3,2.4),(15.38,2.4),(15.38,1.26),(15.02,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,2.56),(7.7,4.48),(8.3,4.48),(8.3,2.56),(7.7,2.56)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,1.26),(0.62,5.92),(1.9,5.92),(1.9,4.64),(0.98,4.64),(0.98,1.26),(0.62,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.88,0.8),(6.88,1.44),(7.52,1.44),(7.52,0.8),(6.88,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,1.76),(4.5,3.68),(5.1,3.68),(5.1,1.76),(4.5,1.76)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,1.12),(12.5,3.04),(13.1,3.04),(13.1,1.12),(12.5,1.12)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,2.56),(6.1,4.48),(6.7,4.48),(6.7,2.56),(6.1,2.56)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.3,1.12),(9.3,3.04),(11.5,3.04),(11.5,1.12),(9.3,1.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(17.6,1.92),(17.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(17.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(17.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((10.29,1.195),(10.29,1.415),(10.51,1.415),(10.51,1.195),(10.29,1.195)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.695),(10.29,1.915),(10.51,1.915),(10.51,1.695),(10.29,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,1.33),(15.09,1.55),(15.31,1.55),(15.31,1.33),(15.09,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.01),(7.09,1.23),(7.31,1.23),(7.31,1.01),(7.09,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.33),(0.69,1.55),(0.91,1.55),(0.91,1.33),(0.69,1.33)),
        )
        net = nets['_net7']
        createRL(
            tech, net, 'COMP',
            ((11.5,1.12),(11.5,3.04),(12.5,3.04),(12.5,1.12),(11.5,1.12)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'Poly2',
            ((10.9,0.9),(10.9,3.26),(11.06,3.26),(11.06,4.62),(9.62,4.62),(9.62,11.78),(9.3,11.78),(9.3,15.42),(9.9,15.42),(9.9,4.98),(11.54,4.98),(11.54,4.62),(11.34,4.62),(11.34,3.26),(11.5,3.26),(11.5,0.9),(10.9,0.9)),
        )
        createRL(
            tech, net, 'COMP',
            ((13.42,8.8),(13.42,11.04),(14.1,11.04),(14.1,8.8),(13.42,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((13.42,4.64),(13.42,5.6),(14.1,5.6),(14.1,4.64),(13.42,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((11.25,4.69),(11.25,4.91),(11.47,4.91),(11.47,4.69),(11.25,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,9.0),(13.49,9.22),(13.71,9.22),(13.71,9.0),(13.49,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,9.5),(13.49,9.72),(13.71,9.72),(13.71,9.5),(13.49,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,10.0),(13.49,10.22),(13.71,10.22),(13.71,10.0),(13.49,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,10.5),(13.49,10.72),(13.71,10.72),(13.71,10.5),(13.49,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,4.76),(13.49,4.98),(13.71,4.98),(13.71,4.76),(13.49,4.76)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,5.26),(13.49,5.48),(13.71,5.48),(13.71,5.26),(13.49,5.26)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.19,4.685),(11.19,4.915),(13.43,4.915),(13.43,5.485),(13.485,5.485),(13.485,8.995),(13.43,8.995),(13.43,10.855),(13.77,10.855),(13.77,8.995),(13.715,8.995),(13.715,5.485),(13.77,5.485),(13.77,4.755),(13.66,4.755),(13.66,4.685),(11.19,4.685)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((2.22,12.0),(2.22,15.2),(2.9,15.2),(2.9,12.0),(2.22,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((8.3,10.4),(8.3,13.6),(8.62,13.6),(8.62,15.2),(9.3,15.2),(9.3,12.0),(8.98,12.0),(8.98,10.4),(8.3,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.63,11.545),(8.63,12.685),(2.57,12.685),(2.57,12.095),(2.23,12.095),(2.23,13.85),(2.57,13.85),(2.57,12.915),(8.63,12.915),(8.63,13.85),(8.97,13.85),(8.97,11.545),(8.63,11.545)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.1),(2.29,12.32),(2.51,12.32),(2.51,12.1),(2.29,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.6),(2.29,12.82),(2.51,12.82),(2.51,12.6),(2.29,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,13.1),(2.29,13.32),(2.51,13.32),(2.51,13.1),(2.29,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,13.6),(2.29,13.82),(2.51,13.82),(2.51,13.6),(2.29,13.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,11.59),(8.69,11.81),(8.91,11.81),(8.91,11.59),(8.69,11.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.09),(8.69,12.31),(8.91,12.31),(8.91,12.09),(8.69,12.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.59),(8.69,12.81),(8.91,12.81),(8.91,12.59),(8.69,12.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.09),(8.69,13.31),(8.91,13.31),(8.91,13.09),(8.69,13.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.59),(8.69,13.81),(8.91,13.81),(8.91,13.59),(8.69,13.59)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((16.3,8.8),(16.3,15.2),(16.98,15.2),(16.98,8.8),(16.3,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((16.3,2.4),(16.3,5.6),(16.98,5.6),(16.98,2.4),(16.3,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((16.67,2.15),(16.67,2.635),(16.63,2.635),(16.63,5.365),(16.67,5.365),(16.67,8.995),(16.63,8.995),(16.63,13.85),(16.97,13.85),(16.97,8.995),(16.93,8.995),(16.93,5.365),(16.97,5.365),(16.97,2.635),(16.93,2.635),(16.93,2.15),(16.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(16.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(16.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((16.69,2.64),(16.69,2.86),(16.91,2.86),(16.91,2.64),(16.69,2.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.14),(16.69,3.36),(16.91,3.36),(16.91,3.14),(16.69,3.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.64),(16.69,3.86),(16.91,3.86),(16.91,3.64),(16.69,3.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,4.14),(16.69,4.36),(16.91,4.36),(16.91,4.14),(16.69,4.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,4.64),(16.69,4.86),(16.91,4.86),(16.91,4.64),(16.69,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,5.14),(16.69,5.36),(16.91,5.36),(16.91,5.14),(16.69,5.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,9.0),(16.69,9.22),(16.91,9.22),(16.91,9.0),(16.69,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,9.5),(16.69,9.72),(16.91,9.72),(16.91,9.5),(16.69,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,10.0),(16.69,10.22),(16.91,10.22),(16.91,10.0),(16.69,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,10.5),(16.69,10.72),(16.91,10.72),(16.91,10.5),(16.69,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,11.0),(16.69,11.22),(16.91,11.22),(16.91,11.0),(16.69,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,11.5),(16.69,11.72),(16.91,11.72),(16.91,11.5),(16.69,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.0),(16.69,12.22),(16.91,12.22),(16.91,12.0),(16.69,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.5),(16.69,12.72),(16.91,12.72),(16.91,12.5),(16.69,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,13.0),(16.69,13.22),(16.91,13.22),(16.91,13.0),(16.69,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,13.5),(16.69,13.72),(16.91,13.72),(16.91,13.5),(16.69,13.5)),
        )
        net = nets['cmd0']
        createRL(
            tech, net, 'Poly2',
            ((9.3,0.9),(9.3,3.26),(9.62,3.26),(9.62,3.78),(10.42,3.78),(10.42,3.42),(9.9,3.42),(9.9,0.9),(9.3,0.9)),
        )
        createRL(
            tech, net, 'Poly2',
            ((14.1,4.42),(14.1,5.82),(14.26,5.82),(14.26,7.82),(10.38,7.82),(10.38,8.18),(11.06,8.18),(11.06,11.78),(10.9,11.78),(10.9,15.42),(11.5,15.42),(11.5,11.78),(11.34,11.78),(11.34,8.18),(14.26,8.18),(14.26,8.58),(14.1,8.58),(14.1,11.26),(14.7,11.26),(14.7,8.58),(14.54,8.58),(14.54,5.82),(14.7,5.82),(14.7,4.42),(14.1,4.42)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.13,3.49),(10.13,3.71),(10.35,3.71),(10.35,3.49),(10.13,3.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.45,7.89),(10.45,8.11),(10.67,8.11),(10.67,7.89),(10.45,7.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.27,2.15),(10.27,3.485),(10.07,3.485),(10.07,3.715),(10.27,3.715),(10.27,10.855),(10.53,10.855),(10.53,8.115),(10.73,8.115),(10.73,7.885),(10.53,7.885),(10.53,2.15),(10.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(10.4), u(0.26), u(2.15), u(10.855),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(10.4), u(0.26), u(2.15), u(10.855),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((8.62,1.12),(8.62,2.56),(8.3,2.56),(8.3,4.48),(8.98,4.48),(8.98,3.04),(9.3,3.04),(9.3,1.12),(8.62,1.12)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.22,1.76),(2.22,3.68),(2.9,3.68),(2.9,1.76),(2.22,1.76)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,2.17),(8.69,2.39),(8.91,2.39),(8.91,2.17),(8.69,2.17)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,2.67),(8.69,2.89),(8.91,2.89),(8.91,2.67),(8.69,2.67)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.17),(8.69,3.39),(8.91,3.39),(8.91,3.17),(8.69,3.17)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.67),(8.69,3.89),(8.91,3.89),(8.91,3.67),(8.69,3.67)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,4.17),(8.69,4.39),(8.91,4.39),(8.91,4.17),(8.69,4.17)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,2.27),(2.29,2.49),(2.51,2.49),(2.51,2.27),(2.29,2.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,2.77),(2.29,2.99),(2.51,2.99),(2.51,2.77),(2.29,2.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.27),(2.29,3.49),(2.51,3.49),(2.51,3.27),(2.29,3.27)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.23,2.15),(2.23,3.495),(2.57,3.495),(2.57,3.315),(8.63,3.315),(8.63,4.395),(8.97,4.395),(8.97,2.15),(8.63,2.15),(8.63,3.085),(2.57,3.085),(2.57,2.15),(2.23,2.15)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((11.5,12.0),(11.5,15.2),(12.5,15.2),(12.5,12.0),(11.5,12.0)),
        )
        net = nets['_net10']
        createRL(
            tech, net, 'COMP',
            ((6.7,2.56),(6.7,4.48),(7.7,4.48),(7.7,2.56),(6.7,2.56)),
        )
        net = nets['cmd1']
        createRL(
            tech, net, 'Poly2',
            ((1.3,4.42),(1.3,6.14),(1.46,6.14),(1.46,7.82),(0.78,7.82),(0.78,8.18),(1.46,8.18),(1.46,8.58),(1.3,8.58),(1.3,11.26),(1.9,11.26),(1.9,8.58),(1.74,8.58),(1.74,6.14),(1.9,6.14),(1.9,4.42),(1.3,4.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.34),(6.1,4.7),(6.26,4.7),(6.26,6.26),(4.66,6.26),(4.66,11.02),(4.46,11.02),(4.46,11.38),(4.66,11.38),(4.66,11.78),(4.5,11.78),(4.5,15.42),(5.1,15.42),(5.1,11.78),(4.94,11.78),(4.94,6.54),(6.54,6.54),(6.54,4.7),(6.7,4.7),(6.7,2.34),(6.1,2.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,2.15),(0.67,13.85),(0.93,13.85),(0.93,11.315),(4.81,11.315),(4.81,11.085),(0.93,11.085),(0.93,8.115),(1.13,8.115),(1.13,7.885),(0.93,7.885),(0.93,2.15),(0.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.53,11.09),(4.53,11.31),(4.75,11.31),(4.75,11.09),(4.53,11.09)),
        )
        net = nets['_net8']
        createRL(
            tech, net, 'COMP',
            ((3.5,12.0),(3.5,15.2),(4.5,15.2),(4.5,12.0),(3.5,12.0)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((11.98,9.42),(11.98,9.78),(12.5,9.78),(12.5,15.42),(13.1,15.42),(13.1,11.78),(12.78,11.78),(12.78,9.42),(11.98,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((12.5,0.9),(12.5,6.38),(11.98,6.38),(11.98,6.74),(12.78,6.74),(12.78,3.26),(13.1,3.26),(13.1,0.9),(12.5,0.9)),
        )
        createRL(
            tech, net, 'Contact',
            ((12.05,6.45),(12.05,6.67),(12.27,6.67),(12.27,6.45),(12.05,6.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((12.05,9.49),(12.05,9.71),(12.27,9.71),(12.27,9.49),(12.05,9.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.87,5.145),(11.87,10.855),(12.13,10.855),(12.13,9.715),(12.33,9.715),(12.33,9.485),(12.13,9.485),(12.13,6.675),(12.33,6.675),(12.33,6.445),(12.13,6.445),(12.13,5.145),(11.87,5.145)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(12.0), u(0.26), u(5.145), u(10.855),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(12.0), u(0.26), u(5.145), u(10.855),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((7.7,2.34),(7.7,4.7),(7.86,4.7),(7.86,10.18),(7.7,10.18),(7.7,13.82),(8.3,13.82),(8.3,10.18),(8.14,10.18),(8.14,8.18),(8.82,8.18),(8.82,7.82),(8.14,7.82),(8.14,4.7),(8.3,4.7),(8.3,2.34),(7.7,2.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.67,4.625),(8.67,7.885),(8.47,7.885),(8.47,8.115),(8.67,8.115),(8.67,10.855),(8.93,10.855),(8.93,4.625),(8.67,4.625)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(4.625), u(10.855),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(4.625), u(10.855),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.53,7.89),(8.53,8.11),(8.75,8.11),(8.75,7.89),(8.53,7.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((2.9,1.54),(2.9,3.9),(3.06,3.9),(3.06,11.78),(2.9,11.78),(2.9,15.42),(3.5,15.42),(3.5,11.78),(3.34,11.78),(3.34,8.18),(4.02,8.18),(4.02,7.82),(3.34,7.82),(3.34,3.9),(3.5,3.9),(3.5,1.54),(2.9,1.54)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.73,7.89),(3.73,8.11),(3.95,8.11),(3.95,7.89),(3.73,7.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,5.145),(3.87,7.885),(3.67,7.885),(3.67,8.115),(3.87,8.115),(3.87,9.255),(4.13,9.255),(4.13,5.145),(3.87,5.145)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(5.145), u(9.255),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(5.145), u(9.255),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['cmd0'].setDirection(Net.Direction.IN)
        nets['cmd1'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nsnrlatch_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'nq': Net.create(cell, 'nq'),
            'nrst': Net.create(cell, 'nrst'),
            'nset': Net.create(cell, 'nset'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,5.6),(2.9,5.6),(2.9,2.4),(1.9,2.4)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((1.3,2.4),(1.3,5.6),(1.9,5.6),(1.9,2.4),(1.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.2,0.8),(5.2,1.44),(6.0,1.44),(6.0,0.8),(5.2,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,2.4),(6.1,5.6),(6.7,5.6),(6.7,2.4),(6.1,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.0,0.8),(2.0,1.44),(2.8,1.44),(2.8,0.8),(2.0,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,2.4),(2.9,5.6),(5.1,5.6),(5.1,2.4),(2.9,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.885,1.92),(3.885,2.635),(3.83,2.635),(3.83,5.365),(4.17,5.365),(4.17,2.635),(4.115,2.635),(4.115,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,2.64),(3.89,2.86),(4.11,2.86),(4.11,2.64),(3.89,2.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.14),(3.89,3.36),(4.11,3.36),(4.11,3.14),(3.89,3.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.64),(3.89,3.86),(4.11,3.86),(4.11,3.64),(3.89,3.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,4.14),(3.89,4.36),(4.11,4.36),(4.11,4.14),(3.89,4.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,4.64),(3.89,4.86),(4.11,4.86),(4.11,4.64),(3.89,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,5.14),(3.89,5.36),(4.11,5.36),(4.11,5.14),(3.89,5.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.01),(2.29,1.23),(2.51,1.23),(2.51,1.01),(2.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.01),(5.49,1.23),(5.71,1.23),(5.71,1.01),(5.49,1.01)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((1.84,14.17),(1.84,15.27),(2.96,15.27),(2.96,14.17),(1.84,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.04,14.17),(5.04,15.27),(6.16,15.27),(6.16,14.17),(5.04,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,2.17),(0.46,5.83),(7.54,5.83),(7.54,2.17),(0.46,2.17)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,10.17),(0.46,14.97),(1.14,14.97),(1.14,13.83),(6.86,13.83),(6.86,14.97),(7.54,14.97),(7.54,10.17),(0.46,10.17)),
        )
        createRL(
            tech, net, 'Pplus',
            ((5.04,0.57),(5.04,1.67),(6.16,1.67),(6.16,0.57),(5.04,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.84,0.57),(1.84,1.67),(2.96,1.67),(2.96,0.57),(1.84,0.57)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,5.82),(3.06,5.82),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,7.38),(3.54,7.38),(3.54,7.02),(3.34,7.02),(3.34,5.82),(3.5,5.82),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,10.4),(5.1,13.6),(6.1,13.6),(6.1,10.4),(5.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.7,2.4),(6.7,5.6),(7.38,5.6),(7.38,2.4),(6.7,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.47,2.15),(5.47,7.085),(3.19,7.085),(3.19,7.315),(5.47,7.315),(5.47,10.635),(5.43,10.635),(5.43,13.365),(5.47,13.365),(5.47,13.85),(5.73,13.85),(5.73,13.365),(5.77,13.365),(5.77,10.635),(5.73,10.635),(5.73,3.44),(7.03,3.44),(7.03,5.365),(7.37,5.365),(7.37,2.15),(7.03,2.15),(7.03,2.96),(5.73,2.96),(5.73,2.15),(5.47,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.25,7.09),(3.25,7.31),(3.47,7.31),(3.47,7.09),(3.25,7.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.64),(7.09,2.86),(7.31,2.86),(7.31,2.64),(7.09,2.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.14),(7.09,3.36),(7.31,3.36),(7.31,3.14),(7.09,3.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.64),(7.09,3.86),(7.31,3.86),(7.31,3.64),(7.09,3.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,4.14),(7.09,4.36),(7.31,4.36),(7.31,4.14),(7.09,4.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,4.64),(7.09,4.86),(7.31,4.86),(7.31,4.64),(7.09,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,5.14),(7.09,5.36),(7.31,5.36),(7.31,5.14),(7.09,5.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.64),(5.49,10.86),(5.71,10.86),(5.71,10.64),(5.49,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.14),(5.49,11.36),(5.71,11.36),(5.71,11.14),(5.49,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.64),(5.49,11.86),(5.71,11.86),(5.71,11.64),(5.49,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.14),(5.49,12.36),(5.71,12.36),(5.71,12.14),(5.49,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.64),(5.49,12.86),(5.71,12.86),(5.71,12.64),(5.49,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.14),(5.49,13.36),(5.71,13.36),(5.71,13.14),(5.49,13.14)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((1.9,10.4),(1.9,13.6),(2.9,13.6),(2.9,10.4),(1.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,5.6),(1.3,5.6),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,5.82),(4.66,5.82),(4.66,8.62),(4.46,8.62),(4.46,8.98),(4.66,8.98),(4.66,10.18),(4.5,10.18),(4.5,13.82),(5.1,13.82),(5.1,10.18),(4.94,10.18),(4.94,5.82),(5.1,5.82),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.15),(0.63,5.365),(0.97,5.365),(0.97,3.44),(2.27,3.44),(2.27,10.635),(2.23,10.635),(2.23,13.365),(2.27,13.365),(2.27,13.85),(2.53,13.85),(2.53,13.365),(2.57,13.365),(2.57,10.635),(2.53,10.635),(2.53,8.915),(4.81,8.915),(4.81,8.685),(2.53,8.685),(2.53,2.15),(2.27,2.15),(2.27,2.96),(0.97,2.96),(0.97,2.15),(0.63,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.69,2.64),(0.69,2.86),(0.91,2.86),(0.91,2.64),(0.69,2.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.14),(0.69,3.36),(0.91,3.36),(0.91,3.14),(0.69,3.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.64),(0.69,3.86),(0.91,3.86),(0.91,3.64),(0.69,3.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.14),(0.69,4.36),(0.91,4.36),(0.91,4.14),(0.69,4.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.64),(0.69,4.86),(0.91,4.86),(0.91,4.64),(0.69,4.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,5.14),(0.69,5.36),(0.91,5.36),(0.91,5.14),(0.69,5.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,10.64),(2.29,10.86),(2.51,10.86),(2.51,10.64),(2.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.14),(2.29,11.36),(2.51,11.36),(2.51,11.14),(2.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.64),(2.29,11.86),(2.51,11.86),(2.51,11.64),(2.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.14),(2.29,12.36),(2.51,12.36),(2.51,12.14),(2.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.64),(2.29,12.86),(2.51,12.86),(2.51,12.64),(2.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,13.14),(2.29,13.36),(2.51,13.36),(2.51,13.14),(2.29,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.53,8.69),(4.53,8.91),(4.75,8.91),(4.75,8.69),(4.53,8.69)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((5.2,14.4),(5.2,15.04),(6.0,15.04),(6.0,14.4),(5.2,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,10.4),(2.9,13.6),(5.1,13.6),(5.1,10.4),(2.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,10.4),(6.1,13.6),(7.02,13.6),(7.02,14.74),(7.38,14.74),(7.38,10.4),(6.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,14.74),(0.98,14.74),(0.98,13.6),(1.9,13.6),(1.9,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.0,14.4),(2.0,15.04),(2.8,15.04),(2.8,14.4),(2.0,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(8.48,17.28),(8.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.83,10.635),(3.83,13.365),(3.885,13.365),(3.885,14.08),(0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(4.115,14.08),(4.115,13.365),(4.17,13.365),(4.17,10.635),(3.83,10.635)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,14.45),(7.09,14.67),(7.31,14.67),(7.31,14.45),(7.09,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.61),(5.49,14.83),(5.71,14.83),(5.71,14.61),(5.49,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.64),(3.89,10.86),(4.11,10.86),(4.11,10.64),(3.89,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.14),(3.89,11.36),(4.11,11.36),(4.11,11.14),(3.89,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.64),(3.89,11.86),(4.11,11.86),(4.11,11.64),(3.89,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.14),(3.89,12.36),(4.11,12.36),(4.11,12.14),(3.89,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.64),(3.89,12.86),(4.11,12.86),(4.11,12.64),(3.89,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.14),(3.89,13.36),(4.11,13.36),(4.11,13.14),(3.89,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.18),(6.1,5.82),(6.26,5.82),(6.26,10.18),(6.1,10.18),(6.1,13.82),(6.7,13.82),(6.7,10.18),(6.54,10.18),(6.54,8.18),(7.22,8.18),(7.22,7.82),(6.54,7.82),(6.54,5.82),(6.7,5.82),(6.7,2.18),(6.1,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.07,6.4),(7.07,7.885),(6.87,7.885),(6.87,8.115),(7.07,8.115),(7.07,13.85),(7.33,13.85),(7.33,6.4),(7.07,6.4)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(6.4), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(6.4), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((6.93,7.89),(6.93,8.11),(7.15,8.11),(7.15,7.89),(6.93,7.89)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((5.1,2.4),(5.1,5.6),(6.1,5.6),(6.1,2.4),(5.1,2.4)),
        )
        net = nets['nset']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,5.82),(1.46,5.82),(1.46,7.82),(0.78,7.82),(0.78,8.18),(1.46,8.18),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,5.82),(1.9,5.82),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,6.4),(0.67,13.85),(0.93,13.85),(0.93,8.115),(1.13,8.115),(1.13,7.885),(0.93,7.885),(0.93,6.4),(0.67,6.4)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(6.4), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(6.4), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['nset'].setDirection(Net.Direction.IN)

    cell = new_cells['nxr2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(11.200000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((5.1,8.8),(5.1,15.2),(6.1,15.2),(6.1,8.8),(5.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,0.96),(5.1,4.0),(6.1,4.0),(6.1,0.96),(5.1,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,2.15),(3.87,12.0),(4.13,12.0),(4.13,11.315),(5.43,11.315),(5.43,12.455),(5.77,12.455),(5.77,9.045),(5.43,9.045),(5.43,11.085),(4.13,11.085),(4.13,3.315),(5.43,3.315),(5.43,3.905),(5.77,3.905),(5.77,2.15),(5.43,2.15),(5.43,3.085),(4.13,3.085),(4.13,2.15),(3.87,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(2.15), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(2.15), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,2.18),(5.49,2.4),(5.71,2.4),(5.71,2.18),(5.49,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.68),(5.49,2.9),(5.71,2.9),(5.71,2.68),(5.49,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.18),(5.49,3.4),(5.71,3.4),(5.71,3.18),(5.49,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.68),(5.49,3.9),(5.71,3.9),(5.71,3.68),(5.49,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.05),(5.49,9.27),(5.71,9.27),(5.71,9.05),(5.49,9.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.55),(5.49,9.77),(5.71,9.77),(5.71,9.55),(5.49,9.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.05),(5.49,10.27),(5.71,10.27),(5.71,10.05),(5.49,10.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.55),(5.49,10.77),(5.71,10.77),(5.71,10.55),(5.49,10.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.05),(5.49,11.27),(5.71,11.27),(5.71,11.05),(5.49,11.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.55),(5.49,11.77),(5.71,11.77),(5.71,11.55),(5.49,11.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.05),(5.49,12.27),(5.71,12.27),(5.71,12.05),(5.49,12.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((2.22,8.8),(2.22,10.4),(1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,15.2),(3.5,15.2),(3.5,8.8),(2.22,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.16,14.4),(10.16,15.2),(10.64,15.2),(10.64,14.4),(10.16,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,8.8),(4.5,15.2),(5.1,15.2),(5.1,8.8),(4.5,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,8.8),(6.1,15.2),(6.7,15.2),(6.7,8.8),(6.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,14.4),(0.56,15.2),(1.04,15.2),(1.04,14.4),(0.56,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,8.8),(7.7,15.2),(8.98,15.2),(8.98,13.6),(9.9,13.6),(9.9,10.4),(8.98,10.4),(8.98,8.8),(7.7,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(11.68,17.28),(11.68,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(11.2,16.0),(11.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,14.25),(8.69,14.47),(8.91,14.47),(8.91,14.25),(8.69,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,14.75),(8.69,14.97),(8.91,14.97),(8.91,14.75),(8.69,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.61),(0.69,14.83),(0.91,14.83),(0.91,14.61),(0.69,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.25),(2.29,14.47),(2.51,14.47),(2.51,14.25),(2.29,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.75),(2.29,14.97),(2.51,14.97),(2.51,14.75),(2.29,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.61),(10.29,14.83),(10.51,14.83),(10.51,14.61),(10.29,14.61)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.7,15.2),(7.7,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,8.8),(3.5,15.2),(4.5,15.2),(4.5,8.8),(3.5,8.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.43),(3.89,12.65),(4.11,12.65),(4.11,12.43),(3.89,12.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.93),(3.89,13.15),(4.11,13.15),(4.11,12.93),(3.89,12.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.43),(3.89,13.65),(4.11,13.65),(4.11,13.43),(3.89,13.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,8.995),(7.03,12.685),(4.17,12.685),(4.17,12.23),(3.83,12.23),(3.83,13.85),(4.17,13.85),(4.17,12.915),(7.03,12.915),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.03,8.995)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((2.06,8.57),(2.06,10.17),(0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,15.43),(9.14,15.43),(9.14,13.83),(10.74,13.83),(10.74,10.17),(9.14,10.17),(9.14,8.57),(2.06,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((10.0,0.41),(10.0,1.67),(10.8,1.67),(10.8,0.41),(10.0,0.41)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(11.6,16.4),(11.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(11.205,16.005),(11.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.06,0.73),(2.06,2.17),(0.46,2.17),(0.46,4.23),(10.74,4.23),(10.74,2.17),(9.14,2.17),(9.14,0.73),(2.06,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((10.0,14.17),(10.0,15.43),(10.8,15.43),(10.8,14.17),(10.0,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.4,14.17),(0.4,15.43),(1.2,15.43),(1.2,14.17),(0.4,14.17)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(0.78,6.22),(0.78,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.59),(0.69,2.81),(0.91,2.81),(0.91,2.59),(0.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.59),(0.69,3.81),(0.91,3.81),(0.91,3.59),(0.69,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.64),(0.69,10.86),(0.91,10.86),(0.91,10.64),(0.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.14),(0.69,11.36),(0.91,11.36),(0.91,11.14),(0.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.64),(0.69,11.86),(0.91,11.86),(0.91,11.64),(0.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.14),(0.69,12.36),(0.91,12.36),(0.91,12.14),(0.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.64),(0.69,12.86),(0.91,12.86),(0.91,12.64),(0.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.14),(0.69,13.36),(0.91,13.36),(0.91,13.14),(0.69,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.585),(0.63,3.815),(0.685,3.815),(0.685,10.635),(0.63,10.635),(0.63,13.365),(0.97,13.365),(0.97,10.635),(0.915,10.635),(0.915,6.515),(1.13,6.515),(1.13,6.285),(0.915,6.285),(0.915,3.815),(0.97,3.815),(0.97,2.585),(0.63,2.585)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((6.1,0.96),(6.1,4.0),(6.7,4.0),(6.7,0.96),(6.1,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.22,0.96),(2.22,2.4),(1.3,2.4),(1.3,4.0),(3.5,4.0),(3.5,0.96),(2.22,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,0.96),(7.7,4.0),(9.9,4.0),(9.9,2.4),(8.98,2.4),(8.98,0.96),(7.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.16,0.64),(10.16,1.44),(10.64,1.44),(10.64,0.64),(10.16,0.64)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,0.96),(4.5,4.0),(5.1,4.0),(5.1,0.96),(4.5,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(11.2,1.92),(11.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,1.11),(8.69,1.33),(8.91,1.33),(8.91,1.11),(8.69,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,1.61),(8.69,1.83),(8.91,1.83),(8.91,1.61),(8.69,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.01),(10.29,1.23),(10.51,1.23),(10.51,1.01),(10.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.11),(2.29,1.33),(2.51,1.33),(2.51,1.11),(2.29,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.61),(2.29,1.83),(2.51,1.83),(2.51,1.61),(2.29,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.7,4.0),(7.7,0.96),(6.7,0.96)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'COMP',
            ((3.5,0.96),(3.5,4.0),(4.5,4.0),(4.5,0.96),(3.5,0.96)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,4.22),(4.78,4.22),(4.78,4.98),(5.14,4.98),(5.14,4.62),(5.1,4.62),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.18,6.22),(7.18,6.58),(8.02,6.58),(8.02,8.58),(7.7,8.58),(7.7,15.42),(8.3,15.42),(8.3,6.58),(10.42,6.58),(10.42,6.22),(7.18,6.22)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,10.4),(9.9,13.6),(10.58,13.6),(10.58,10.4),(9.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,2.4),(9.9,4.0),(10.58,4.0),(10.58,2.4),(9.9,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.59),(10.29,2.81),(10.51,2.81),(10.51,2.59),(10.29,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.09),(10.29,3.31),(10.51,3.31),(10.51,3.09),(10.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.59),(10.29,3.81),(10.51,3.81),(10.51,3.59),(10.29,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.25,6.29),(7.25,6.51),(7.47,6.51),(7.47,6.29),(7.25,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.13,6.29),(10.13,6.51),(10.35,6.51),(10.35,6.29),(10.13,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.64),(10.29,10.86),(10.51,10.86),(10.51,10.64),(10.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.14),(10.29,11.36),(10.51,11.36),(10.51,11.14),(10.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.64),(10.29,11.86),(10.51,11.86),(10.51,11.64),(10.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.14),(10.29,12.36),(10.51,12.36),(10.51,12.14),(10.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.64),(10.29,12.86),(10.51,12.86),(10.51,12.64),(10.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.14),(10.29,13.36),(10.51,13.36),(10.51,13.14),(10.29,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.85,4.69),(4.85,4.91),(5.07,4.91),(5.07,4.69),(4.85,4.69)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.23,2.585),(10.23,3.815),(10.285,3.815),(10.285,6.285),(10.07,6.285),(10.07,6.515),(10.285,6.515),(10.285,10.635),(10.23,10.635),(10.23,13.365),(10.57,13.365),(10.57,10.635),(10.515,10.635),(10.515,3.815),(10.57,3.815),(10.57,2.585),(10.23,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.79,4.685),(4.79,4.915),(7.085,4.915),(7.085,6.515),(7.53,6.515),(7.53,6.285),(7.315,6.285),(7.315,4.685),(4.79,4.685)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((2.9,0.74),(2.9,4.62),(1.9,4.62),(1.9,2.18),(1.3,2.18),(1.3,4.22),(1.62,4.22),(1.62,4.98),(3.18,4.98),(3.18,4.22),(3.5,4.22),(3.5,0.74),(2.9,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.62,7.82),(1.62,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,8.18),(2.9,8.18),(2.9,15.42),(3.5,15.42),(3.5,8.58),(3.18,8.58),(3.18,7.82),(1.62,7.82)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,2.15),(2.27,4.685),(2.23,4.685),(2.23,4.915),(2.27,4.915),(2.27,7.885),(2.23,7.885),(2.23,8.115),(2.27,8.115),(2.27,13.85),(2.53,13.85),(2.53,8.115),(2.57,8.115),(2.57,7.885),(2.53,7.885),(2.53,4.915),(2.57,4.915),(2.57,4.685),(2.53,4.685),(2.53,2.15),(2.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,7.89),(2.29,8.11),(2.51,8.11),(2.51,7.89),(2.29,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,4.69),(2.29,4.91),(2.51,4.91),(2.51,4.69),(2.29,4.69)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((4.78,7.82),(4.78,8.58),(4.5,8.58),(4.5,15.42),(5.1,15.42),(5.1,8.18),(5.14,8.18),(5.14,7.82),(4.78,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((8.78,7.82),(8.78,8.18),(9.3,8.18),(9.3,13.82),(9.9,13.82),(9.9,10.18),(9.58,10.18),(9.58,7.82),(8.78,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.7,0.74),(7.7,4.22),(8.02,4.22),(8.02,4.98),(9.58,4.98),(9.58,4.22),(9.9,4.22),(9.9,2.18),(9.3,2.18),(9.3,4.62),(8.3,4.62),(8.3,0.74),(7.7,0.74)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.67,2.15),(8.67,4.685),(8.63,4.685),(8.63,4.915),(8.67,4.915),(8.67,7.885),(4.79,7.885),(4.79,8.115),(8.67,8.115),(8.67,13.85),(8.93,13.85),(8.93,8.115),(9.13,8.115),(9.13,7.885),(8.93,7.885),(8.93,4.915),(8.97,4.915),(8.97,4.685),(8.93,4.685),(8.93,2.15),(8.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.85,7.89),(8.85,8.11),(9.07,8.11),(9.07,7.89),(8.85,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,4.69),(8.69,4.91),(8.91,4.91),(8.91,4.69),(8.69,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.85,7.89),(4.85,8.11),(5.07,8.11),(5.07,7.89),(4.85,7.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['o2_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((2.9,8.8),(2.9,13.6),(3.82,13.6),(3.82,15.2),(5.1,15.2),(5.1,8.8),(2.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.8),(1.3,13.6),(1.9,13.6),(1.9,8.8),(1.3,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,14.4),(2.08,15.04),(2.72,15.04),(2.72,14.4),(2.08,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(6.88,17.28),(6.88,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.89,14.25),(3.89,14.47),(4.11,14.47),(4.11,14.25),(3.89,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.75),(3.89,14.97),(4.11,14.97),(4.11,14.75),(3.89,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((5.1,0.96),(5.1,4.0),(5.78,4.0),(5.78,0.96),(5.1,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,8.8),(5.1,15.2),(5.78,15.2),(5.78,8.8),(5.1,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,2.15),(5.43,3.905),(5.47,3.905),(5.47,8.995),(5.43,8.995),(5.43,13.85),(5.77,13.85),(5.77,8.995),(5.73,8.995),(5.73,3.905),(5.77,3.905),(5.77,2.15),(5.43,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,2.18),(5.49,2.4),(5.71,2.4),(5.71,2.18),(5.49,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.68),(5.49,2.9),(5.71,2.9),(5.71,2.68),(5.49,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.18),(5.49,3.4),(5.71,3.4),(5.71,3.18),(5.49,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.68),(5.49,3.9),(5.71,3.9),(5.71,3.68),(5.49,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.0),(5.49,9.22),(5.71,9.22),(5.71,9.0),(5.49,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.5),(5.49,9.72),(5.71,9.72),(5.71,9.5),(5.49,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.0),(5.49,10.22),(5.71,10.22),(5.71,10.0),(5.49,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.5),(5.49,10.72),(5.71,10.72),(5.71,10.5),(5.49,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.0),(5.49,11.22),(5.71,11.22),(5.71,11.0),(5.49,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.5),(5.49,11.72),(5.71,11.72),(5.71,11.5),(5.49,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.0),(5.49,12.22),(5.71,12.22),(5.71,12.0),(5.49,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.5),(5.49,12.72),(5.71,12.72),(5.71,12.5),(5.49,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.0),(5.49,13.22),(5.71,13.22),(5.71,13.0),(5.49,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.5),(5.49,13.72),(5.71,13.72),(5.71,13.5),(5.49,13.5)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((0.46,8.57),(0.46,13.83),(3.66,13.83),(3.66,15.43),(5.94,15.43),(5.94,8.57),(0.46,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.92,0.57),(1.92,1.67),(2.88,1.67),(2.88,0.57),(1.92,0.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.66,0.73),(3.66,2.17),(1.14,2.17),(1.14,1.03),(0.46,1.03),(0.46,4.23),(5.94,4.23),(5.94,0.73),(3.66,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.92,14.17),(1.92,15.27),(2.88,15.27),(2.88,14.17),(1.92,14.17)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,4.22),(4.66,4.22),(4.66,6.22),(2.38,6.22),(2.38,6.58),(4.66,6.58),(4.66,8.58),(4.5,8.58),(4.5,15.42),(5.1,15.42),(5.1,8.58),(4.94,8.58),(4.94,4.22),(5.1,4.22),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,4.0),(2.9,4.0),(2.9,2.4),(1.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,8.8),(0.62,13.6),(1.3,13.6),(1.3,8.8),(0.62,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.23,2.585),(2.23,3.815),(2.285,3.815),(2.285,12.685),(0.97,12.685),(0.97,12.23),(0.63,12.23),(0.63,13.495),(0.97,13.495),(0.97,12.915),(2.515,12.915),(2.515,6.515),(2.73,6.515),(2.73,6.285),(2.515,6.285),(2.515,3.815),(2.57,3.815),(2.57,2.585),(2.23,2.585)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.27),(0.69,12.49),(0.91,12.49),(0.91,12.27),(0.69,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.77),(0.69,12.99),(0.91,12.99),(0.91,12.77),(0.69,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.27),(0.69,13.49),(0.91,13.49),(0.91,13.27),(0.69,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,2.59),(2.29,2.81),(2.51,2.81),(2.51,2.59),(2.29,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.09),(2.29,3.31),(2.51,3.31),(2.51,3.09),(2.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.59),(2.29,3.81),(2.51,3.81),(2.51,3.59),(2.29,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.45,6.29),(2.45,6.51),(2.67,6.51),(2.67,6.29),(2.45,6.29)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((3.82,0.96),(3.82,2.4),(2.9,2.4),(2.9,4.0),(5.1,4.0),(5.1,0.96),(3.82,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,1.26),(0.62,4.0),(1.9,4.0),(1.9,2.4),(0.98,2.4),(0.98,1.26),(0.62,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,0.8),(2.08,1.44),(2.72,1.44),(2.72,0.8),(2.08,0.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.01),(2.29,1.23),(2.51,1.23),(2.51,1.01),(2.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.11),(3.89,1.33),(4.11,1.33),(4.11,1.11),(3.89,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.61),(3.89,1.83),(4.11,1.83),(4.11,1.61),(3.89,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.33),(0.69,1.55),(0.91,1.55),(0.91,1.33),(0.69,1.33)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((1.9,8.8),(1.9,13.6),(2.9,13.6),(2.9,8.8),(1.9,8.8)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.22,4.22),(3.22,4.98),(4.02,4.98),(4.02,4.62),(3.5,4.62),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((3.22,7.82),(3.22,8.58),(2.9,8.58),(2.9,13.82),(3.5,13.82),(3.5,8.18),(4.02,8.18),(4.02,7.82),(3.22,7.82)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,2.15),(3.87,4.685),(3.67,4.685),(3.67,4.915),(3.87,4.915),(3.87,7.885),(3.67,7.885),(3.67,8.115),(3.87,8.115),(3.87,13.85),(4.13,13.85),(4.13,2.15),(3.87,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((3.73,4.69),(3.73,4.91),(3.95,4.91),(3.95,4.69),(3.73,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.73,7.89),(3.73,8.11),(3.95,8.11),(3.95,7.89),(3.73,7.89)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.46,4.22),(1.46,6.22),(0.78,6.22),(0.78,6.58),(1.46,6.58),(1.46,8.58),(1.3,8.58),(1.3,13.82),(1.9,13.82),(1.9,8.58),(1.74,8.58),(1.74,4.22),(1.9,4.22),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,2.15),(0.67,12.0),(0.93,12.0),(0.93,6.515),(1.13,6.515),(1.13,6.285),(0.93,6.285),(0.93,2.15),(0.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['o3_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((4.5,8.8),(4.5,13.6),(5.42,13.6),(5.42,15.2),(6.7,15.2),(6.7,8.8),(4.5,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.8),(1.3,13.6),(1.9,13.6),(1.9,8.8),(1.3,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,14.4),(0.56,15.2),(1.04,15.2),(1.04,14.4),(0.56,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,8.8),(2.9,13.6),(3.5,13.6),(3.5,8.8),(2.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,14.4),(3.68,15.04),(4.32,15.04),(4.32,14.4),(3.68,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(8.48,17.28),(8.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,13.145),(5.43,14.08),(0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(5.77,14.08),(5.77,13.145),(5.43,13.145)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,13.28),(5.49,13.5),(5.71,13.5),(5.71,13.28),(5.49,13.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.78),(5.49,14.0),(5.71,14.0),(5.71,13.78),(5.49,13.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.28),(5.49,14.5),(5.71,14.5),(5.71,14.28),(5.49,14.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.78),(5.49,15.0),(5.71,15.0),(5.71,14.78),(5.49,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.61),(3.89,14.83),(4.11,14.83),(4.11,14.61),(3.89,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.61),(0.69,14.83),(0.91,14.83),(0.91,14.61),(0.69,14.61)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.38,4.0),(7.38,0.96),(6.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.38,15.2),(7.38,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,2.15),(7.03,3.905),(7.07,3.905),(7.07,8.995),(7.03,8.995),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.33,8.995),(7.33,3.905),(7.37,3.905),(7.37,2.15),(7.03,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.18),(7.09,2.4),(7.31,2.4),(7.31,2.18),(7.09,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.68),(7.09,2.9),(7.31,2.9),(7.31,2.68),(7.09,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.18),(7.09,3.4),(7.31,3.4),(7.31,3.18),(7.09,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.68),(7.09,3.9),(7.31,3.9),(7.31,3.68),(7.09,3.68)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((3.52,0.57),(3.52,1.67),(4.48,1.67),(4.48,0.57),(3.52,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,8.57),(0.46,13.83),(5.26,13.83),(5.26,15.43),(7.54,15.43),(7.54,8.57),(0.46,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.26,0.73),(5.26,2.17),(2.74,2.17),(2.74,1.03),(2.06,1.03),(2.06,2.17),(0.46,2.17),(0.46,4.23),(7.54,4.23),(7.54,0.73),(5.26,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.52,14.17),(3.52,15.27),(4.48,15.27),(4.48,14.17),(3.52,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.4,14.17),(0.4,15.43),(1.2,15.43),(1.2,14.17),(0.4,14.17)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(5.58,6.22),(5.58,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,8.8),(0.62,13.6),(1.3,13.6),(1.3,8.8),(0.62,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,4.0),(4.5,4.0),(4.5,2.4),(3.5,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.5),(0.63,3.77),(0.97,3.77),(0.97,3.315),(3.83,3.315),(3.83,3.77),(4.17,3.77),(4.17,3.315),(5.485,3.315),(5.485,12.685),(0.97,12.685),(0.97,12.23),(0.63,12.23),(0.63,13.495),(0.97,13.495),(0.97,12.915),(5.715,12.915),(5.715,6.515),(5.93,6.515),(5.93,6.285),(5.715,6.285),(5.715,3.085),(4.17,3.085),(4.17,2.5),(3.83,2.5),(3.83,3.085),(0.97,3.085),(0.97,2.5),(0.63,2.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.505),(0.69,2.725),(0.91,2.725),(0.91,2.505),(0.69,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.005),(0.69,3.225),(0.91,3.225),(0.91,3.005),(0.69,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.505),(0.69,3.725),(0.91,3.725),(0.91,3.505),(0.69,3.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.65,6.29),(5.65,6.51),(5.87,6.51),(5.87,6.29),(5.65,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.27),(0.69,12.49),(0.91,12.49),(0.91,12.27),(0.69,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.77),(0.69,12.99),(0.91,12.99),(0.91,12.77),(0.69,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.27),(0.69,13.49),(0.91,13.49),(0.91,13.27),(0.69,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.505),(3.89,2.725),(4.11,2.725),(4.11,2.505),(3.89,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.005),(3.89,3.225),(4.11,3.225),(4.11,3.005),(3.89,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.505),(3.89,3.725),(4.11,3.725),(4.11,3.505),(3.89,3.505)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((2.22,1.26),(2.22,2.4),(1.3,2.4),(1.3,4.0),(3.5,4.0),(3.5,2.4),(2.58,2.4),(2.58,1.26),(2.22,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,0.8),(3.68,1.44),(4.32,1.44),(4.32,0.8),(3.68,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,0.96),(5.42,2.4),(4.5,2.4),(4.5,4.0),(6.7,4.0),(6.7,0.96),(5.42,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(5.43,1.92),(5.43,2.855),(5.77,2.855),(5.77,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.33),(2.29,1.55),(2.51,1.55),(2.51,1.33),(2.29,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.01),(3.89,1.23),(4.11,1.23),(4.11,1.01),(3.89,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.08),(5.49,1.3),(5.71,1.3),(5.71,1.08),(5.49,1.08)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.58),(5.49,1.8),(5.71,1.8),(5.71,1.58),(5.49,1.58)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.08),(5.49,2.3),(5.71,2.3),(5.71,2.08),(5.49,2.08)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.58),(5.49,2.8),(5.71,2.8),(5.71,2.58),(5.49,2.58)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,4.22),(4.66,4.22),(4.66,7.82),(3.98,7.82),(3.98,8.18),(4.66,8.18),(4.66,8.58),(4.5,8.58),(4.5,13.82),(5.1,13.82),(5.1,8.58),(4.94,8.58),(4.94,4.22),(5.1,4.22),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,4.0),(3.87,12.455),(4.13,12.455),(4.13,8.115),(4.33,8.115),(4.33,7.885),(4.13,7.885),(4.13,4.0),(3.87,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(4.0), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(4.0), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((4.05,7.89),(4.05,8.11),(4.27,8.11),(4.27,7.89),(4.05,7.89)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((3.5,8.8),(3.5,13.6),(4.5,13.6),(4.5,8.8),(3.5,8.8)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.06,4.22),(3.06,4.62),(2.22,4.62),(2.22,4.98),(3.06,4.98),(3.06,8.58),(2.9,8.58),(2.9,13.82),(3.5,13.82),(3.5,8.58),(3.34,8.58),(3.34,4.22),(3.5,4.22),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,3.545),(2.27,4.685),(2.23,4.685),(2.23,4.915),(2.27,4.915),(2.27,12.455),(2.53,12.455),(2.53,4.915),(2.57,4.915),(2.57,4.685),(2.53,4.685),(2.53,3.545),(2.27,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(3.545), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(3.545), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,4.69),(2.29,4.91),(2.51,4.91),(2.51,4.69),(2.29,4.69)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((1.9,8.8),(1.9,13.6),(2.9,13.6),(2.9,8.8),(1.9,8.8)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.46,4.22),(1.46,6.22),(0.62,6.22),(0.62,6.58),(1.46,6.58),(1.46,8.58),(1.3,8.58),(1.3,13.82),(1.9,13.82),(1.9,8.58),(1.74,8.58),(1.74,4.22),(1.9,4.22),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,4.0),(0.67,6.285),(0.63,6.285),(0.63,6.515),(0.67,6.515),(0.67,12.0),(0.93,12.0),(0.93,6.515),(0.97,6.515),(0.97,6.285),(0.93,6.285),(0.93,4.0),(0.67,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(4.0), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(4.0), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.69,6.29),(0.69,6.51),(0.91,6.51),(0.91,6.29),(0.69,6.29)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['o4_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(9.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((5.28,14.4),(5.28,15.04),(5.92,15.04),(5.92,14.4),(5.28,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,8.8),(6.1,13.6),(7.02,13.6),(7.02,15.2),(8.3,15.2),(8.3,8.8),(6.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,8.8),(4.5,13.6),(5.1,13.6),(5.1,8.8),(4.5,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.8),(1.3,13.6),(1.9,13.6),(1.9,8.8),(1.3,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,8.8),(2.9,13.6),(3.5,13.6),(3.5,8.8),(2.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,14.4),(2.08,15.04),(2.72,15.04),(2.72,14.4),(2.08,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(10.08,17.28),(10.08,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,13.145),(7.03,14.08),(0.0,14.08),(0.0,16.0),(9.6,16.0),(9.6,14.08),(7.37,14.08),(7.37,13.145),(7.03,13.145)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.8), u(9.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,13.28),(7.09,13.5),(7.31,13.5),(7.31,13.28),(7.09,13.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.78),(7.09,14.0),(7.31,14.0),(7.31,13.78),(7.09,13.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.28),(7.09,14.5),(7.31,14.5),(7.31,14.28),(7.09,14.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.78),(7.09,15.0),(7.31,15.0),(7.31,14.78),(7.09,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.61),(5.49,14.83),(5.71,14.83),(5.71,14.61),(5.49,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((8.3,0.96),(8.3,4.0),(8.98,4.0),(8.98,0.96),(8.3,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((8.3,8.8),(8.3,15.2),(8.98,15.2),(8.98,8.8),(8.3,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.63,2.15),(8.63,3.905),(8.67,3.905),(8.67,8.995),(8.63,8.995),(8.63,13.85),(8.97,13.85),(8.97,8.995),(8.93,8.995),(8.93,3.905),(8.97,3.905),(8.97,2.15),(8.63,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,2.18),(8.69,2.4),(8.91,2.4),(8.91,2.18),(8.69,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,2.68),(8.69,2.9),(8.91,2.9),(8.91,2.68),(8.69,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.18),(8.69,3.4),(8.91,3.4),(8.91,3.18),(8.69,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.68),(8.69,3.9),(8.91,3.9),(8.91,3.68),(8.69,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,9.0),(8.69,9.22),(8.91,9.22),(8.91,9.0),(8.69,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,9.5),(8.69,9.72),(8.91,9.72),(8.91,9.5),(8.69,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,10.0),(8.69,10.22),(8.91,10.22),(8.91,10.0),(8.69,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,10.5),(8.69,10.72),(8.91,10.72),(8.91,10.5),(8.69,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,11.0),(8.69,11.22),(8.91,11.22),(8.91,11.0),(8.69,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,11.5),(8.69,11.72),(8.91,11.72),(8.91,11.5),(8.69,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.0),(8.69,12.22),(8.91,12.22),(8.91,12.0),(8.69,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,12.5),(8.69,12.72),(8.91,12.72),(8.91,12.5),(8.69,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.0),(8.69,13.22),(8.91,13.22),(8.91,13.0),(8.69,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,13.5),(8.69,13.72),(8.91,13.72),(8.91,13.5),(8.69,13.5)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((0.46,8.57),(0.46,13.83),(6.86,13.83),(6.86,15.43),(9.14,15.43),(9.14,8.57),(0.46,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((5.12,0.57),(5.12,1.67),(6.08,1.67),(6.08,0.57),(5.12,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.92,0.57),(1.92,1.67),(2.88,1.67),(2.88,0.57),(1.92,0.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(10.0,16.4),(10.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(9.605,16.005),(9.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((6.86,0.73),(6.86,2.17),(4.34,2.17),(4.34,1.03),(3.66,1.03),(3.66,2.17),(1.14,2.17),(1.14,1.03),(0.46,1.03),(0.46,4.23),(9.14,4.23),(9.14,0.73),(6.86,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((5.12,14.17),(5.12,15.27),(6.08,15.27),(6.08,14.17),(5.12,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.92,14.17),(1.92,15.27),(2.88,15.27),(2.88,14.17),(1.92,14.17)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Poly2',
            ((7.7,0.74),(7.7,4.22),(7.86,4.22),(7.86,6.22),(7.18,6.22),(7.18,6.58),(7.86,6.58),(7.86,8.58),(7.7,8.58),(7.7,15.42),(8.3,15.42),(8.3,8.58),(8.14,8.58),(8.14,4.22),(8.3,4.22),(8.3,0.74),(7.7,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,2.4),(5.1,4.0),(6.1,4.0),(6.1,2.4),(5.1,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,2.4),(1.9,4.0),(2.9,4.0),(2.9,2.4),(1.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,8.8),(0.62,13.6),(1.3,13.6),(1.3,8.8),(0.62,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.23,2.5),(2.23,3.77),(2.57,3.77),(2.57,3.315),(5.43,3.315),(5.43,3.77),(5.77,3.77),(5.77,3.315),(7.085,3.315),(7.085,12.685),(0.97,12.685),(0.97,12.23),(0.63,12.23),(0.63,13.495),(0.97,13.495),(0.97,12.915),(7.315,12.915),(7.315,6.515),(7.53,6.515),(7.53,6.285),(7.315,6.285),(7.315,3.085),(5.77,3.085),(5.77,2.5),(5.43,2.5),(5.43,3.085),(2.57,3.085),(2.57,2.5),(2.23,2.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.25,6.29),(7.25,6.51),(7.47,6.51),(7.47,6.29),(7.25,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.505),(5.49,2.725),(5.71,2.725),(5.71,2.505),(5.49,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.005),(5.49,3.225),(5.71,3.225),(5.71,3.005),(5.49,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.505),(5.49,3.725),(5.71,3.725),(5.71,3.505),(5.49,3.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.27),(0.69,12.49),(0.91,12.49),(0.91,12.27),(0.69,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.77),(0.69,12.99),(0.91,12.99),(0.91,12.77),(0.69,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.27),(0.69,13.49),(0.91,13.49),(0.91,13.27),(0.69,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,2.505),(2.29,2.725),(2.51,2.725),(2.51,2.505),(2.29,2.505)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.005),(2.29,3.225),(2.51,3.225),(2.51,3.005),(2.29,3.005)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.505),(2.29,3.725),(2.51,3.725),(2.51,3.505),(2.29,3.505)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.62,1.26),(0.62,4.0),(1.9,4.0),(1.9,2.4),(0.98,2.4),(0.98,1.26),(0.62,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.82,1.26),(3.82,2.4),(2.9,2.4),(2.9,4.0),(5.1,4.0),(5.1,2.4),(4.18,2.4),(4.18,1.26),(3.82,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.02,0.96),(7.02,2.4),(6.1,2.4),(6.1,4.0),(8.3,4.0),(8.3,0.96),(7.02,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,0.8),(2.08,1.44),(2.72,1.44),(2.72,0.8),(2.08,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.28,0.8),(5.28,1.44),(5.92,1.44),(5.92,0.8),(5.28,0.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(7.03,1.92),(7.03,2.855),(7.37,2.855),(7.37,1.92),(9.6,1.92),(9.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.8), u(9.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.01),(2.29,1.23),(2.51,1.23),(2.51,1.01),(2.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.01),(5.49,1.23),(5.71,1.23),(5.71,1.01),(5.49,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.08),(7.09,1.3),(7.31,1.3),(7.31,1.08),(7.09,1.08)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.58),(7.09,1.8),(7.31,1.8),(7.31,1.58),(7.09,1.58)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.08),(7.09,2.3),(7.31,2.3),(7.31,2.08),(7.09,2.08)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.58),(7.09,2.8),(7.31,2.8),(7.31,2.58),(7.09,2.58)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.33),(3.89,1.55),(4.11,1.55),(4.11,1.33),(3.89,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.33),(0.69,1.55),(0.91,1.55),(0.91,1.33),(0.69,1.33)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((4.5,2.18),(4.5,4.22),(4.66,4.22),(4.66,6.22),(3.98,6.22),(3.98,6.58),(4.66,6.58),(4.66,8.58),(4.5,8.58),(4.5,13.82),(5.1,13.82),(5.1,8.58),(4.94,8.58),(4.94,4.22),(5.1,4.22),(5.1,2.18),(4.5,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,3.545),(3.87,12.455),(4.13,12.455),(4.13,6.515),(4.33,6.515),(4.33,6.285),(4.13,6.285),(4.13,3.545),(3.87,3.545)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(3.545), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(3.545), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((4.05,6.29),(4.05,6.51),(4.27,6.51),(4.27,6.29),(4.05,6.29)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'COMP',
            ((3.5,8.8),(3.5,13.6),(4.5,13.6),(4.5,8.8),(3.5,8.8)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((5.1,8.8),(5.1,13.6),(6.1,13.6),(6.1,8.8),(5.1,8.8)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.06,4.22),(3.06,6.22),(2.38,6.22),(2.38,6.58),(3.06,6.58),(3.06,8.58),(2.9,8.58),(2.9,13.82),(3.5,13.82),(3.5,8.58),(3.34,8.58),(3.34,4.22),(3.5,4.22),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,4.0),(2.27,12.455),(2.53,12.455),(2.53,6.515),(2.73,6.515),(2.73,6.285),(2.53,6.285),(2.53,4.0),(2.27,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(4.0), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(4.0), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.45,6.29),(2.45,6.51),(2.67,6.51),(2.67,6.29),(2.45,6.29)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((1.9,8.8),(1.9,13.6),(2.9,13.6),(2.9,8.8),(1.9,8.8)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.18),(6.1,4.22),(6.26,4.22),(6.26,6.22),(5.58,6.22),(5.58,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,13.82),(6.7,13.82),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,2.18),(6.1,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.47,4.0),(5.47,12.455),(5.73,12.455),(5.73,6.515),(5.93,6.515),(5.93,6.285),(5.73,6.285),(5.73,4.0),(5.47,4.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(4.0), u(12.455),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(4.0), u(12.455),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.65,6.29),(5.65,6.51),(5.87,6.51),(5.87,6.29),(5.65,6.29)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.46,4.22),(1.46,6.22),(0.78,6.22),(0.78,6.58),(1.46,6.58),(1.46,8.58),(1.3,8.58),(1.3,13.82),(1.9,13.82),(1.9,8.58),(1.74,8.58),(1.74,4.22),(1.9,4.22),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,2.15),(0.67,12.0),(0.93,12.0),(0.93,6.515),(1.13,6.515),(1.13,6.285),(0.93,6.285),(0.93,2.15),(0.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['oa22_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((5.42,8.8),(5.42,10.4),(4.5,10.4),(4.5,13.6),(5.42,13.6),(5.42,15.2),(6.7,15.2),(6.7,8.8),(5.42,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,10.4),(2.9,13.6),(3.5,13.6),(3.5,10.4),(2.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,10.4),(1.3,13.6),(1.9,13.6),(1.9,10.4),(1.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,14.4),(2.08,15.04),(2.72,15.04),(2.72,14.4),(2.08,14.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(8.48,17.28),(8.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,14.25),(5.49,14.47),(5.71,14.47),(5.71,14.25),(5.49,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.75),(5.49,14.97),(5.71,14.97),(5.71,14.75),(5.49,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.38,4.0),(7.38,0.96),(6.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.38,15.2),(7.38,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,2.15),(7.03,3.905),(7.07,3.905),(7.07,8.995),(7.03,8.995),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.33,8.995),(7.33,3.905),(7.37,3.905),(7.37,2.15),(7.03,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.18),(7.09,2.4),(7.31,2.4),(7.31,2.18),(7.09,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,2.68),(7.09,2.9),(7.31,2.9),(7.31,2.68),(7.09,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.18),(7.09,3.4),(7.31,3.4),(7.31,3.18),(7.09,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.68),(7.09,3.9),(7.31,3.9),(7.31,3.68),(7.09,3.68)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((5.26,8.57),(5.26,10.17),(0.46,10.17),(0.46,13.83),(5.26,13.83),(5.26,15.43),(7.54,15.43),(7.54,8.57),(5.26,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.92,0.57),(1.92,1.67),(2.88,1.67),(2.88,0.57),(1.92,0.57)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.66,0.73),(3.66,2.33),(1.14,2.33),(1.14,1.03),(0.46,1.03),(0.46,5.83),(4.34,5.83),(4.34,4.23),(7.54,4.23),(7.54,0.73),(3.66,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.92,14.17),(1.92,15.27),(2.88,15.27),(2.88,14.17),(1.92,14.17)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(3.98,6.22),(3.98,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.82,0.96),(3.82,2.56),(3.5,2.56),(3.5,5.6),(4.18,5.6),(4.18,4.0),(4.5,4.0),(4.5,0.96),(3.82,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.9,10.4),(1.9,13.6),(2.9,13.6),(2.9,10.4),(1.9,10.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.05,6.29),(4.05,6.51),(4.27,6.51),(4.27,6.29),(4.05,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,10.6),(2.29,10.82),(2.51,10.82),(2.51,10.6),(2.29,10.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.1),(2.29,11.32),(2.51,11.32),(2.51,11.1),(2.29,11.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,11.6),(2.29,11.82),(2.51,11.82),(2.51,11.6),(2.29,11.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,12.1),(2.29,12.32),(2.51,12.32),(2.51,12.1),(2.29,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.23),(3.89,2.45),(4.11,2.45),(4.11,2.23),(3.89,2.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.73),(3.89,2.95),(4.11,2.95),(4.11,2.73),(3.89,2.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.23),(3.89,3.45),(4.11,3.45),(4.11,3.23),(3.89,3.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.73),(3.89,3.95),(4.11,3.95),(4.11,3.73),(3.89,3.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,4.23),(3.89,4.45),(4.11,4.45),(4.11,4.23),(3.89,4.23)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,4.73),(3.89,4.95),(4.11,4.95),(4.11,4.73),(3.89,4.73)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,5.23),(3.89,5.45),(4.11,5.45),(4.11,5.23),(3.89,5.23)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.83,2.15),(3.83,5.455),(3.885,5.455),(3.885,11.085),(2.57,11.085),(2.57,10.595),(2.23,10.595),(2.23,12.455),(2.57,12.455),(2.57,11.315),(4.115,11.315),(4.115,6.515),(4.33,6.515),(4.33,6.285),(4.115,6.285),(4.115,5.455),(4.17,5.455),(4.17,2.15),(3.83,2.15)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((4.5,0.96),(4.5,4.0),(6.7,4.0),(6.7,0.96),(4.5,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,1.26),(0.62,5.6),(1.9,5.6),(1.9,2.56),(0.98,2.56),(0.98,1.26),(0.62,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.08,0.8),(2.08,1.44),(2.72,1.44),(2.72,0.8),(2.08,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.9,2.56),(2.9,5.6),(3.5,5.6),(3.5,2.56),(2.9,2.56)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.01),(2.29,1.23),(2.51,1.23),(2.51,1.01),(2.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.11),(5.49,1.33),(5.71,1.33),(5.71,1.11),(5.49,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.61),(5.49,1.83),(5.71,1.83),(5.71,1.61),(5.49,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.33),(0.69,1.55),(0.91,1.55),(0.91,1.33),(0.69,1.33)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((1.9,2.56),(1.9,5.6),(2.9,5.6),(2.9,2.56),(1.9,2.56)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.34),(1.3,5.82),(1.46,5.82),(1.46,6.22),(0.78,6.22),(0.78,6.58),(1.46,6.58),(1.46,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,10.18),(1.74,10.18),(1.74,5.82),(1.9,5.82),(1.9,2.34),(1.3,2.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.67,2.15),(0.67,12.0),(0.93,12.0),(0.93,6.515),(1.13,6.515),(1.13,6.285),(0.93,6.285),(0.93,2.15),(0.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(2.15), u(12.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((3.5,10.4),(3.5,13.6),(4.5,13.6),(4.5,10.4),(3.5,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.83,11.545),(3.83,12.685),(0.97,12.685),(0.97,12.23),(0.63,12.23),(0.63,13.495),(0.97,13.495),(0.97,12.915),(3.83,12.915),(3.83,13.405),(4.17,13.405),(4.17,11.545),(3.83,11.545)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.27),(0.69,12.49),(0.91,12.49),(0.91,12.27),(0.69,12.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.77),(0.69,12.99),(0.91,12.99),(0.91,12.77),(0.69,12.77)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.27),(0.69,13.49),(0.91,13.49),(0.91,13.27),(0.69,13.27)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.68),(3.89,11.9),(4.11,11.9),(4.11,11.68),(3.89,11.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.18),(3.89,12.4),(4.11,12.4),(4.11,12.18),(3.89,12.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.68),(3.89,12.9),(4.11,12.9),(4.11,12.68),(3.89,12.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.18),(3.89,13.4),(4.11,13.4),(4.11,13.18),(3.89,13.18)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.34),(2.9,5.82),(3.06,5.82),(3.06,7.82),(2.38,7.82),(2.38,8.18),(3.06,8.18),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,5.82),(3.5,5.82),(3.5,2.34),(2.9,2.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,2.15),(2.27,10.365),(2.53,10.365),(2.53,8.115),(2.73,8.115),(2.73,7.885),(2.53,7.885),(2.53,2.15),(2.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(10.365),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(10.365),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.45,7.89),(2.45,8.11),(2.67,8.11),(2.67,7.89),(2.45,7.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,4.22),(4.82,4.22),(4.82,4.98),(5.62,4.98),(5.62,4.62),(5.1,4.62),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((4.82,7.82),(4.82,10.18),(4.5,10.18),(4.5,13.82),(5.1,13.82),(5.1,8.18),(5.62,8.18),(5.62,7.82),(4.82,7.82)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.47,2.15),(5.47,4.685),(5.27,4.685),(5.27,4.915),(5.47,4.915),(5.47,7.885),(5.27,7.885),(5.27,8.115),(5.47,8.115),(5.47,13.85),(5.73,13.85),(5.73,2.15),(5.47,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.33,4.69),(5.33,4.91),(5.55,4.91),(5.55,4.69),(5.33,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.33,7.89),(5.33,8.11),(5.55,8.11),(5.55,7.89),(5.33,7.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['powmid_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(11.200000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.685,1.92),(0.685,3.085),(0.63,3.085),(0.63,3.315),(0.97,3.315),(0.97,3.085),(0.915,3.085),(0.915,1.92),(2.285,1.92),(2.285,3.085),(2.23,3.085),(2.23,3.315),(2.57,3.315),(2.57,3.085),(2.515,3.085),(2.515,1.92),(3.885,1.92),(3.885,3.085),(3.83,3.085),(3.83,3.315),(4.17,3.315),(4.17,3.085),(4.115,3.085),(4.115,1.92),(5.485,1.92),(5.485,3.085),(5.43,3.085),(5.43,3.315),(5.77,3.315),(5.77,3.085),(5.715,3.085),(5.715,1.92),(7.085,1.92),(7.085,3.085),(7.03,3.085),(7.03,3.315),(7.37,3.315),(7.37,3.085),(7.315,3.085),(7.315,1.92),(8.685,1.92),(8.685,3.085),(8.63,3.085),(8.63,3.315),(8.97,3.315),(8.97,3.085),(8.915,3.085),(8.915,1.92),(10.285,1.92),(10.285,3.085),(10.23,3.085),(10.23,3.315),(10.57,3.315),(10.57,3.085),(10.515,3.085),(10.515,1.92),(11.2,1.92),(11.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Metal3',
            ((6.08,0.0),(6.08,16.0),(9.92,16.0),(9.92,0.0),(6.08,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal3_Label'),
            u(8.0), u(3.84), u(0.0), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal3'),
            u(8.0), u(3.84), u(0.0), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Metal2',
            ((6.4,0.56),(6.4,1.04),(9.6,1.04),(9.6,0.56),(6.4,0.56)),
        )
        createRL(
            tech, net, 'Via2',
            ((7.47,0.67),(7.47,0.93),(7.73,0.93),(7.73,0.67),(7.47,0.67)),
        )
        createRL(
            tech, net, 'Via2',
            ((9.07,0.67),(9.07,0.93),(9.33,0.93),(9.33,0.67),(9.07,0.67)),
        )
        createRL(
            tech, net, 'Via2',
            ((8.27,0.67),(8.27,0.93),(8.53,0.93),(8.53,0.67),(8.27,0.67)),
        )
        createRL(
            tech, net, 'Via2',
            ((6.67,0.67),(6.67,0.93),(6.93,0.93),(6.93,0.67),(6.67,0.67)),
        )
        Horizontal.create(
            net, tech.getLayer('Metal2_Label'),
            u(0.8), u(0.48), u(6.4), u(9.6),
        )
        pin = Horizontal.create(
            net, tech.getLayer('Metal2'),
            u(0.8), u(0.48), u(6.4), u(9.6),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via1',
            ((7.47,0.67),(7.47,0.93),(7.73,0.93),(7.73,0.67),(7.47,0.67)),
        )
        createRL(
            tech, net, 'Via1',
            ((9.07,0.67),(9.07,0.93),(9.33,0.93),(9.33,0.67),(9.07,0.67)),
        )
        createRL(
            tech, net, 'Via1',
            ((8.27,0.67),(8.27,0.93),(8.53,0.93),(8.53,0.67),(8.27,0.67)),
        )
        createRL(
            tech, net, 'Via1',
            ((6.67,0.67),(6.67,0.93),(6.93,0.93),(6.93,0.67),(6.67,0.67)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.4,2.4),(0.4,13.6),(10.8,13.6),(10.8,2.4),(0.4,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.33),(2.29,1.55),(2.51,1.55),(2.51,1.33),(2.29,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,1.33),(5.49,1.55),(5.71,1.55),(5.71,1.33),(5.49,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,1.33),(8.69,1.55),(8.91,1.55),(8.91,1.33),(8.69,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,3.09),(2.29,3.31),(2.51,3.31),(2.51,3.09),(2.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.33),(3.89,1.55),(4.11,1.55),(4.11,1.33),(3.89,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,3.09),(8.69,3.31),(8.91,3.31),(8.91,3.09),(8.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.33),(10.29,1.55),(10.51,1.55),(10.51,1.33),(10.29,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,3.09),(7.09,3.31),(7.31,3.31),(7.31,3.09),(7.09,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.09),(3.89,3.31),(4.11,3.31),(4.11,3.09),(3.89,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.33),(0.69,1.55),(0.91,1.55),(0.91,1.33),(0.69,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.09),(10.29,3.31),(10.51,3.31),(10.51,3.09),(10.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.09),(5.49,3.31),(5.71,3.31),(5.71,3.09),(5.49,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.33),(7.09,1.55),(7.31,1.55),(7.31,1.33),(7.09,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.8,1.2),(0.8,1.26),(0.62,1.26),(0.62,1.62),(0.8,1.62),(0.8,1.68),(10.4,1.68),(10.4,1.62),(10.58,1.62),(10.58,1.26),(10.4,1.26),(10.4,1.2),(0.8,1.2)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(11.2,16.0),(11.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(11.68,17.28),(11.68,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal2',
            ((1.6,14.96),(1.6,15.44),(4.8,15.44),(4.8,14.96),(1.6,14.96)),
        )
        Horizontal.create(
            net, tech.getLayer('Metal2_Label'),
            u(15.2), u(0.48), u(1.6000000000000003), u(4.8),
        )
        pin = Horizontal.create(
            net, tech.getLayer('Metal2'),
            u(15.2), u(0.48), u(1.6000000000000003), u(4.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via2',
            ((1.87,15.07),(1.87,15.33),(2.13,15.33),(2.13,15.07),(1.87,15.07)),
        )
        createRL(
            tech, net, 'Via2',
            ((2.67,15.07),(2.67,15.33),(2.93,15.33),(2.93,15.07),(2.67,15.07)),
        )
        createRL(
            tech, net, 'Via2',
            ((3.47,15.07),(3.47,15.33),(3.73,15.33),(3.73,15.07),(3.47,15.07)),
        )
        createRL(
            tech, net, 'Via2',
            ((4.27,15.07),(4.27,15.33),(4.53,15.33),(4.53,15.07),(4.27,15.07)),
        )
        createRL(
            tech, net, 'Metal3',
            ((1.28,0.0),(1.28,16.0),(5.12,16.0),(5.12,0.0),(1.28,0.0)),
        )
        createRL(
            tech, net, 'Via1',
            ((1.87,15.07),(1.87,15.33),(2.13,15.33),(2.13,15.07),(1.87,15.07)),
        )
        createRL(
            tech, net, 'Via1',
            ((2.67,15.07),(2.67,15.33),(2.93,15.33),(2.93,15.07),(2.67,15.07)),
        )
        createRL(
            tech, net, 'Via1',
            ((3.47,15.07),(3.47,15.33),(3.73,15.33),(3.73,15.07),(3.47,15.07)),
        )
        createRL(
            tech, net, 'Via1',
            ((4.27,15.07),(4.27,15.33),(4.53,15.33),(4.53,15.07),(4.27,15.07)),
        )
        Vertical.create(
            net, tech.getLayer('Metal3_Label'),
            u(3.2), u(3.84), u(0.0), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal3'),
            u(3.2), u(3.84), u(0.0), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.8,14.32),(0.8,14.38),(0.62,14.38),(0.62,14.74),(0.8,14.74),(0.8,14.8),(10.4,14.8),(10.4,14.74),(10.58,14.74),(10.58,14.38),(10.4,14.38),(10.4,14.32),(0.8,14.32)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.45),(7.09,14.67),(7.31,14.67),(7.31,14.45),(7.09,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.45),(2.29,14.67),(2.51,14.67),(2.51,14.45),(2.29,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,14.45),(5.49,14.67),(5.71,14.67),(5.71,14.45),(5.49,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,14.45),(8.69,14.67),(8.91,14.67),(8.91,14.45),(8.69,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.45),(3.89,14.67),(4.11,14.67),(4.11,14.45),(3.89,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.45),(10.29,14.67),(10.51,14.67),(10.51,14.45),(10.29,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.45),(0.69,14.67),(0.91,14.67),(0.91,14.45),(0.69,14.45)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((0.64,0.97),(0.64,1.03),(0.46,1.03),(0.46,1.85),(0.64,1.85),(0.64,1.91),(10.56,1.91),(10.56,1.85),(10.74,1.85),(10.74,1.03),(10.56,1.03),(10.56,0.97),(0.64,0.97)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.64,14.09),(0.64,14.15),(0.46,14.15),(0.46,14.97),(0.64,14.97),(0.64,15.03),(10.56,15.03),(10.56,14.97),(10.74,14.97),(10.74,14.15),(10.56,14.15),(10.56,14.09),(0.64,14.09)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(11.6,16.4),(11.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(11.205,16.005),(11.205,-0.005),(-0.005,-0.005)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)

    cell = new_cells['sff1_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(24.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_net6': Net.create(cell, '_net6'),
            'ck': Net.create(cell, 'ck'),
            'ckr': Net.create(cell, 'ckr'),
            'i': Net.create(cell, 'i'),
            'nckr': Net.create(cell, 'nckr'),
            'q': Net.create(cell, 'q'),
            'sff_m': Net.create(cell, 'sff_m'),
            'sff_s': Net.create(cell, 'sff_s'),
            'u': Net.create(cell, 'u'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'y': Net.create(cell, 'y'),
        }
        net = nets['nckr']
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.06,4.22),(3.06,7.82),(0.78,7.82),(0.78,8.18),(3.06,8.18),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,8.18),(11.06,8.18),(11.06,10.18),(10.9,10.18),(10.9,13.82),(11.5,13.82),(11.5,10.18),(11.34,10.18),(11.34,8.18),(15.86,8.18),(15.86,10.18),(15.7,10.18),(15.7,13.82),(16.3,13.82),(16.3,10.18),(16.14,10.18),(16.14,8.18),(17.58,8.18),(17.58,4.22),(17.9,4.22),(17.9,2.18),(17.3,2.18),(17.3,7.82),(3.34,7.82),(3.34,4.22),(3.5,4.22),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((9.3,2.18),(9.3,4.22),(9.58,4.22),(9.58,4.98),(9.94,4.98),(9.94,4.62),(9.9,4.62),(9.9,2.18),(9.3,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.59),(0.69,2.81),(0.91,2.81),(0.91,2.59),(0.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.59),(0.69,3.81),(0.91,3.81),(0.91,3.59),(0.69,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.65,4.69),(9.65,4.91),(9.87,4.91),(9.87,4.69),(9.65,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.49,7.89),(9.49,8.11),(9.71,8.11),(9.71,7.89),(9.49,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.64),(0.69,10.86),(0.91,10.86),(0.91,10.64),(0.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.14),(0.69,11.36),(0.91,11.36),(0.91,11.14),(0.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.64),(0.69,11.86),(0.91,11.86),(0.91,11.64),(0.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.14),(0.69,12.36),(0.91,12.36),(0.91,12.14),(0.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.64),(0.69,12.86),(0.91,12.86),(0.91,12.64),(0.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.14),(0.69,13.36),(0.91,13.36),(0.91,13.14),(0.69,13.14)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.585),(0.63,3.815),(0.685,3.815),(0.685,10.635),(0.63,10.635),(0.63,13.365),(0.97,13.365),(0.97,10.635),(0.915,10.635),(0.915,8.115),(1.13,8.115),(1.13,7.885),(0.915,7.885),(0.915,3.815),(0.97,3.815),(0.97,2.585),(0.63,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.485,4.685),(9.485,7.885),(9.43,7.885),(9.43,8.115),(9.77,8.115),(9.77,7.885),(9.715,7.885),(9.715,4.915),(9.93,4.915),(9.93,4.685),(9.485,4.685)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((9.3,2.4),(9.3,4.0),(9.9,4.0),(9.9,2.4),(9.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.0,0.8),(10.0,1.44),(10.8,1.44),(10.8,0.8),(10.0,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((19.82,0.96),(19.82,2.4),(18.9,2.4),(18.9,4.0),(21.1,4.0),(21.1,0.96),(19.82,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((17.3,2.4),(17.3,4.0),(17.9,4.0),(17.9,2.4),(17.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.22,1.1),(2.22,2.4),(1.3,2.4),(1.3,4.0),(3.5,4.0),(3.5,2.4),(2.58,2.4),(2.58,1.1),(2.22,1.1)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.02,1.1),(7.02,2.4),(6.1,2.4),(6.1,4.0),(8.3,4.0),(8.3,2.4),(7.38,2.4),(7.38,1.1),(7.02,1.1)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,0.96),(12.5,2.4),(14.7,2.4),(14.7,0.96),(12.5,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.1,0.96),(22.1,4.0),(23.38,4.0),(23.38,0.96),(22.1,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.7,2.4),(15.7,4.0),(16.3,4.0),(16.3,2.4),(15.7,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((18.0,0.8),(18.0,1.44),(18.8,1.44),(18.8,0.8),(18.0,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,0.8),(3.68,1.44),(4.32,1.44),(4.32,0.8),(3.68,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.9,2.4),(10.9,4.0),(11.5,4.0),(11.5,2.4),(10.9,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(13.43,1.92),(13.43,2.295),(13.77,2.295),(13.77,1.92),(19.83,1.92),(19.83,3.845),(20.17,3.845),(20.17,1.92),(23.03,1.92),(23.03,3.845),(23.37,3.845),(23.37,1.92),(24.0,1.92),(24.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(12.0), u(24.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(12.0), u(24.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((18.29,1.01),(18.29,1.23),(18.51,1.23),(18.51,1.01),(18.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.17),(2.29,1.39),(2.51,1.39),(2.51,1.17),(2.29,1.17)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.01),(3.89,1.23),(4.11,1.23),(4.11,1.01),(3.89,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.01),(10.29,1.23),(10.51,1.23),(10.51,1.01),(10.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,1.07),(13.49,1.29),(13.71,1.29),(13.71,1.07),(13.49,1.07)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,1.57),(13.49,1.79),(13.71,1.79),(13.71,1.57),(13.49,1.57)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,2.07),(13.49,2.29),(13.71,2.29),(13.71,2.07),(13.49,2.07)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,1.12),(23.09,1.34),(23.31,1.34),(23.31,1.12),(23.09,1.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,1.62),(23.09,1.84),(23.31,1.84),(23.31,1.62),(23.09,1.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,2.12),(23.09,2.34),(23.31,2.34),(23.31,2.12),(23.09,2.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,2.62),(23.09,2.84),(23.31,2.84),(23.31,2.62),(23.09,2.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,3.12),(23.09,3.34),(23.31,3.34),(23.31,3.12),(23.09,3.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,3.62),(23.09,3.84),(23.31,3.84),(23.31,3.62),(23.09,3.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.17),(7.09,1.39),(7.31,1.39),(7.31,1.17),(7.09,1.17)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,1.12),(19.89,1.34),(20.11,1.34),(20.11,1.12),(19.89,1.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,1.62),(19.89,1.84),(20.11,1.84),(20.11,1.62),(19.89,1.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,2.12),(19.89,2.34),(20.11,2.34),(20.11,2.12),(19.89,2.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,2.62),(19.89,2.84),(20.11,2.84),(20.11,2.62),(19.89,2.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,3.12),(19.89,3.34),(20.11,3.34),(20.11,3.12),(19.89,3.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,3.62),(19.89,3.84),(20.11,3.84),(20.11,3.62),(19.89,3.62)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((9.84,14.17),(9.84,15.27),(10.96,15.27),(10.96,14.17),(9.84,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.06,0.87),(2.06,2.17),(0.46,2.17),(0.46,4.23),(4.34,4.23),(4.34,2.17),(2.74,2.17),(2.74,0.87),(2.06,0.87)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.4,14.17),(0.4,15.43),(1.2,15.43),(1.2,14.17),(0.4,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((11.69,0.73),(11.69,2.17),(7.54,2.17),(7.54,0.87),(6.86,0.87),(6.86,2.17),(5.26,2.17),(5.26,4.23),(12.31,4.23),(12.31,2.63),(14.86,2.63),(14.86,4.23),(23.54,4.23),(23.54,0.73),(19.66,0.73),(19.66,2.17),(15.54,2.17),(15.54,0.73),(11.69,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((16.24,14.17),(16.24,15.27),(17.36,15.27),(17.36,14.17),(16.24,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.52,14.17),(3.52,15.27),(4.48,15.27),(4.48,14.17),(3.52,14.17)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(24.4,16.4),(24.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(24.005,16.005),(24.005,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((9.84,0.57),(9.84,1.67),(10.96,1.67),(10.96,0.57),(9.84,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((19.66,8.57),(19.66,11.77),(18.71,11.77),(18.71,10.17),(14.86,10.17),(14.86,11.77),(12.31,11.77),(12.31,10.17),(8.49,10.17),(8.49,11.77),(5.26,11.77),(5.26,15.43),(9.11,15.43),(9.11,13.83),(11.69,13.83),(11.69,15.43),(15.54,15.43),(15.54,13.83),(18.09,13.83),(18.09,15.43),(23.54,15.43),(23.54,8.57),(19.66,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        createRL(
            tech, net, 'Pplus',
            ((17.84,0.57),(17.84,1.67),(18.96,1.67),(18.96,0.57),(17.84,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,15.13),(2.74,15.13),(2.74,13.83),(4.34,13.83),(4.34,10.17),(0.46,10.17)),
        )
        createRL(
            tech, net, 'Pplus',
            ((3.52,0.57),(3.52,1.67),(4.48,1.67),(4.48,0.57),(3.52,0.57)),
        )
        net = nets['ck']
        createRL(
            tech, net, 'Poly2',
            ((1.62,9.42),(1.62,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,9.78),(2.42,9.78),(2.42,9.42),(1.62,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.62,4.22),(1.62,4.98),(2.42,4.98),(2.42,4.62),(1.9,4.62),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,2.15),(2.27,4.685),(2.07,4.685),(2.07,4.915),(2.27,4.915),(2.27,9.485),(2.07,9.485),(2.07,9.715),(2.27,9.715),(2.27,13.85),(2.53,13.85),(2.53,2.15),(2.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.13,9.49),(2.13,9.71),(2.35,9.71),(2.35,9.49),(2.13,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.13,4.69),(2.13,4.91),(2.35,4.91),(2.35,4.69),(2.13,4.69)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,14.9),(2.58,14.9),(2.58,13.6),(3.5,13.6),(3.5,10.4),(1.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((17.3,10.4),(17.3,13.6),(17.9,13.6),(17.9,10.4),(17.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((19.82,8.8),(19.82,12.0),(18.9,12.0),(18.9,15.2),(21.1,15.2),(21.1,8.8),(19.82,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.1,8.8),(22.1,15.2),(23.38,15.2),(23.38,8.8),(22.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.7,10.4),(15.7,13.6),(16.3,13.6),(16.3,10.4),(15.7,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,12.0),(12.5,15.2),(14.7,15.2),(14.7,12.0),(12.5,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,12.0),(6.1,15.2),(8.3,15.2),(8.3,12.0),(6.1,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.0,14.4),(10.0,15.04),(10.8,15.04),(10.8,14.4),(10.0,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.3,10.4),(9.3,13.6),(9.9,13.6),(9.9,10.4),(9.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((16.4,14.4),(16.4,15.04),(17.2,15.04),(17.2,14.4),(16.4,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,14.4),(0.56,15.2),(1.04,15.2),(1.04,14.4),(0.56,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,14.4),(3.68,15.04),(4.32,15.04),(4.32,14.4),(3.68,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.9,10.4),(10.9,13.6),(11.5,13.6),(11.5,10.4),(10.9,10.4)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(24.48,17.28),(24.48,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((19.83,8.885),(19.83,14.08),(13.77,14.08),(13.77,12.235),(13.43,12.235),(13.43,14.08),(0.0,14.08),(0.0,16.0),(24.0,16.0),(24.0,14.08),(23.37,14.08),(23.37,8.885),(23.03,8.885),(23.03,14.08),(20.17,14.08),(20.17,8.885),(19.83,8.885)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(12.0), u(24.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(12.0), u(24.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((13.49,12.24),(13.49,12.46),(13.71,12.46),(13.71,12.24),(13.49,12.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,12.74),(13.49,12.96),(13.71,12.96),(13.71,12.74),(13.49,12.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.24),(13.49,13.46),(13.71,13.46),(13.71,13.24),(13.49,13.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.74),(13.49,13.96),(13.71,13.96),(13.71,13.74),(13.49,13.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,14.24),(13.49,14.46),(13.71,14.46),(13.71,14.24),(13.49,14.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,14.74),(13.49,14.96),(13.71,14.96),(13.71,14.74),(13.49,14.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.61),(2.29,14.83),(2.51,14.83),(2.51,14.61),(2.29,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,8.89),(23.09,9.11),(23.31,9.11),(23.31,8.89),(23.09,8.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,9.39),(23.09,9.61),(23.31,9.61),(23.31,9.39),(23.09,9.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,9.89),(23.09,10.11),(23.31,10.11),(23.31,9.89),(23.09,9.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,10.39),(23.09,10.61),(23.31,10.61),(23.31,10.39),(23.09,10.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,10.89),(23.09,11.11),(23.31,11.11),(23.31,10.89),(23.09,10.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,11.39),(23.09,11.61),(23.31,11.61),(23.31,11.39),(23.09,11.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,11.89),(23.09,12.11),(23.31,12.11),(23.31,11.89),(23.09,11.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,12.39),(23.09,12.61),(23.31,12.61),(23.31,12.39),(23.09,12.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,12.89),(23.09,13.11),(23.31,13.11),(23.31,12.89),(23.09,12.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,13.39),(23.09,13.61),(23.31,13.61),(23.31,13.39),(23.09,13.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,13.89),(23.09,14.11),(23.31,14.11),(23.31,13.89),(23.09,13.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,14.39),(23.09,14.61),(23.31,14.61),(23.31,14.39),(23.09,14.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,14.89),(23.09,15.11),(23.31,15.11),(23.31,14.89),(23.09,14.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,8.89),(19.89,9.11),(20.11,9.11),(20.11,8.89),(19.89,8.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,9.39),(19.89,9.61),(20.11,9.61),(20.11,9.39),(19.89,9.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,9.89),(19.89,10.11),(20.11,10.11),(20.11,9.89),(19.89,9.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,10.39),(19.89,10.61),(20.11,10.61),(20.11,10.39),(19.89,10.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,10.89),(19.89,11.11),(20.11,11.11),(20.11,10.89),(19.89,10.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,11.39),(19.89,11.61),(20.11,11.61),(20.11,11.39),(19.89,11.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,11.89),(19.89,12.11),(20.11,12.11),(20.11,11.89),(19.89,11.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,12.39),(19.89,12.61),(20.11,12.61),(20.11,12.39),(19.89,12.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,12.89),(19.89,13.11),(20.11,13.11),(20.11,12.89),(19.89,12.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,13.39),(19.89,13.61),(20.11,13.61),(20.11,13.39),(19.89,13.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,13.89),(19.89,14.11),(20.11,14.11),(20.11,13.89),(19.89,13.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,14.39),(19.89,14.61),(20.11,14.61),(20.11,14.39),(19.89,14.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,14.89),(19.89,15.11),(20.11,15.11),(20.11,14.89),(19.89,14.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.25),(7.09,14.47),(7.31,14.47),(7.31,14.25),(7.09,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.75),(7.09,14.97),(7.31,14.97),(7.31,14.75),(7.09,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.61),(3.89,14.83),(4.11,14.83),(4.11,14.61),(3.89,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,14.61),(16.69,14.83),(16.91,14.83),(16.91,14.61),(16.69,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.61),(10.29,14.83),(10.51,14.83),(10.51,14.61),(10.29,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.61),(0.69,14.83),(0.91,14.83),(0.91,14.61),(0.69,14.61)),
        )
        net = nets['sff_s']
        createRL(
            tech, net, 'COMP',
            ((16.3,2.4),(16.3,4.0),(17.3,4.0),(17.3,2.4),(16.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((16.3,10.4),(16.3,13.6),(17.3,13.6),(17.3,10.4),(16.3,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((20.5,0.74),(20.5,4.22),(20.66,4.22),(20.66,6.22),(20.22,6.22),(20.22,6.58),(20.66,6.58),(20.66,8.58),(20.5,8.58),(20.5,15.42),(21.1,15.42),(21.1,8.58),(20.94,8.58),(20.94,6.58),(22.26,6.58),(22.26,8.58),(22.1,8.58),(22.1,15.42),(22.7,15.42),(22.7,8.58),(22.54,8.58),(22.54,4.22),(22.7,4.22),(22.7,0.74),(22.1,0.74),(22.1,4.22),(22.26,4.22),(22.26,6.22),(20.94,6.22),(20.94,4.22),(21.1,4.22),(21.1,0.74),(20.5,0.74)),
        )
        createRL(
            tech, net, 'Metal1',
            ((16.63,2.15),(16.63,3.815),(16.97,3.815),(16.97,3.315),(18.285,3.315),(18.285,12.685),(16.97,12.685),(16.97,10.635),(16.63,10.635),(16.63,13.85),(16.97,13.85),(16.97,12.915),(18.48,12.915),(18.48,12.88),(18.515,12.88),(18.515,6.515),(20.57,6.515),(20.57,6.285),(18.515,6.285),(18.515,3.12),(18.48,3.12),(18.48,3.085),(16.97,3.085),(16.97,2.15),(16.63,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((20.29,6.29),(20.29,6.51),(20.51,6.51),(20.51,6.29),(20.29,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,10.64),(16.69,10.86),(16.91,10.86),(16.91,10.64),(16.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,11.14),(16.69,11.36),(16.91,11.36),(16.91,11.14),(16.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,11.64),(16.69,11.86),(16.91,11.86),(16.91,11.64),(16.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.14),(16.69,12.36),(16.91,12.36),(16.91,12.14),(16.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.64),(16.69,12.86),(16.91,12.86),(16.91,12.64),(16.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,13.14),(16.69,13.36),(16.91,13.36),(16.91,13.14),(16.69,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,2.59),(16.69,2.81),(16.91,2.81),(16.91,2.59),(16.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.09),(16.69,3.31),(16.91,3.31),(16.91,3.09),(16.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.59),(16.69,3.81),(16.91,3.81),(16.91,3.59),(16.69,3.59)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((17.9,10.4),(17.9,13.6),(18.25,13.6),(18.25,15.2),(18.9,15.2),(18.9,12.0),(18.55,12.0),(18.55,10.4),(17.9,10.4)),
        )
        net = nets['ckr']
        createRL(
            tech, net, 'Poly2',
            ((9.62,9.42),(9.62,10.18),(9.3,10.18),(9.3,13.82),(9.9,13.82),(9.9,9.78),(10.1,9.78),(10.1,9.42),(9.62,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((10.9,2.18),(10.9,6.22),(3.98,6.22),(3.98,6.58),(16.82,6.58),(16.82,6.22),(15.98,6.22),(15.98,4.22),(16.3,4.22),(16.3,2.18),(15.7,2.18),(15.7,6.22),(11.18,6.22),(11.18,4.22),(11.5,4.22),(11.5,2.18),(10.9,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((16.78,9.42),(16.78,9.78),(17.3,9.78),(17.3,13.82),(17.9,13.82),(17.9,10.18),(17.58,10.18),(17.58,9.42),(16.78,9.42)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,4.0),(4.18,4.0),(4.18,2.4),(3.5,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,10.4),(3.5,13.6),(4.18,13.6),(4.18,10.4),(3.5,10.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.05,6.29),(4.05,6.51),(4.27,6.51),(4.27,6.29),(4.05,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.77,6.29),(10.77,6.51),(10.99,6.51),(10.99,6.29),(10.77,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.85,9.49),(16.85,9.71),(17.07,9.71),(17.07,9.49),(16.85,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.53,6.29),(16.53,6.51),(16.75,6.51),(16.75,6.29),(16.53,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.59),(3.89,2.81),(4.11,2.81),(4.11,2.59),(3.89,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.09),(3.89,3.31),(4.11,3.31),(4.11,3.09),(3.89,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.59),(3.89,3.81),(4.11,3.81),(4.11,3.59),(3.89,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.64),(3.89,10.86),(4.11,10.86),(4.11,10.64),(3.89,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.14),(3.89,11.36),(4.11,11.36),(4.11,11.14),(3.89,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.64),(3.89,11.86),(4.11,11.86),(4.11,11.64),(3.89,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.14),(3.89,12.36),(4.11,12.36),(4.11,12.14),(3.89,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.64),(3.89,12.86),(4.11,12.86),(4.11,12.64),(3.89,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.14),(3.89,13.36),(4.11,13.36),(4.11,13.14),(3.89,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.81,9.49),(9.81,9.71),(10.03,9.71),(10.03,9.49),(9.81,9.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((16.47,6.285),(16.47,6.515),(16.685,6.515),(16.685,9.68),(16.79,9.68),(16.79,9.715),(17.13,9.715),(17.13,9.485),(16.915,9.485),(16.915,6.32),(16.81,6.32),(16.81,6.285),(16.47,6.285)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.83,2.15),(3.83,3.815),(3.885,3.815),(3.885,10.635),(3.83,10.635),(3.83,13.85),(4.17,13.85),(4.17,10.635),(4.115,10.635),(4.115,6.515),(4.33,6.515),(4.33,6.285),(4.115,6.285),(4.115,3.815),(4.17,3.815),(4.17,2.15),(3.83,2.15)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.685,6.285),(10.685,9.485),(9.75,9.485),(9.75,9.715),(10.88,9.715),(10.88,9.68),(10.915,9.68),(10.915,6.515),(11.05,6.515),(11.05,6.285),(10.685,6.285)),
        )
        net = nets['sff_m']
        createRL(
            tech, net, 'COMP',
            ((9.9,2.4),(9.9,4.0),(10.9,4.0),(10.9,2.4),(9.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,10.4),(9.9,13.6),(10.9,13.6),(10.9,10.4),(9.9,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((13.82,9.42),(13.82,9.78),(14.1,9.78),(14.1,15.42),(14.7,15.42),(14.7,11.78),(14.38,11.78),(14.38,9.42),(13.82,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((14.1,0.74),(14.1,4.62),(13.82,4.62),(13.82,4.98),(14.38,4.98),(14.38,2.62),(14.7,2.62),(14.7,0.74),(14.1,0.74)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.23,2.585),(10.23,3.815),(10.57,3.815),(10.57,3.315),(11.885,3.315),(11.885,11.885),(10.57,11.885),(10.57,10.635),(10.23,10.635),(10.23,13.365),(10.57,13.365),(10.57,12.115),(12.08,12.115),(12.08,12.08),(12.115,12.08),(12.115,9.715),(14.17,9.715),(14.17,9.485),(12.115,9.485),(12.115,4.915),(14.17,4.915),(14.17,4.685),(12.115,4.685),(12.115,3.12),(12.08,3.12),(12.08,3.085),(10.57,3.085),(10.57,2.585),(10.23,2.585)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.59),(10.29,2.81),(10.51,2.81),(10.51,2.59),(10.29,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.09),(10.29,3.31),(10.51,3.31),(10.51,3.09),(10.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.59),(10.29,3.81),(10.51,3.81),(10.51,3.59),(10.29,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.89,9.49),(13.89,9.71),(14.11,9.71),(14.11,9.49),(13.89,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.64),(10.29,10.86),(10.51,10.86),(10.51,10.64),(10.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.14),(10.29,11.36),(10.51,11.36),(10.51,11.14),(10.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.64),(10.29,11.86),(10.51,11.86),(10.51,11.64),(10.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.14),(10.29,12.36),(10.51,12.36),(10.51,12.14),(10.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.64),(10.29,12.86),(10.51,12.86),(10.51,12.64),(10.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.14),(10.29,13.36),(10.51,13.36),(10.51,13.14),(10.29,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.89,4.69),(13.89,4.91),(14.11,4.91),(14.11,4.69),(13.89,4.69)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'COMP',
            ((11.85,0.96),(11.85,2.4),(11.5,2.4),(11.5,4.0),(12.15,4.0),(12.15,2.4),(12.5,2.4),(12.5,0.96),(11.85,0.96)),
        )
        net = nets['y']
        createRL(
            tech, net, 'COMP',
            ((14.7,0.96),(14.7,2.4),(15.02,2.4),(15.02,4.0),(15.7,4.0),(15.7,2.4),(15.38,2.4),(15.38,0.96),(14.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.02,10.4),(15.02,12.0),(14.7,12.0),(14.7,15.2),(15.38,15.2),(15.38,13.6),(15.7,13.6),(15.7,10.4),(15.02,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((12.5,0.74),(12.5,2.62),(12.82,2.62),(12.82,3.38),(13.3,3.38),(13.3,3.02),(13.1,3.02),(13.1,0.74),(12.5,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((12.82,11.02),(12.82,11.78),(12.5,11.78),(12.5,15.42),(13.1,15.42),(13.1,11.38),(13.3,11.38),(13.3,11.02),(12.82,11.02)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,10.55),(15.09,10.77),(15.31,10.77),(15.31,10.55),(15.09,10.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,11.05),(15.09,11.27),(15.31,11.27),(15.31,11.05),(15.09,11.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,11.55),(15.09,11.77),(15.31,11.77),(15.31,11.55),(15.09,11.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.05),(15.09,12.27),(15.31,12.27),(15.31,12.05),(15.09,12.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.55),(15.09,12.77),(15.31,12.77),(15.31,12.55),(15.09,12.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.05),(15.09,13.27),(15.31,13.27),(15.31,13.05),(15.09,13.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.55),(15.09,13.77),(15.31,13.77),(15.31,13.55),(15.09,13.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,2.18),(15.09,2.4),(15.31,2.4),(15.31,2.18),(15.09,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,2.68),(15.09,2.9),(15.31,2.9),(15.31,2.68),(15.09,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,3.18),(15.09,3.4),(15.31,3.4),(15.31,3.18),(15.09,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,3.68),(15.09,3.9),(15.31,3.9),(15.31,3.68),(15.09,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.01,3.09),(13.01,3.31),(13.23,3.31),(13.23,3.09),(13.01,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.01,11.09),(13.01,11.31),(13.23,11.31),(13.23,11.09),(13.01,11.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((15.03,2.15),(15.03,3.085),(12.95,3.085),(12.95,3.315),(15.03,3.315),(15.03,3.905),(15.085,3.905),(15.085,10.545),(15.03,10.545),(15.03,11.085),(12.95,11.085),(12.95,11.315),(15.03,11.315),(15.03,13.85),(15.37,13.85),(15.37,10.545),(15.315,10.545),(15.315,3.905),(15.37,3.905),(15.37,2.15),(15.03,2.15)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((8.65,10.4),(8.65,12.0),(8.3,12.0),(8.3,15.2),(8.95,15.2),(8.95,13.6),(9.3,13.6),(9.3,10.4),(8.65,10.4)),
        )
        net = nets['u']
        createRL(
            tech, net, 'COMP',
            ((5.42,2.4),(5.42,4.0),(6.1,4.0),(6.1,2.4),(5.42,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,12.0),(5.42,15.2),(6.1,15.2),(6.1,12.0),(5.42,12.0)),
        )
        createRL(
            tech, net, 'Poly2',
            ((5.58,9.42),(5.58,9.78),(7.7,9.78),(7.7,15.42),(8.3,15.42),(8.3,11.78),(7.98,11.78),(7.98,9.78),(8.5,9.78),(8.5,9.42),(5.58,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.7,2.18),(7.7,4.22),(8.02,4.22),(8.02,4.98),(8.5,4.98),(8.5,4.62),(8.3,4.62),(8.3,2.18),(7.7,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.59),(5.49,2.81),(5.71,2.81),(5.71,2.59),(5.49,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.09),(5.49,3.31),(5.71,3.31),(5.71,3.09),(5.49,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.59),(5.49,3.81),(5.71,3.81),(5.71,3.59),(5.49,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.65,9.49),(5.65,9.71),(5.87,9.71),(5.87,9.49),(5.65,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.21,4.69),(8.21,4.91),(8.43,4.91),(8.43,4.69),(8.21,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.21,9.49),(8.21,9.71),(8.43,9.71),(8.43,9.49),(8.21,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.1),(5.49,12.32),(5.71,12.32),(5.71,12.1),(5.49,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.6),(5.49,12.82),(5.71,12.82),(5.71,12.6),(5.49,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.1),(5.49,13.32),(5.71,13.32),(5.71,13.1),(5.49,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.6),(5.49,13.82),(5.71,13.82),(5.71,13.6),(5.49,13.6)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.15,4.685),(8.15,4.915),(8.205,4.915),(8.205,9.485),(8.15,9.485),(8.15,9.715),(8.49,9.715),(8.49,9.485),(8.435,9.485),(8.435,4.915),(8.49,4.915),(8.49,4.685),(8.15,4.685)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,2.15),(5.43,3.815),(5.485,3.815),(5.485,12.095),(5.43,12.095),(5.43,13.85),(5.77,13.85),(5.77,12.095),(5.715,12.095),(5.715,9.715),(5.93,9.715),(5.93,9.485),(5.715,9.485),(5.715,3.815),(5.77,3.815),(5.77,2.15),(5.43,2.15)),
        )
        net = nets['i']
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.18),(6.1,4.22),(6.42,4.22),(6.42,4.98),(7.22,4.98),(7.22,4.62),(6.7,4.62),(6.7,2.18),(6.1,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((6.42,11.02),(6.42,11.78),(6.1,11.78),(6.1,15.42),(6.7,15.42),(6.7,11.38),(7.22,11.38),(7.22,11.02),(6.42,11.02)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.07,2.15),(7.07,4.685),(6.87,4.685),(6.87,4.915),(7.07,4.915),(7.07,11.085),(6.87,11.085),(6.87,11.315),(7.07,11.315),(7.07,13.85),(7.33,13.85),(7.33,2.15),(7.07,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((6.93,4.69),(6.93,4.91),(7.15,4.91),(7.15,4.69),(6.93,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.93,11.09),(6.93,11.31),(7.15,11.31),(7.15,11.09),(6.93,11.09)),
        )
        net = nets['_net5']
        createRL(
            tech, net, 'COMP',
            ((11.5,10.4),(11.5,13.6),(11.85,13.6),(11.85,15.2),(12.5,15.2),(12.5,12.0),(12.15,12.0),(12.15,10.4),(11.5,10.4)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((8.3,2.4),(8.3,4.0),(9.3,4.0),(9.3,2.4),(8.3,2.4)),
        )
        net = nets['_net6']
        createRL(
            tech, net, 'COMP',
            ((17.9,2.4),(17.9,4.0),(18.9,4.0),(18.9,2.4),(17.9,2.4)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Poly2',
            ((19.22,7.82),(19.22,11.78),(18.9,11.78),(18.9,15.42),(19.5,15.42),(19.5,8.18),(19.78,8.18),(19.78,7.82),(19.22,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((18.9,2.18),(18.9,4.22),(19.22,4.22),(19.22,4.98),(19.78,4.98),(19.78,4.62),(19.5,4.62),(19.5,2.18),(18.9,2.18)),
        )
        createRL(
            tech, net, 'COMP',
            ((21.1,8.8),(21.1,15.2),(22.1,15.2),(22.1,8.8),(21.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((21.1,0.96),(21.1,4.0),(22.1,4.0),(22.1,0.96),(21.1,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((21.43,2.15),(21.43,3.905),(21.47,3.905),(21.47,4.685),(19.43,4.685),(19.43,4.915),(21.47,4.915),(21.47,7.885),(19.43,7.885),(19.43,8.115),(21.47,8.115),(21.47,8.995),(21.43,8.995),(21.43,13.85),(21.77,13.85),(21.77,8.995),(21.73,8.995),(21.73,3.905),(21.77,3.905),(21.77,2.15),(21.43,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(21.6), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(21.6), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((19.49,4.69),(19.49,4.91),(19.71,4.91),(19.71,4.69),(19.49,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.49,7.89),(19.49,8.11),(19.71,8.11),(19.71,7.89),(19.49,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,2.18),(21.49,2.4),(21.71,2.4),(21.71,2.18),(21.49,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,2.68),(21.49,2.9),(21.71,2.9),(21.71,2.68),(21.49,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,3.18),(21.49,3.4),(21.71,3.4),(21.71,3.18),(21.49,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,3.68),(21.49,3.9),(21.71,3.9),(21.71,3.68),(21.49,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,9.0),(21.49,9.22),(21.71,9.22),(21.71,9.0),(21.49,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,9.5),(21.49,9.72),(21.71,9.72),(21.71,9.5),(21.49,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,10.0),(21.49,10.22),(21.71,10.22),(21.71,10.0),(21.49,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,10.5),(21.49,10.72),(21.71,10.72),(21.71,10.5),(21.49,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,11.0),(21.49,11.22),(21.71,11.22),(21.71,11.0),(21.49,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,11.5),(21.49,11.72),(21.71,11.72),(21.71,11.5),(21.49,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,12.0),(21.49,12.22),(21.71,12.22),(21.71,12.0),(21.49,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,12.5),(21.49,12.72),(21.71,12.72),(21.71,12.5),(21.49,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,13.0),(21.49,13.22),(21.71,13.22),(21.71,13.0),(21.49,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,13.5),(21.49,13.72),(21.71,13.72),(21.71,13.5),(21.49,13.5)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['ck'].setType(Net.Type.CLOCK)
        nets['ck'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['sff1r_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(28.8), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_net6': Net.create(cell, '_net6'),
            '_net7': Net.create(cell, '_net7'),
            '_net8': Net.create(cell, '_net8'),
            'ck': Net.create(cell, 'ck'),
            'ckr': Net.create(cell, 'ckr'),
            'i': Net.create(cell, 'i'),
            'nckr': Net.create(cell, 'nckr'),
            'nrst': Net.create(cell, 'nrst'),
            'q': Net.create(cell, 'q'),
            'sff_m': Net.create(cell, 'sff_m'),
            'sff_s': Net.create(cell, 'sff_s'),
            'u': Net.create(cell, 'u'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'y': Net.create(cell, 'y'),
        }
        net = nets['nckr']
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.9,2.18),(2.9,4.22),(3.06,4.22),(3.06,7.82),(0.78,7.82),(0.78,8.18),(3.06,8.18),(3.06,10.18),(2.9,10.18),(2.9,13.82),(3.5,13.82),(3.5,10.18),(3.34,10.18),(3.34,8.18),(11.06,8.18),(11.06,10.18),(10.9,10.18),(10.9,13.82),(11.5,13.82),(11.5,10.18),(11.34,10.18),(11.34,8.18),(20.66,8.18),(20.66,10.18),(20.5,10.18),(20.5,13.82),(21.1,13.82),(21.1,10.18),(20.94,10.18),(20.94,7.84),(20.78,7.84),(20.78,4.22),(21.1,4.22),(21.1,2.18),(20.5,2.18),(20.5,7.82),(3.34,7.82),(3.34,4.22),(3.5,4.22),(3.5,2.18),(2.9,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((9.3,2.18),(9.3,4.22),(9.58,4.22),(9.58,4.98),(9.94,4.98),(9.94,4.62),(9.9,4.62),(9.9,2.18),(9.3,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.59),(0.69,2.81),(0.91,2.81),(0.91,2.59),(0.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.59),(0.69,3.81),(0.91,3.81),(0.91,3.59),(0.69,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.65,4.69),(9.65,4.91),(9.87,4.91),(9.87,4.69),(9.65,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.85,7.89),(0.85,8.11),(1.07,8.11),(1.07,7.89),(0.85,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.49,7.89),(9.49,8.11),(9.71,8.11),(9.71,7.89),(9.49,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.64),(0.69,10.86),(0.91,10.86),(0.91,10.64),(0.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.14),(0.69,11.36),(0.91,11.36),(0.91,11.14),(0.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.64),(0.69,11.86),(0.91,11.86),(0.91,11.64),(0.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.14),(0.69,12.36),(0.91,12.36),(0.91,12.14),(0.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.64),(0.69,12.86),(0.91,12.86),(0.91,12.64),(0.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.14),(0.69,13.36),(0.91,13.36),(0.91,13.14),(0.69,13.14)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.585),(0.63,3.815),(0.685,3.815),(0.685,10.635),(0.63,10.635),(0.63,13.365),(0.97,13.365),(0.97,10.635),(0.915,10.635),(0.915,8.115),(1.13,8.115),(1.13,7.885),(0.915,7.885),(0.915,3.815),(0.97,3.815),(0.97,2.585),(0.63,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.485,4.685),(9.485,7.885),(9.43,7.885),(9.43,8.115),(9.77,8.115),(9.77,7.885),(9.715,7.885),(9.715,4.915),(9.93,4.915),(9.93,4.685),(9.485,4.685)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((21.28,14.4),(21.28,15.04),(21.92,15.04),(21.92,14.4),(21.28,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,14.74),(2.58,14.74),(2.58,13.6),(3.5,13.6),(3.5,10.4),(1.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.1,10.4),(22.1,13.6),(22.7,13.6),(22.7,10.4),(22.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.3,10.4),(9.3,13.6),(9.9,13.6),(9.9,10.4),(9.3,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.9,10.4),(10.9,13.6),(11.5,13.6),(11.5,10.4),(10.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((26.9,8.8),(26.9,15.2),(28.18,15.2),(28.18,8.8),(26.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.08,14.4),(10.08,15.04),(10.72,15.04),(10.72,14.4),(10.08,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,14.4),(3.68,15.04),(4.32,15.04),(4.32,14.4),(3.68,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,14.4),(0.56,15.2),(1.04,15.2),(1.04,14.4),(0.56,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((20.5,10.4),(20.5,13.6),(21.1,13.6),(21.1,10.4),(20.5,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,12.0),(12.5,15.2),(14.7,15.2),(14.7,12.0),(12.5,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,12.0),(6.1,15.2),(8.3,15.2),(8.3,12.0),(6.1,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.7,12.0),(15.7,15.2),(17.9,15.2),(17.9,12.0),(15.7,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((24.62,8.8),(24.62,12.0),(23.7,12.0),(23.7,15.2),(25.9,15.2),(25.9,8.8),(24.62,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(29.28,17.28),(29.28,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((24.63,8.885),(24.63,14.08),(16.97,14.08),(16.97,12.235),(16.63,12.235),(16.63,14.08),(13.77,14.08),(13.77,12.235),(13.43,12.235),(13.43,14.08),(0.0,14.08),(0.0,16.0),(28.8,16.0),(28.8,14.08),(28.17,14.08),(28.17,8.885),(27.83,8.885),(27.83,14.08),(24.97,14.08),(24.97,8.885),(24.63,8.885)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(14.4), u(28.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(14.4), u(28.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((24.69,8.89),(24.69,9.11),(24.91,9.11),(24.91,8.89),(24.69,8.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,9.39),(24.69,9.61),(24.91,9.61),(24.91,9.39),(24.69,9.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,9.89),(24.69,10.11),(24.91,10.11),(24.91,9.89),(24.69,9.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,10.39),(24.69,10.61),(24.91,10.61),(24.91,10.39),(24.69,10.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,10.89),(24.69,11.11),(24.91,11.11),(24.91,10.89),(24.69,10.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,11.39),(24.69,11.61),(24.91,11.61),(24.91,11.39),(24.69,11.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,11.89),(24.69,12.11),(24.91,12.11),(24.91,11.89),(24.69,11.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,12.39),(24.69,12.61),(24.91,12.61),(24.91,12.39),(24.69,12.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,12.89),(24.69,13.11),(24.91,13.11),(24.91,12.89),(24.69,12.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,13.39),(24.69,13.61),(24.91,13.61),(24.91,13.39),(24.69,13.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,13.89),(24.69,14.11),(24.91,14.11),(24.91,13.89),(24.69,13.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,14.39),(24.69,14.61),(24.91,14.61),(24.91,14.39),(24.69,14.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,14.89),(24.69,15.11),(24.91,15.11),(24.91,14.89),(24.69,14.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.24),(16.69,12.46),(16.91,12.46),(16.91,12.24),(16.69,12.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,12.74),(16.69,12.96),(16.91,12.96),(16.91,12.74),(16.69,12.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,13.24),(16.69,13.46),(16.91,13.46),(16.91,13.24),(16.69,13.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,13.74),(16.69,13.96),(16.91,13.96),(16.91,13.74),(16.69,13.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,14.24),(16.69,14.46),(16.91,14.46),(16.91,14.24),(16.69,14.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,14.74),(16.69,14.96),(16.91,14.96),(16.91,14.74),(16.69,14.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,12.24),(13.49,12.46),(13.71,12.46),(13.71,12.24),(13.49,12.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,12.74),(13.49,12.96),(13.71,12.96),(13.71,12.74),(13.49,12.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.24),(13.49,13.46),(13.71,13.46),(13.71,13.24),(13.49,13.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,13.74),(13.49,13.96),(13.71,13.96),(13.71,13.74),(13.49,13.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,14.24),(13.49,14.46),(13.71,14.46),(13.71,14.24),(13.49,14.24)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,14.74),(13.49,14.96),(13.71,14.96),(13.71,14.74),(13.49,14.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.45),(2.29,14.67),(2.51,14.67),(2.51,14.45),(2.29,14.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,14.61),(21.49,14.83),(21.71,14.83),(21.71,14.61),(21.49,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.61),(0.69,14.83),(0.91,14.83),(0.91,14.61),(0.69,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,14.61),(3.89,14.83),(4.11,14.83),(4.11,14.61),(3.89,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,8.89),(27.89,9.11),(28.11,9.11),(28.11,8.89),(27.89,8.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,9.39),(27.89,9.61),(28.11,9.61),(28.11,9.39),(27.89,9.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,9.89),(27.89,10.11),(28.11,10.11),(28.11,9.89),(27.89,9.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,10.39),(27.89,10.61),(28.11,10.61),(28.11,10.39),(27.89,10.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,10.89),(27.89,11.11),(28.11,11.11),(28.11,10.89),(27.89,10.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,11.39),(27.89,11.61),(28.11,11.61),(28.11,11.39),(27.89,11.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,11.89),(27.89,12.11),(28.11,12.11),(28.11,11.89),(27.89,11.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,12.39),(27.89,12.61),(28.11,12.61),(28.11,12.39),(27.89,12.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,12.89),(27.89,13.11),(28.11,13.11),(28.11,12.89),(27.89,12.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,13.39),(27.89,13.61),(28.11,13.61),(28.11,13.39),(27.89,13.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,13.89),(27.89,14.11),(28.11,14.11),(28.11,13.89),(27.89,13.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,14.39),(27.89,14.61),(28.11,14.61),(28.11,14.39),(27.89,14.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,14.89),(27.89,15.11),(28.11,15.11),(28.11,14.89),(27.89,14.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.61),(10.29,14.83),(10.51,14.83),(10.51,14.61),(10.29,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.25),(7.09,14.47),(7.31,14.47),(7.31,14.25),(7.09,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,14.75),(7.09,14.97),(7.31,14.97),(7.31,14.75),(7.09,14.75)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((9.92,0.57),(9.92,1.67),(10.88,1.67),(10.88,0.57),(9.92,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,14.97),(2.74,14.97),(2.74,13.83),(4.34,13.83),(4.34,10.17),(0.46,10.17)),
        )
        createRL(
            tech, net, 'Pplus',
            ((22.72,0.57),(22.72,1.67),(23.68,1.67),(23.68,0.57),(22.72,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((24.46,8.57),(24.46,11.77),(23.54,11.77),(23.54,10.17),(19.66,10.17),(19.66,13.83),(22.86,13.83),(22.86,15.43),(28.34,15.43),(28.34,8.57),(24.46,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        createRL(
            tech, net, 'Pplus',
            ((3.52,0.57),(3.52,1.67),(4.48,1.67),(4.48,0.57),(3.52,0.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((8.49,10.17),(8.49,11.77),(5.26,11.77),(5.26,15.43),(9.11,15.43),(9.11,13.83),(11.69,13.83),(11.69,15.43),(18.74,15.43),(18.74,11.77),(12.31,11.77),(12.31,10.17),(8.49,10.17)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(29.2,16.4),(29.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(28.805,16.005),(28.805,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((9.92,14.17),(9.92,15.27),(10.88,15.27),(10.88,14.17),(9.92,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((21.12,14.17),(21.12,15.27),(22.08,15.27),(22.08,14.17),(21.12,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((11.69,0.73),(11.69,2.17),(7.54,2.17),(7.54,1.03),(6.86,1.03),(6.86,2.17),(5.26,2.17),(5.26,4.23),(12.31,4.23),(12.31,2.63),(16.46,2.63),(16.46,4.23),(28.34,4.23),(28.34,0.73),(24.46,0.73),(24.46,2.17),(17.14,2.17),(17.14,0.73),(11.69,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.4,14.17),(0.4,15.43),(1.2,15.43),(1.2,14.17),(0.4,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((3.52,14.17),(3.52,15.27),(4.48,15.27),(4.48,14.17),(3.52,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.06,1.03),(2.06,2.17),(0.46,2.17),(0.46,4.23),(4.34,4.23),(4.34,2.17),(2.74,2.17),(2.74,1.03),(2.06,1.03)),
        )
        net = nets['ck']
        createRL(
            tech, net, 'Poly2',
            ((1.62,9.42),(1.62,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,9.78),(2.58,9.78),(2.58,9.42),(1.62,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,2.18),(1.3,4.22),(1.62,4.22),(1.62,4.98),(2.58,4.98),(2.58,4.62),(1.9,4.62),(1.9,2.18),(1.3,2.18)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,2.15),(2.27,4.685),(2.23,4.685),(2.23,4.915),(2.27,4.915),(2.27,9.485),(2.23,9.485),(2.23,9.715),(2.27,9.715),(2.27,13.85),(2.53,13.85),(2.53,9.715),(2.57,9.715),(2.57,9.485),(2.53,9.485),(2.53,4.915),(2.57,4.915),(2.57,4.685),(2.53,4.685),(2.53,2.15),(2.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,9.49),(2.29,9.71),(2.51,9.71),(2.51,9.49),(2.29,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,4.69),(2.29,4.91),(2.51,4.91),(2.51,4.69),(2.29,4.69)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((7.02,1.26),(7.02,2.4),(6.1,2.4),(6.1,4.0),(8.3,4.0),(8.3,2.4),(7.38,2.4),(7.38,1.26),(7.02,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((12.5,0.96),(12.5,2.4),(14.7,2.4),(14.7,0.96),(12.5,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.08,0.8),(10.08,1.44),(10.72,1.44),(10.72,0.8),(10.08,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.3,2.4),(9.3,4.0),(9.9,4.0),(9.9,2.4),(9.3,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.22,1.26),(2.22,2.4),(1.3,2.4),(1.3,4.0),(3.5,4.0),(3.5,2.4),(2.58,2.4),(2.58,1.26),(2.22,1.26)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.9,2.4),(10.9,4.0),(11.5,4.0),(11.5,2.4),(10.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.1,2.4),(22.1,4.0),(22.7,4.0),(22.7,2.4),(22.1,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((15.7,0.96),(15.7,2.4),(16.3,2.4),(16.3,0.96),(15.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((26.9,0.96),(26.9,4.0),(28.18,4.0),(28.18,0.96),(26.9,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.88,0.8),(22.88,1.44),(23.52,1.44),(23.52,0.8),(22.88,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((20.5,2.4),(20.5,4.0),(21.1,4.0),(21.1,2.4),(20.5,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'COMP',
            ((24.62,0.96),(24.62,2.4),(23.7,2.4),(23.7,4.0),(25.9,4.0),(25.9,0.96),(24.62,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.68,0.8),(3.68,1.44),(4.32,1.44),(4.32,0.8),(3.68,0.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((18.9,2.4),(18.9,4.0),(19.5,4.0),(19.5,2.4),(18.9,2.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(13.43,1.92),(13.43,2.295),(13.77,2.295),(13.77,1.92),(24.63,1.92),(24.63,3.845),(24.97,3.845),(24.97,1.92),(27.83,1.92),(27.83,3.845),(28.17,3.845),(28.17,1.92),(28.8,1.92),(28.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(14.4), u(28.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(14.4), u(28.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,1.33),(2.29,1.55),(2.51,1.55),(2.51,1.33),(2.29,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,1.33),(7.09,1.55),(7.31,1.55),(7.31,1.33),(7.09,1.33)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,1.01),(3.89,1.23),(4.11,1.23),(4.11,1.01),(3.89,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,1.12),(27.89,1.34),(28.11,1.34),(28.11,1.12),(27.89,1.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,1.62),(27.89,1.84),(28.11,1.84),(28.11,1.62),(27.89,1.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,2.12),(27.89,2.34),(28.11,2.34),(28.11,2.12),(27.89,2.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,2.62),(27.89,2.84),(28.11,2.84),(28.11,2.62),(27.89,2.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,3.12),(27.89,3.34),(28.11,3.34),(28.11,3.12),(27.89,3.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((27.89,3.62),(27.89,3.84),(28.11,3.84),(28.11,3.62),(27.89,3.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.01),(10.29,1.23),(10.51,1.23),(10.51,1.01),(10.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,1.07),(13.49,1.29),(13.71,1.29),(13.71,1.07),(13.49,1.07)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,1.57),(13.49,1.79),(13.71,1.79),(13.71,1.57),(13.49,1.57)),
        )
        createRL(
            tech, net, 'Contact',
            ((13.49,2.07),(13.49,2.29),(13.71,2.29),(13.71,2.07),(13.49,2.07)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,1.12),(24.69,1.34),(24.91,1.34),(24.91,1.12),(24.69,1.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,1.62),(24.69,1.84),(24.91,1.84),(24.91,1.62),(24.69,1.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,2.12),(24.69,2.34),(24.91,2.34),(24.91,2.12),(24.69,2.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,2.62),(24.69,2.84),(24.91,2.84),(24.91,2.62),(24.69,2.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,3.12),(24.69,3.34),(24.91,3.34),(24.91,3.12),(24.69,3.12)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.69,3.62),(24.69,3.84),(24.91,3.84),(24.91,3.62),(24.69,3.62)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,1.01),(23.09,1.23),(23.31,1.23),(23.31,1.01),(23.09,1.01)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'COMP',
            ((8.65,10.4),(8.65,12.0),(8.3,12.0),(8.3,15.2),(8.95,15.2),(8.95,13.6),(9.3,13.6),(9.3,10.4),(8.65,10.4)),
        )
        net = nets['sff_m']
        createRL(
            tech, net, 'COMP',
            ((9.9,2.4),(9.9,4.0),(10.9,4.0),(10.9,2.4),(9.9,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,10.4),(9.9,13.6),(10.9,13.6),(10.9,10.4),(9.9,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((14.1,0.74),(14.1,4.62),(14.06,4.62),(14.06,4.98),(14.42,4.98),(14.42,2.62),(14.7,2.62),(14.7,0.74),(14.1,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((14.06,9.42),(14.06,9.78),(14.1,9.78),(14.1,15.42),(14.7,15.42),(14.7,11.78),(14.42,11.78),(14.42,9.42),(14.06,9.42)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.23,2.585),(10.23,3.815),(10.57,3.815),(10.57,3.315),(11.885,3.315),(11.885,11.085),(10.57,11.085),(10.57,10.635),(10.23,10.635),(10.23,13.365),(10.57,13.365),(10.57,11.315),(12.115,11.315),(12.115,9.715),(14.41,9.715),(14.41,9.485),(12.115,9.485),(12.115,4.915),(14.41,4.915),(14.41,4.685),(12.115,4.685),(12.115,3.085),(10.57,3.085),(10.57,2.585),(10.23,2.585)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.59),(10.29,2.81),(10.51,2.81),(10.51,2.59),(10.29,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.09),(10.29,3.31),(10.51,3.31),(10.51,3.09),(10.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.59),(10.29,3.81),(10.51,3.81),(10.51,3.59),(10.29,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.64),(10.29,10.86),(10.51,10.86),(10.51,10.64),(10.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.14),(10.29,11.36),(10.51,11.36),(10.51,11.14),(10.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.64),(10.29,11.86),(10.51,11.86),(10.51,11.64),(10.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.14),(10.29,12.36),(10.51,12.36),(10.51,12.14),(10.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.64),(10.29,12.86),(10.51,12.86),(10.51,12.64),(10.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.14),(10.29,13.36),(10.51,13.36),(10.51,13.14),(10.29,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((14.13,9.49),(14.13,9.71),(14.35,9.71),(14.35,9.49),(14.13,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((14.13,4.69),(14.13,4.91),(14.35,4.91),(14.35,4.69),(14.13,4.69)),
        )
        net = nets['ckr']
        createRL(
            tech, net, 'Poly2',
            ((10.9,2.18),(10.9,4.22),(11.06,4.22),(11.06,6.22),(3.98,6.22),(3.98,6.58),(19.78,6.58),(19.78,6.22),(19.18,6.22),(19.18,4.22),(19.5,4.22),(19.5,2.18),(18.9,2.18),(18.9,6.22),(11.34,6.22),(11.34,4.22),(11.5,4.22),(11.5,2.18),(10.9,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((9.58,9.42),(9.58,10.18),(9.3,10.18),(9.3,13.82),(9.9,13.82),(9.9,9.78),(9.94,9.78),(9.94,9.42),(9.58,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((21.58,7.82),(21.58,8.18),(22.1,8.18),(22.1,13.82),(22.7,13.82),(22.7,10.18),(22.38,10.18),(22.38,7.82),(21.58,7.82)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,2.4),(3.5,4.0),(4.18,4.0),(4.18,2.4),(3.5,2.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,10.4),(3.5,13.6),(4.18,13.6),(4.18,10.4),(3.5,10.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.05,6.29),(4.05,6.51),(4.27,6.51),(4.27,6.29),(4.05,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.69,6.29),(10.69,6.51),(10.91,6.51),(10.91,6.29),(10.69,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.49,6.29),(19.49,6.51),(19.71,6.51),(19.71,6.29),(19.49,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.65,7.89),(21.65,8.11),(21.87,8.11),(21.87,7.89),(21.65,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,2.59),(3.89,2.81),(4.11,2.81),(4.11,2.59),(3.89,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.09),(3.89,3.31),(4.11,3.31),(4.11,3.09),(3.89,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,3.59),(3.89,3.81),(4.11,3.81),(4.11,3.59),(3.89,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.64),(3.89,10.86),(4.11,10.86),(4.11,10.64),(3.89,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.14),(3.89,11.36),(4.11,11.36),(4.11,11.14),(3.89,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.64),(3.89,11.86),(4.11,11.86),(4.11,11.64),(3.89,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.14),(3.89,12.36),(4.11,12.36),(4.11,12.14),(3.89,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.64),(3.89,12.86),(4.11,12.86),(4.11,12.64),(3.89,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.14),(3.89,13.36),(4.11,13.36),(4.11,13.14),(3.89,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((9.65,9.49),(9.65,9.71),(9.87,9.71),(9.87,9.49),(9.65,9.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.83,2.585),(3.83,3.815),(3.885,3.815),(3.885,10.635),(3.83,10.635),(3.83,13.365),(4.17,13.365),(4.17,10.635),(4.115,10.635),(4.115,6.515),(4.33,6.515),(4.33,6.285),(4.115,6.285),(4.115,3.815),(4.17,3.815),(4.17,2.585),(3.83,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.63,6.285),(10.63,6.515),(10.685,6.515),(10.685,9.485),(9.59,9.485),(9.59,9.715),(10.915,9.715),(10.915,6.515),(10.97,6.515),(10.97,6.285),(10.63,6.285)),
        )
        createRL(
            tech, net, 'Metal1',
            ((19.43,6.285),(19.43,6.515),(21.485,6.515),(21.485,8.115),(21.93,8.115),(21.93,7.885),(21.715,7.885),(21.715,6.285),(19.43,6.285)),
        )
        net = nets['y']
        createRL(
            tech, net, 'COMP',
            ((16.3,0.96),(16.3,2.4),(16.62,2.4),(16.62,4.0),(18.9,4.0),(18.9,2.4),(16.98,2.4),(16.98,0.96),(16.3,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((14.7,12.0),(14.7,15.2),(15.7,15.2),(15.7,12.0),(14.7,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((19.82,10.4),(19.82,13.6),(20.5,13.6),(20.5,10.4),(19.82,10.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((12.5,0.74),(12.5,2.62),(12.78,2.62),(12.78,3.38),(13.14,3.38),(13.14,3.02),(13.1,3.02),(13.1,0.74),(12.5,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((12.78,11.02),(12.78,11.78),(12.5,11.78),(12.5,15.42),(13.1,15.42),(13.1,11.38),(13.14,11.38),(13.14,11.02),(12.78,11.02)),
        )
        createRL(
            tech, net, 'Metal1',
            ((16.63,2.15),(16.63,3.085),(12.79,3.085),(12.79,3.315),(12.96,3.315),(12.96,3.36),(15.085,3.36),(15.085,11.085),(12.79,11.085),(12.79,11.315),(15.085,11.315),(15.085,12.095),(15.03,12.095),(15.03,13.85),(15.37,13.85),(15.37,12.095),(15.315,12.095),(15.315,11.315),(19.83,11.315),(19.83,12.455),(20.17,12.455),(20.17,10.595),(19.83,10.595),(19.83,11.085),(15.315,11.085),(15.315,3.315),(16.63,3.315),(16.63,3.905),(16.97,3.905),(16.97,2.15),(16.63,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,2.18),(16.69,2.4),(16.91,2.4),(16.91,2.18),(16.69,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,2.68),(16.69,2.9),(16.91,2.9),(16.91,2.68),(16.69,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.18),(16.69,3.4),(16.91,3.4),(16.91,3.18),(16.69,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((16.69,3.68),(16.69,3.9),(16.91,3.9),(16.91,3.68),(16.69,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((12.85,3.09),(12.85,3.31),(13.07,3.31),(13.07,3.09),(12.85,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.1),(15.09,12.32),(15.31,12.32),(15.31,12.1),(15.09,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,12.6),(15.09,12.82),(15.31,12.82),(15.31,12.6),(15.09,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.1),(15.09,13.32),(15.31,13.32),(15.31,13.1),(15.09,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((15.09,13.6),(15.09,13.82),(15.31,13.82),(15.31,13.6),(15.09,13.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,10.6),(19.89,10.82),(20.11,10.82),(20.11,10.6),(19.89,10.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,11.1),(19.89,11.32),(20.11,11.32),(20.11,11.1),(19.89,11.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,11.6),(19.89,11.82),(20.11,11.82),(20.11,11.6),(19.89,11.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,12.1),(19.89,12.32),(20.11,12.32),(20.11,12.1),(19.89,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((12.85,11.09),(12.85,11.31),(13.07,11.31),(13.07,11.09),(12.85,11.09)),
        )
        net = nets['sff_s']
        createRL(
            tech, net, 'COMP',
            ((21.1,10.4),(21.1,13.6),(22.1,13.6),(22.1,10.4),(21.1,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((19.5,2.4),(19.5,4.0),(20.5,4.0),(20.5,2.4),(19.5,2.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((25.3,0.74),(25.3,4.22),(25.46,4.22),(25.46,6.22),(24.78,6.22),(24.78,6.58),(25.46,6.58),(25.46,8.58),(25.3,8.58),(25.3,15.42),(25.9,15.42),(25.9,8.58),(25.74,8.58),(25.74,6.58),(27.06,6.58),(27.06,8.58),(26.9,8.58),(26.9,15.42),(27.5,15.42),(27.5,8.58),(27.34,8.58),(27.34,4.22),(27.5,4.22),(27.5,0.74),(26.9,0.74),(26.9,4.22),(27.06,4.22),(27.06,6.22),(25.74,6.22),(25.74,4.22),(25.9,4.22),(25.9,0.74),(25.3,0.74)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,10.6),(21.49,10.82),(21.71,10.82),(21.71,10.6),(21.49,10.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,11.1),(21.49,11.32),(21.71,11.32),(21.71,11.1),(21.49,11.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,11.6),(21.49,11.82),(21.71,11.82),(21.71,11.6),(21.49,11.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((21.49,12.1),(21.49,12.32),(21.71,12.32),(21.71,12.1),(21.49,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.85,6.29),(24.85,6.51),(25.07,6.51),(25.07,6.29),(24.85,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,2.59),(19.89,2.81),(20.11,2.81),(20.11,2.59),(19.89,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,3.09),(19.89,3.31),(20.11,3.31),(20.11,3.09),(19.89,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((19.89,3.59),(19.89,3.81),(20.11,3.81),(20.11,3.59),(19.89,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((19.83,2.585),(19.83,3.815),(20.17,3.815),(20.17,3.315),(23.085,3.315),(23.085,9.485),(21.54,9.485),(21.54,10.595),(21.43,10.595),(21.43,12.455),(21.77,12.455),(21.77,9.715),(23.315,9.715),(23.315,6.515),(25.13,6.515),(25.13,6.285),(23.315,6.285),(23.315,3.085),(20.17,3.085),(20.17,2.585),(19.83,2.585)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'COMP',
            ((17.9,12.0),(17.9,15.2),(18.58,15.2),(18.58,12.0),(17.9,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((22.7,10.4),(22.7,13.6),(23.02,13.6),(23.02,15.2),(23.7,15.2),(23.7,12.0),(23.38,12.0),(23.38,10.4),(22.7,10.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,10.55),(23.09,10.77),(23.31,10.77),(23.31,10.55),(23.09,10.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,11.05),(23.09,11.27),(23.31,11.27),(23.31,11.05),(23.09,11.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,11.55),(23.09,11.77),(23.31,11.77),(23.31,11.55),(23.09,11.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,12.05),(23.09,12.27),(23.31,12.27),(23.31,12.05),(23.09,12.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,12.55),(23.09,12.77),(23.31,12.77),(23.31,12.55),(23.09,12.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,13.05),(23.09,13.27),(23.31,13.27),(23.31,13.05),(23.09,13.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((23.09,13.55),(23.09,13.77),(23.31,13.77),(23.31,13.55),(23.09,13.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.29,12.1),(18.29,12.32),(18.51,12.32),(18.51,12.1),(18.29,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.29,12.6),(18.29,12.82),(18.51,12.82),(18.51,12.6),(18.29,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.29,13.1),(18.29,13.32),(18.51,13.32),(18.51,13.1),(18.29,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.29,13.6),(18.29,13.82),(18.51,13.82),(18.51,13.6),(18.29,13.6)),
        )
        createRL(
            tech, net, 'Metal1',
            ((23.03,10.545),(23.03,12.685),(18.57,12.685),(18.57,12.095),(18.23,12.095),(18.23,13.85),(18.57,13.85),(18.57,12.915),(23.03,12.915),(23.03,13.85),(23.37,13.85),(23.37,10.545),(23.03,10.545)),
        )
        net = nets['_net6']
        createRL(
            tech, net, 'COMP',
            ((11.85,0.96),(11.85,2.4),(11.5,2.4),(11.5,4.0),(12.15,4.0),(12.15,2.4),(12.5,2.4),(12.5,0.96),(11.85,0.96)),
        )
        net = nets['u']
        createRL(
            tech, net, 'COMP',
            ((5.42,12.0),(5.42,15.2),(6.1,15.2),(6.1,12.0),(5.42,12.0)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,2.4),(5.42,4.0),(6.1,4.0),(6.1,2.4),(5.42,2.4)),
        )
        createRL(
            tech, net, 'Poly2',
            ((5.58,9.42),(5.58,9.78),(7.7,9.78),(7.7,15.42),(8.3,15.42),(8.3,11.78),(7.98,11.78),(7.98,9.78),(8.42,9.78),(8.42,9.42),(5.58,9.42)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.7,2.18),(7.7,4.22),(8.02,4.22),(8.02,4.98),(8.42,4.98),(8.42,4.62),(8.3,4.62),(8.3,2.18),(7.7,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.59),(5.49,2.81),(5.71,2.81),(5.71,2.59),(5.49,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.09),(5.49,3.31),(5.71,3.31),(5.71,3.09),(5.49,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.59),(5.49,3.81),(5.71,3.81),(5.71,3.59),(5.49,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.65,9.49),(5.65,9.71),(5.87,9.71),(5.87,9.49),(5.65,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.13,4.69),(8.13,4.91),(8.35,4.91),(8.35,4.69),(8.13,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.13,9.49),(8.13,9.71),(8.35,9.71),(8.35,9.49),(8.13,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.1),(5.49,12.32),(5.71,12.32),(5.71,12.1),(5.49,12.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.6),(5.49,12.82),(5.71,12.82),(5.71,12.6),(5.49,12.6)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.1),(5.49,13.32),(5.71,13.32),(5.71,13.1),(5.49,13.1)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,13.6),(5.49,13.82),(5.71,13.82),(5.71,13.6),(5.49,13.6)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.43,2.585),(5.43,3.815),(5.485,3.815),(5.485,12.095),(5.43,12.095),(5.43,13.85),(5.77,13.85),(5.77,12.095),(5.715,12.095),(5.715,9.715),(5.93,9.715),(5.93,9.485),(5.715,9.485),(5.715,3.815),(5.77,3.815),(5.77,2.585),(5.43,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.07,4.685),(8.07,4.915),(8.285,4.915),(8.285,9.485),(8.07,9.485),(8.07,9.715),(8.515,9.715),(8.515,4.685),(8.07,4.685)),
        )
        net = nets['i']
        createRL(
            tech, net, 'Poly2',
            ((6.1,2.18),(6.1,4.22),(6.42,4.22),(6.42,4.98),(7.22,4.98),(7.22,4.62),(6.7,4.62),(6.7,2.18),(6.1,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((6.42,11.02),(6.42,11.78),(6.1,11.78),(6.1,15.42),(6.7,15.42),(6.7,11.38),(7.22,11.38),(7.22,11.02),(6.42,11.02)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.07,2.15),(7.07,4.685),(6.87,4.685),(6.87,4.915),(7.07,4.915),(7.07,11.085),(6.87,11.085),(6.87,11.315),(7.07,11.315),(7.07,13.85),(7.33,13.85),(7.33,2.15),(7.07,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.2), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((6.93,4.69),(6.93,4.91),(7.15,4.91),(7.15,4.69),(6.93,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.93,11.09),(6.93,11.31),(7.15,11.31),(7.15,11.09),(6.93,11.09)),
        )
        net = nets['_net7']
        createRL(
            tech, net, 'COMP',
            ((8.3,2.4),(8.3,4.0),(9.3,4.0),(9.3,2.4),(8.3,2.4)),
        )
        net = nets['_net8']
        createRL(
            tech, net, 'COMP',
            ((21.1,2.4),(21.1,4.0),(22.1,4.0),(22.1,2.4),(21.1,2.4)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((11.5,10.4),(11.5,13.6),(11.85,13.6),(11.85,15.2),(12.5,15.2),(12.5,12.0),(12.15,12.0),(12.15,10.4),(11.5,10.4)),
        )
        net = nets['_net5']
        createRL(
            tech, net, 'COMP',
            ((22.7,2.4),(22.7,4.0),(23.7,4.0),(23.7,2.4),(22.7,2.4)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'Poly2',
            ((22.1,2.18),(22.1,4.62),(22.06,4.62),(22.06,4.98),(22.42,4.98),(22.42,4.22),(22.7,4.22),(22.7,2.18),(22.1,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((15.7,0.74),(15.7,2.62),(16.02,2.62),(16.02,4.98),(18.42,4.98),(18.42,4.62),(16.3,4.62),(16.3,0.74),(15.7,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((16.02,9.42),(16.02,11.78),(15.7,11.78),(15.7,15.42),(16.3,15.42),(16.3,9.78),(17.46,9.78),(17.46,11.78),(17.3,11.78),(17.3,15.42),(17.9,15.42),(17.9,11.78),(17.74,11.78),(17.74,9.78),(18.42,9.78),(18.42,9.42),(16.02,9.42)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.13,9.49),(18.13,9.71),(18.35,9.71),(18.35,9.49),(18.13,9.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((22.13,4.69),(22.13,4.91),(22.35,4.91),(22.35,4.69),(22.13,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((18.13,4.69),(18.13,4.91),(18.35,4.91),(18.35,4.69),(18.13,4.69)),
        )
        createRL(
            tech, net, 'Metal1',
            ((18.27,2.15),(18.27,4.685),(18.07,4.685),(18.07,4.915),(18.27,4.915),(18.27,9.485),(18.07,9.485),(18.07,9.715),(18.27,9.715),(18.27,10.855),(18.53,10.855),(18.53,4.915),(22.41,4.915),(22.41,4.685),(18.53,4.685),(18.53,2.15),(18.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(18.4), u(0.26), u(2.15), u(10.855),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(18.4), u(0.26), u(2.15), u(10.855),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net4']
        createRL(
            tech, net, 'COMP',
            ((14.7,0.96),(14.7,2.4),(15.7,2.4),(15.7,0.96),(14.7,0.96)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Poly2',
            ((23.98,7.82),(23.98,11.78),(23.7,11.78),(23.7,15.42),(24.3,15.42),(24.3,8.18),(24.34,8.18),(24.34,7.82),(23.98,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((23.7,2.18),(23.7,4.22),(23.98,4.22),(23.98,4.98),(24.34,4.98),(24.34,4.62),(24.3,4.62),(24.3,2.18),(23.7,2.18)),
        )
        createRL(
            tech, net, 'COMP',
            ((25.9,8.8),(25.9,15.2),(26.9,15.2),(26.9,8.8),(25.9,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((25.9,0.96),(25.9,4.0),(26.9,4.0),(26.9,0.96),(25.9,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((26.23,2.15),(26.23,3.905),(26.27,3.905),(26.27,4.685),(23.99,4.685),(23.99,4.915),(26.27,4.915),(26.27,7.885),(23.99,7.885),(23.99,8.115),(26.27,8.115),(26.27,8.995),(26.23,8.995),(26.23,13.85),(26.57,13.85),(26.57,8.995),(26.53,8.995),(26.53,3.905),(26.57,3.905),(26.57,2.15),(26.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(26.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(26.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((24.05,7.89),(24.05,8.11),(24.27,8.11),(24.27,7.89),(24.05,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((24.05,4.69),(24.05,4.91),(24.27,4.91),(24.27,4.69),(24.05,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,2.18),(26.29,2.4),(26.51,2.4),(26.51,2.18),(26.29,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,2.68),(26.29,2.9),(26.51,2.9),(26.51,2.68),(26.29,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,3.18),(26.29,3.4),(26.51,3.4),(26.51,3.18),(26.29,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,3.68),(26.29,3.9),(26.51,3.9),(26.51,3.68),(26.29,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,9.0),(26.29,9.22),(26.51,9.22),(26.51,9.0),(26.29,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,9.5),(26.29,9.72),(26.51,9.72),(26.51,9.5),(26.29,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,10.0),(26.29,10.22),(26.51,10.22),(26.51,10.0),(26.29,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,10.5),(26.29,10.72),(26.51,10.72),(26.51,10.5),(26.29,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,11.0),(26.29,11.22),(26.51,11.22),(26.51,11.0),(26.29,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,11.5),(26.29,11.72),(26.51,11.72),(26.51,11.5),(26.29,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,12.0),(26.29,12.22),(26.51,12.22),(26.51,12.0),(26.29,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,12.5),(26.29,12.72),(26.51,12.72),(26.51,12.5),(26.29,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,13.0),(26.29,13.22),(26.51,13.22),(26.51,13.0),(26.29,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((26.29,13.5),(26.29,13.72),(26.51,13.72),(26.51,13.5),(26.29,13.5)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['ck'].setType(Net.Type.CLOCK)
        nets['ck'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['xr2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(11.200000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((5.1,8.8),(5.1,15.2),(6.1,15.2),(6.1,8.8),(5.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.1,0.96),(5.1,4.0),(6.1,4.0),(6.1,0.96),(5.1,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.87,2.15),(3.87,10.4),(4.13,10.4),(4.13,9.84),(5.43,9.84),(5.43,12.455),(5.77,12.455),(5.77,9.045),(5.43,9.045),(5.43,9.36),(4.13,9.36),(4.13,3.315),(5.43,3.315),(5.43,3.905),(5.77,3.905),(5.77,2.15),(5.43,2.15),(5.43,3.085),(4.13,3.085),(4.13,2.15),(3.87,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(0.26), u(2.15), u(10.4),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(0.26), u(2.15), u(10.4),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((5.49,2.18),(5.49,2.4),(5.71,2.4),(5.71,2.18),(5.49,2.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,2.68),(5.49,2.9),(5.71,2.9),(5.71,2.68),(5.49,2.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.18),(5.49,3.4),(5.71,3.4),(5.71,3.18),(5.49,3.18)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,3.68),(5.49,3.9),(5.71,3.9),(5.71,3.68),(5.49,3.68)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.05),(5.49,9.27),(5.71,9.27),(5.71,9.05),(5.49,9.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,9.55),(5.49,9.77),(5.71,9.77),(5.71,9.55),(5.49,9.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.05),(5.49,10.27),(5.71,10.27),(5.71,10.05),(5.49,10.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,10.55),(5.49,10.77),(5.71,10.77),(5.71,10.55),(5.49,10.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.05),(5.49,11.27),(5.71,11.27),(5.71,11.05),(5.49,11.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,11.55),(5.49,11.77),(5.71,11.77),(5.71,11.55),(5.49,11.55)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.49,12.05),(5.49,12.27),(5.71,12.27),(5.71,12.05),(5.49,12.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((2.22,8.8),(2.22,10.4),(1.3,10.4),(1.3,13.6),(2.22,13.6),(2.22,15.2),(3.5,15.2),(3.5,8.8),(2.22,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.16,14.4),(10.16,15.2),(10.64,15.2),(10.64,14.4),(10.16,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,8.8),(4.5,15.2),(5.1,15.2),(5.1,8.8),(4.5,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.1,8.8),(6.1,15.2),(6.7,15.2),(6.7,8.8),(6.1,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,14.4),(0.56,15.2),(1.04,15.2),(1.04,14.4),(0.56,14.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,8.8),(7.7,15.2),(8.98,15.2),(8.98,13.6),(9.9,13.6),(9.9,10.4),(8.98,10.4),(8.98,8.8),(7.7,8.8)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.48,7.68),(-0.48,17.28),(11.68,17.28),(11.68,7.68),(-0.48,7.68)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(11.2,16.0),(11.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,14.25),(8.69,14.47),(8.91,14.47),(8.91,14.25),(8.69,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,14.75),(8.69,14.97),(8.91,14.97),(8.91,14.75),(8.69,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.61),(0.69,14.83),(0.91,14.83),(0.91,14.61),(0.69,14.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.25),(2.29,14.47),(2.51,14.47),(2.51,14.25),(2.29,14.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,14.75),(2.29,14.97),(2.51,14.97),(2.51,14.75),(2.29,14.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,14.61),(10.29,14.83),(10.51,14.83),(10.51,14.61),(10.29,14.61)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'COMP',
            ((6.7,8.8),(6.7,15.2),(7.7,15.2),(7.7,8.8),(6.7,8.8)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.5,8.8),(3.5,15.2),(4.5,15.2),(4.5,8.8),(3.5,8.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,10.88),(3.89,11.1),(4.11,11.1),(4.11,10.88),(3.89,10.88)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.38),(3.89,11.6),(4.11,11.6),(4.11,11.38),(3.89,11.38)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,11.88),(3.89,12.1),(4.11,12.1),(4.11,11.88),(3.89,11.88)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.38),(3.89,12.6),(4.11,12.6),(4.11,12.38),(3.89,12.38)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,12.88),(3.89,13.1),(4.11,13.1),(4.11,12.88),(3.89,12.88)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.89,13.38),(3.89,13.6),(4.11,13.6),(4.11,13.38),(3.89,13.38)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.0),(7.09,9.22),(7.31,9.22),(7.31,9.0),(7.09,9.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,9.5),(7.09,9.72),(7.31,9.72),(7.31,9.5),(7.09,9.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.0),(7.09,10.22),(7.31,10.22),(7.31,10.0),(7.09,10.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,10.5),(7.09,10.72),(7.31,10.72),(7.31,10.5),(7.09,10.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.0),(7.09,11.22),(7.31,11.22),(7.31,11.0),(7.09,11.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,11.5),(7.09,11.72),(7.31,11.72),(7.31,11.5),(7.09,11.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.0),(7.09,12.22),(7.31,12.22),(7.31,12.0),(7.09,12.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,12.5),(7.09,12.72),(7.31,12.72),(7.31,12.5),(7.09,12.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.0),(7.09,13.22),(7.31,13.22),(7.31,13.0),(7.09,13.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.09,13.5),(7.09,13.72),(7.31,13.72),(7.31,13.5),(7.09,13.5)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.03,8.995),(7.03,12.685),(4.17,12.685),(4.17,10.63),(3.83,10.63),(3.83,13.85),(4.17,13.85),(4.17,12.915),(7.03,12.915),(7.03,13.85),(7.37,13.85),(7.37,8.995),(7.03,8.995)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Pplus',
            ((2.06,8.57),(2.06,10.17),(0.46,10.17),(0.46,13.83),(2.06,13.83),(2.06,15.43),(9.14,15.43),(9.14,13.83),(10.74,13.83),(10.74,10.17),(9.14,10.17),(9.14,8.57),(2.06,8.57)),
        )
        createRL(
            tech, net, 'Pplus',
            ((10.0,0.41),(10.0,1.67),(10.8,1.67),(10.8,0.41),(10.0,0.41)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.4,0.41),(0.4,1.67),(1.2,1.67),(1.2,0.41),(0.4,0.41)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(11.6,16.4),(11.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(11.205,16.005),(11.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.06,0.73),(2.06,2.17),(0.46,2.17),(0.46,4.23),(10.74,4.23),(10.74,2.17),(9.14,2.17),(9.14,0.73),(2.06,0.73)),
        )
        createRL(
            tech, net, 'Nplus',
            ((10.0,14.17),(10.0,15.43),(10.8,15.43),(10.8,14.17),(10.0,14.17)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.4,14.17),(0.4,15.43),(1.2,15.43),(1.2,14.17),(0.4,14.17)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Poly2',
            ((6.1,0.74),(6.1,4.22),(6.26,4.22),(6.26,6.22),(0.78,6.22),(0.78,6.58),(6.26,6.58),(6.26,8.58),(6.1,8.58),(6.1,15.42),(6.7,15.42),(6.7,8.58),(6.54,8.58),(6.54,4.22),(6.7,4.22),(6.7,0.74),(6.1,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,10.4),(0.62,13.6),(1.3,13.6),(1.3,10.4),(0.62,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.4),(0.62,4.0),(1.3,4.0),(1.3,2.4),(0.62,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.59),(0.69,2.81),(0.91,2.81),(0.91,2.59),(0.69,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.09),(0.69,3.31),(0.91,3.31),(0.91,3.09),(0.69,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.59),(0.69,3.81),(0.91,3.81),(0.91,3.59),(0.69,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.64),(0.69,10.86),(0.91,10.86),(0.91,10.64),(0.69,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.14),(0.69,11.36),(0.91,11.36),(0.91,11.14),(0.69,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.64),(0.69,11.86),(0.91,11.86),(0.91,11.64),(0.69,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.14),(0.69,12.36),(0.91,12.36),(0.91,12.14),(0.69,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.64),(0.69,12.86),(0.91,12.86),(0.91,12.64),(0.69,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.14),(0.69,13.36),(0.91,13.36),(0.91,13.14),(0.69,13.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.85,6.29),(0.85,6.51),(1.07,6.51),(1.07,6.29),(0.85,6.29)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.585),(0.63,3.815),(0.685,3.815),(0.685,10.635),(0.63,10.635),(0.63,13.365),(0.97,13.365),(0.97,10.635),(0.915,10.635),(0.915,6.515),(1.13,6.515),(1.13,6.285),(0.915,6.285),(0.915,3.815),(0.97,3.815),(0.97,2.585),(0.63,2.585)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((6.1,0.96),(6.1,4.0),(6.7,4.0),(6.7,0.96),(6.1,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.22,0.96),(2.22,2.4),(1.3,2.4),(1.3,4.0),(3.5,4.0),(3.5,0.96),(2.22,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((7.7,0.96),(7.7,4.0),(9.9,4.0),(9.9,2.4),(8.98,2.4),(8.98,0.96),(7.7,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((10.16,0.64),(10.16,1.44),(10.64,1.44),(10.64,0.64),(10.16,0.64)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.5,0.96),(4.5,4.0),(5.1,4.0),(5.1,0.96),(4.5,0.96)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.56,0.64),(0.56,1.44),(1.04,1.44),(1.04,0.64),(0.56,0.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(11.2,1.92),(11.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.6), u(11.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,1.11),(8.69,1.33),(8.91,1.33),(8.91,1.11),(8.69,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,1.61),(8.69,1.83),(8.91,1.83),(8.91,1.61),(8.69,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,1.01),(10.29,1.23),(10.51,1.23),(10.51,1.01),(10.29,1.01)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.11),(2.29,1.33),(2.51,1.33),(2.51,1.11),(2.29,1.11)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,1.61),(2.29,1.83),(2.51,1.83),(2.51,1.61),(2.29,1.61)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.01),(0.69,1.23),(0.91,1.23),(0.91,1.01),(0.69,1.01)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'COMP',
            ((6.7,0.96),(6.7,4.0),(7.7,4.0),(7.7,0.96),(6.7,0.96)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Poly2',
            ((4.82,7.82),(4.82,8.58),(4.5,8.58),(4.5,15.42),(5.1,15.42),(5.1,8.18),(5.62,8.18),(5.62,7.82),(4.82,7.82)),
        )
        createRL(
            tech, net, 'Poly2',
            ((7.7,0.74),(7.7,6.22),(7.66,6.22),(7.66,6.58),(10.42,6.58),(10.42,6.22),(8.3,6.22),(8.3,0.74),(7.7,0.74)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,10.4),(9.9,13.6),(10.58,13.6),(10.58,10.4),(9.9,10.4)),
        )
        createRL(
            tech, net, 'COMP',
            ((9.9,2.4),(9.9,4.0),(10.58,4.0),(10.58,2.4),(9.9,2.4)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,2.59),(10.29,2.81),(10.51,2.81),(10.51,2.59),(10.29,2.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.09),(10.29,3.31),(10.51,3.31),(10.51,3.09),(10.29,3.09)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,3.59),(10.29,3.81),(10.51,3.81),(10.51,3.59),(10.29,3.59)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.73,6.29),(7.73,6.51),(7.95,6.51),(7.95,6.29),(7.73,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.13,6.29),(10.13,6.51),(10.35,6.51),(10.35,6.29),(10.13,6.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.33,7.89),(5.33,8.11),(5.55,8.11),(5.55,7.89),(5.33,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,10.64),(10.29,10.86),(10.51,10.86),(10.51,10.64),(10.29,10.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.14),(10.29,11.36),(10.51,11.36),(10.51,11.14),(10.29,11.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,11.64),(10.29,11.86),(10.51,11.86),(10.51,11.64),(10.29,11.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.14),(10.29,12.36),(10.51,12.36),(10.51,12.14),(10.29,12.14)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,12.64),(10.29,12.86),(10.51,12.86),(10.51,12.64),(10.29,12.64)),
        )
        createRL(
            tech, net, 'Contact',
            ((10.29,13.14),(10.29,13.36),(10.51,13.36),(10.51,13.14),(10.29,13.14)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.23,2.585),(10.23,3.815),(10.285,3.815),(10.285,6.285),(10.07,6.285),(10.07,6.515),(10.285,6.515),(10.285,10.635),(10.23,10.635),(10.23,13.365),(10.57,13.365),(10.57,10.635),(10.515,10.635),(10.515,3.815),(10.57,3.815),(10.57,2.585),(10.23,2.585)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.485,6.285),(5.485,7.885),(5.27,7.885),(5.27,8.115),(5.715,8.115),(5.715,6.515),(8.01,6.515),(8.01,6.285),(5.485,6.285)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((2.9,0.74),(2.9,4.62),(1.9,4.62),(1.9,2.18),(1.3,2.18),(1.3,4.22),(1.62,4.22),(1.62,4.98),(3.18,4.98),(3.18,4.22),(3.5,4.22),(3.5,0.74),(2.9,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.62,7.82),(1.62,10.18),(1.3,10.18),(1.3,13.82),(1.9,13.82),(1.9,8.18),(2.9,8.18),(2.9,15.42),(3.5,15.42),(3.5,8.58),(3.18,8.58),(3.18,7.82),(1.62,7.82)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.27,2.15),(2.27,4.685),(2.23,4.685),(2.23,4.915),(2.27,4.915),(2.27,7.885),(2.23,7.885),(2.23,8.115),(2.27,8.115),(2.27,13.85),(2.53,13.85),(2.53,8.115),(2.57,8.115),(2.57,7.885),(2.53,7.885),(2.53,4.915),(2.57,4.915),(2.57,4.685),(2.53,4.685),(2.53,2.15),(2.27,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((2.29,7.89),(2.29,8.11),(2.51,8.11),(2.51,7.89),(2.29,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.29,4.69),(2.29,4.91),(2.51,4.91),(2.51,4.69),(2.29,4.69)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'COMP',
            ((3.5,0.96),(3.5,4.0),(4.5,4.0),(4.5,0.96),(3.5,0.96)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((4.5,0.74),(4.5,4.22),(4.78,4.22),(4.78,4.98),(5.14,4.98),(5.14,4.62),(5.1,4.62),(5.1,0.74),(4.5,0.74)),
        )
        createRL(
            tech, net, 'Poly2',
            ((9.3,2.18),(9.3,4.62),(8.62,4.62),(8.62,4.98),(9.58,4.98),(9.58,4.22),(9.9,4.22),(9.9,2.18),(9.3,2.18)),
        )
        createRL(
            tech, net, 'Poly2',
            ((8.02,7.82),(8.02,8.58),(7.7,8.58),(7.7,15.42),(8.3,15.42),(8.3,8.18),(9.3,8.18),(9.3,13.82),(9.9,13.82),(9.9,10.18),(9.58,10.18),(9.58,7.82),(8.02,7.82)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.67,2.15),(8.67,4.685),(4.79,4.685),(4.79,4.915),(8.67,4.915),(8.67,7.885),(8.63,7.885),(8.63,8.115),(8.67,8.115),(8.67,13.85),(8.93,13.85),(8.93,8.115),(8.97,8.115),(8.97,7.885),(8.93,7.885),(8.93,4.915),(8.97,4.915),(8.97,4.685),(8.93,4.685),(8.93,2.15),(8.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Contact',
            ((8.69,7.89),(8.69,8.11),(8.91,8.11),(8.91,7.89),(8.69,7.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((8.69,4.69),(8.69,4.91),(8.91,4.91),(8.91,4.69),(8.69,4.69)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.85,4.69),(4.85,4.91),(5.07,4.91),(5.07,4.69),(4.85,4.69)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['fill']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(1.6,16.0),(1.6,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(2.2,16.6),(2.2,7.68),(-0.6,7.68)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(1.6,1.92),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(2.0,16.4),(2.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(1.605,16.005),(1.605,-0.005),(-0.005,-0.005)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(1.6,16.0),(1.6,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(2.2,16.6),(2.2,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,14.71),(0.62,15.57),(0.98,15.57),(0.98,14.71),(0.62,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.78),(0.69,15.0),(0.91,15.0),(0.91,14.78),(0.69,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,15.28),(0.69,15.5),(0.91,15.5),(0.91,15.28),(0.69,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(1.6,1.92),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.62,0.43),(0.62,1.29),(0.98,1.29),(0.98,0.43),(0.62,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,0.5),(0.69,0.72),(0.91,0.72),(0.91,0.5),(0.69,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.0),(0.69,1.22),(0.91,1.22),(0.91,1.0),(0.69,1.0)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(2.0,16.4),(2.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(1.605,16.005),(1.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,0.2),(0.46,1.52),(1.14,1.52),(1.14,0.2),(0.46,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,14.48),(0.46,15.8),(1.14,15.8),(1.14,14.48),(0.46,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.38,8.56),(0.38,14.08),(0.0,14.08),(0.0,16.0),(1.6,16.0),(1.6,14.08),(1.22,14.08),(1.22,8.56),(0.38,8.56)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(2.2,16.6),(2.2,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,8.28),(0.36,15.57),(1.24,15.57),(1.24,8.28),(0.36,8.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,8.565),(0.44,8.785),(0.66,8.785),(0.66,8.565),(0.44,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,8.565),(0.94,8.785),(1.16,8.785),(1.16,8.565),(0.94,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,9.065),(0.44,9.285),(0.66,9.285),(0.66,9.065),(0.44,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,9.065),(0.94,9.285),(1.16,9.285),(1.16,9.065),(0.94,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,9.565),(0.44,9.785),(0.66,9.785),(0.66,9.565),(0.44,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,9.565),(0.94,9.785),(1.16,9.785),(1.16,9.565),(0.94,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,10.065),(0.44,10.285),(0.66,10.285),(0.66,10.065),(0.44,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,10.065),(0.94,10.285),(1.16,10.285),(1.16,10.065),(0.94,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,10.565),(0.44,10.785),(0.66,10.785),(0.66,10.565),(0.44,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,10.565),(0.94,10.785),(1.16,10.785),(1.16,10.565),(0.94,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,11.065),(0.44,11.285),(0.66,11.285),(0.66,11.065),(0.44,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,11.065),(0.94,11.285),(1.16,11.285),(1.16,11.065),(0.94,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,11.565),(0.44,11.785),(0.66,11.785),(0.66,11.565),(0.44,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,11.565),(0.94,11.785),(1.16,11.785),(1.16,11.565),(0.94,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,12.065),(0.44,12.285),(0.66,12.285),(0.66,12.065),(0.44,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,12.065),(0.94,12.285),(1.16,12.285),(1.16,12.065),(0.94,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,12.565),(0.44,12.785),(0.66,12.785),(0.66,12.565),(0.44,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,12.565),(0.94,12.785),(1.16,12.785),(1.16,12.565),(0.94,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,13.065),(0.44,13.285),(0.66,13.285),(0.66,13.065),(0.44,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,13.065),(0.94,13.285),(1.16,13.285),(1.16,13.065),(0.94,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,13.565),(0.44,13.785),(0.66,13.785),(0.66,13.565),(0.44,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,13.565),(0.94,13.785),(1.16,13.785),(1.16,13.565),(0.94,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,14.065),(0.44,14.285),(0.66,14.285),(0.66,14.065),(0.44,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,14.065),(0.94,14.285),(1.16,14.285),(1.16,14.065),(0.94,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,14.565),(0.44,14.785),(0.66,14.785),(0.66,14.565),(0.44,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,14.565),(0.94,14.785),(1.16,14.785),(1.16,14.565),(0.94,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,15.065),(0.44,15.285),(0.66,15.285),(0.66,15.065),(0.44,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,15.065),(0.94,15.285),(1.16,15.285),(1.16,15.065),(0.94,15.065)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.38,1.92),(0.38,6.87),(1.22,6.87),(1.22,1.92),(1.6,1.92),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.36,0.43),(0.36,7.08),(1.24,7.08),(1.24,0.43),(0.36,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,0.645),(0.44,0.865),(0.66,0.865),(0.66,0.645),(0.44,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,0.645),(0.94,0.865),(1.16,0.865),(1.16,0.645),(0.94,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,1.145),(0.44,1.365),(0.66,1.365),(0.66,1.145),(0.44,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,1.145),(0.94,1.365),(1.16,1.365),(1.16,1.145),(0.94,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,1.645),(0.44,1.865),(0.66,1.865),(0.66,1.645),(0.44,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,1.645),(0.94,1.865),(1.16,1.865),(1.16,1.645),(0.94,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,2.145),(0.44,2.365),(0.66,2.365),(0.66,2.145),(0.44,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,2.145),(0.94,2.365),(1.16,2.365),(1.16,2.145),(0.94,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,2.645),(0.44,2.865),(0.66,2.865),(0.66,2.645),(0.44,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,2.645),(0.94,2.865),(1.16,2.865),(1.16,2.645),(0.94,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,3.145),(0.44,3.365),(0.66,3.365),(0.66,3.145),(0.44,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,3.145),(0.94,3.365),(1.16,3.365),(1.16,3.145),(0.94,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,3.645),(0.44,3.865),(0.66,3.865),(0.66,3.645),(0.44,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,3.645),(0.94,3.865),(1.16,3.865),(1.16,3.645),(0.94,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,4.145),(0.44,4.365),(0.66,4.365),(0.66,4.145),(0.44,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,4.145),(0.94,4.365),(1.16,4.365),(1.16,4.145),(0.94,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,4.645),(0.44,4.865),(0.66,4.865),(0.66,4.645),(0.44,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,4.645),(0.94,4.865),(1.16,4.865),(1.16,4.645),(0.94,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,5.145),(0.44,5.365),(0.66,5.365),(0.66,5.145),(0.44,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,5.145),(0.94,5.365),(1.16,5.365),(1.16,5.145),(0.94,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,5.645),(0.44,5.865),(0.66,5.865),(0.66,5.645),(0.44,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,5.645),(0.94,5.865),(1.16,5.865),(1.16,5.645),(0.94,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,6.145),(0.44,6.365),(0.66,6.365),(0.66,6.145),(0.44,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,6.145),(0.94,6.365),(1.16,6.365),(1.16,6.145),(0.94,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.44,6.645),(0.44,6.865),(0.66,6.865),(0.66,6.645),(0.44,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.94,6.645),(0.94,6.865),(1.16,6.865),(1.16,6.645),(0.94,6.645)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(2.0,16.4),(2.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(1.605,16.005),(1.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,0.2),(0.2,7.31),(1.4,7.31),(1.4,0.2),(0.2,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,8.05),(0.2,15.8),(1.4,15.8),(1.4,8.05),(0.2,8.05)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(1.6,16.0),(1.6,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(2.2,16.6),(2.2,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,14.71),(0.62,15.57),(0.98,15.57),(0.98,14.71),(0.62,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.78),(0.69,15.0),(0.91,15.0),(0.91,14.78),(0.69,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,15.28),(0.69,15.5),(0.91,15.5),(0.91,15.28),(0.69,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(1.6,1.92),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.62,0.43),(0.62,1.29),(0.98,1.29),(0.98,0.43),(0.62,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,0.5),(0.69,0.72),(0.91,0.72),(0.91,0.5),(0.69,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.0),(0.69,1.22),(0.91,1.22),(0.91,1.0),(0.69,1.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.66),(0.69,1.88),(0.91,1.88),(0.91,1.66),(0.69,1.66)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.12,1.59),(0.12,14.41),(1.48,14.41),(1.48,1.59),(0.12,1.59)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(2.0,16.4),(2.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(1.605,16.005),(1.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,0.2),(0.46,1.52),(1.14,1.52),(1.14,0.2),(0.46,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,14.48),(0.46,15.8),(1.14,15.8),(1.14,14.48),(0.46,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.42,14.71),(1.42,15.57),(1.78,15.57),(1.78,14.71),(1.42,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,14.78),(1.49,15.0),(1.71,15.0),(1.71,14.78),(1.49,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,15.28),(1.49,15.5),(1.71,15.5),(1.71,15.28),(1.49,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((1.42,0.43),(1.42,1.29),(1.78,1.29),(1.78,0.43),(1.42,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,0.5),(1.49,0.72),(1.71,0.72),(1.71,0.5),(1.49,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,1.0),(1.49,1.22),(1.71,1.22),(1.71,1.0),(1.49,1.0)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.26,0.2),(1.26,1.52),(1.94,1.52),(1.94,0.2),(1.26,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.26,14.48),(1.26,15.8),(1.94,15.8),(1.94,14.48),(1.26,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.43,8.56),(0.43,14.08),(0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(2.77,14.08),(2.77,8.56),(0.43,8.56)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,8.28),(0.36,15.57),(2.84,15.57),(2.84,8.28),(0.36,8.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,8.565),(0.49,8.785),(0.71,8.785),(0.71,8.565),(0.49,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,8.565),(0.99,8.785),(1.21,8.785),(1.21,8.565),(0.99,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,8.565),(1.49,8.785),(1.71,8.785),(1.71,8.565),(1.49,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,8.565),(1.99,8.785),(2.21,8.785),(2.21,8.565),(1.99,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,8.565),(2.49,8.785),(2.71,8.785),(2.71,8.565),(2.49,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,9.065),(0.49,9.285),(0.71,9.285),(0.71,9.065),(0.49,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,9.065),(0.99,9.285),(1.21,9.285),(1.21,9.065),(0.99,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,9.065),(1.49,9.285),(1.71,9.285),(1.71,9.065),(1.49,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,9.065),(1.99,9.285),(2.21,9.285),(2.21,9.065),(1.99,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,9.065),(2.49,9.285),(2.71,9.285),(2.71,9.065),(2.49,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,9.565),(0.49,9.785),(0.71,9.785),(0.71,9.565),(0.49,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,9.565),(0.99,9.785),(1.21,9.785),(1.21,9.565),(0.99,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,9.565),(1.49,9.785),(1.71,9.785),(1.71,9.565),(1.49,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,9.565),(1.99,9.785),(2.21,9.785),(2.21,9.565),(1.99,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,9.565),(2.49,9.785),(2.71,9.785),(2.71,9.565),(2.49,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,10.065),(0.49,10.285),(0.71,10.285),(0.71,10.065),(0.49,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,10.065),(0.99,10.285),(1.21,10.285),(1.21,10.065),(0.99,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,10.065),(1.49,10.285),(1.71,10.285),(1.71,10.065),(1.49,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,10.065),(1.99,10.285),(2.21,10.285),(2.21,10.065),(1.99,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,10.065),(2.49,10.285),(2.71,10.285),(2.71,10.065),(2.49,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,10.565),(0.49,10.785),(0.71,10.785),(0.71,10.565),(0.49,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,10.565),(0.99,10.785),(1.21,10.785),(1.21,10.565),(0.99,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,10.565),(1.49,10.785),(1.71,10.785),(1.71,10.565),(1.49,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,10.565),(1.99,10.785),(2.21,10.785),(2.21,10.565),(1.99,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,10.565),(2.49,10.785),(2.71,10.785),(2.71,10.565),(2.49,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,11.065),(0.49,11.285),(0.71,11.285),(0.71,11.065),(0.49,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,11.065),(0.99,11.285),(1.21,11.285),(1.21,11.065),(0.99,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,11.065),(1.49,11.285),(1.71,11.285),(1.71,11.065),(1.49,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,11.065),(1.99,11.285),(2.21,11.285),(2.21,11.065),(1.99,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,11.065),(2.49,11.285),(2.71,11.285),(2.71,11.065),(2.49,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,11.565),(0.49,11.785),(0.71,11.785),(0.71,11.565),(0.49,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,11.565),(0.99,11.785),(1.21,11.785),(1.21,11.565),(0.99,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,11.565),(1.49,11.785),(1.71,11.785),(1.71,11.565),(1.49,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,11.565),(1.99,11.785),(2.21,11.785),(2.21,11.565),(1.99,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,11.565),(2.49,11.785),(2.71,11.785),(2.71,11.565),(2.49,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,12.065),(0.49,12.285),(0.71,12.285),(0.71,12.065),(0.49,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,12.065),(0.99,12.285),(1.21,12.285),(1.21,12.065),(0.99,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,12.065),(1.49,12.285),(1.71,12.285),(1.71,12.065),(1.49,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,12.065),(1.99,12.285),(2.21,12.285),(2.21,12.065),(1.99,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,12.065),(2.49,12.285),(2.71,12.285),(2.71,12.065),(2.49,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,12.565),(0.49,12.785),(0.71,12.785),(0.71,12.565),(0.49,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,12.565),(0.99,12.785),(1.21,12.785),(1.21,12.565),(0.99,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,12.565),(1.49,12.785),(1.71,12.785),(1.71,12.565),(1.49,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,12.565),(1.99,12.785),(2.21,12.785),(2.21,12.565),(1.99,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,12.565),(2.49,12.785),(2.71,12.785),(2.71,12.565),(2.49,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,13.065),(0.49,13.285),(0.71,13.285),(0.71,13.065),(0.49,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,13.065),(0.99,13.285),(1.21,13.285),(1.21,13.065),(0.99,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,13.065),(1.49,13.285),(1.71,13.285),(1.71,13.065),(1.49,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,13.065),(1.99,13.285),(2.21,13.285),(2.21,13.065),(1.99,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,13.065),(2.49,13.285),(2.71,13.285),(2.71,13.065),(2.49,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,13.565),(0.49,13.785),(0.71,13.785),(0.71,13.565),(0.49,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,13.565),(0.99,13.785),(1.21,13.785),(1.21,13.565),(0.99,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,13.565),(1.49,13.785),(1.71,13.785),(1.71,13.565),(1.49,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,13.565),(1.99,13.785),(2.21,13.785),(2.21,13.565),(1.99,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,13.565),(2.49,13.785),(2.71,13.785),(2.71,13.565),(2.49,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,14.065),(0.49,14.285),(0.71,14.285),(0.71,14.065),(0.49,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,14.065),(0.99,14.285),(1.21,14.285),(1.21,14.065),(0.99,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,14.065),(1.49,14.285),(1.71,14.285),(1.71,14.065),(1.49,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,14.065),(1.99,14.285),(2.21,14.285),(2.21,14.065),(1.99,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,14.065),(2.49,14.285),(2.71,14.285),(2.71,14.065),(2.49,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,14.565),(0.49,14.785),(0.71,14.785),(0.71,14.565),(0.49,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,14.565),(0.99,14.785),(1.21,14.785),(1.21,14.565),(0.99,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,14.565),(1.49,14.785),(1.71,14.785),(1.71,14.565),(1.49,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,14.565),(1.99,14.785),(2.21,14.785),(2.21,14.565),(1.99,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,14.565),(2.49,14.785),(2.71,14.785),(2.71,14.565),(2.49,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,15.065),(0.49,15.285),(0.71,15.285),(0.71,15.065),(0.49,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,15.065),(0.99,15.285),(1.21,15.285),(1.21,15.065),(0.99,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,15.065),(1.49,15.285),(1.71,15.285),(1.71,15.065),(1.49,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,15.065),(1.99,15.285),(2.21,15.285),(2.21,15.065),(1.99,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,15.065),(2.49,15.285),(2.71,15.285),(2.71,15.065),(2.49,15.065)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.43,1.92),(0.43,6.87),(2.77,6.87),(2.77,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.36,0.43),(0.36,7.08),(2.84,7.08),(2.84,0.43),(0.36,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,0.645),(0.49,0.865),(0.71,0.865),(0.71,0.645),(0.49,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,0.645),(0.99,0.865),(1.21,0.865),(1.21,0.645),(0.99,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,0.645),(1.49,0.865),(1.71,0.865),(1.71,0.645),(1.49,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,0.645),(1.99,0.865),(2.21,0.865),(2.21,0.645),(1.99,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,0.645),(2.49,0.865),(2.71,0.865),(2.71,0.645),(2.49,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,1.145),(0.49,1.365),(0.71,1.365),(0.71,1.145),(0.49,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,1.145),(0.99,1.365),(1.21,1.365),(1.21,1.145),(0.99,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,1.145),(1.49,1.365),(1.71,1.365),(1.71,1.145),(1.49,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,1.145),(1.99,1.365),(2.21,1.365),(2.21,1.145),(1.99,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,1.145),(2.49,1.365),(2.71,1.365),(2.71,1.145),(2.49,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,1.645),(0.49,1.865),(0.71,1.865),(0.71,1.645),(0.49,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,1.645),(0.99,1.865),(1.21,1.865),(1.21,1.645),(0.99,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,1.645),(1.49,1.865),(1.71,1.865),(1.71,1.645),(1.49,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,1.645),(1.99,1.865),(2.21,1.865),(2.21,1.645),(1.99,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,1.645),(2.49,1.865),(2.71,1.865),(2.71,1.645),(2.49,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,2.145),(0.49,2.365),(0.71,2.365),(0.71,2.145),(0.49,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,2.145),(0.99,2.365),(1.21,2.365),(1.21,2.145),(0.99,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,2.145),(1.49,2.365),(1.71,2.365),(1.71,2.145),(1.49,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,2.145),(1.99,2.365),(2.21,2.365),(2.21,2.145),(1.99,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,2.145),(2.49,2.365),(2.71,2.365),(2.71,2.145),(2.49,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,2.645),(0.49,2.865),(0.71,2.865),(0.71,2.645),(0.49,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,2.645),(0.99,2.865),(1.21,2.865),(1.21,2.645),(0.99,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,2.645),(1.49,2.865),(1.71,2.865),(1.71,2.645),(1.49,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,2.645),(1.99,2.865),(2.21,2.865),(2.21,2.645),(1.99,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,2.645),(2.49,2.865),(2.71,2.865),(2.71,2.645),(2.49,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,3.145),(0.49,3.365),(0.71,3.365),(0.71,3.145),(0.49,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,3.145),(0.99,3.365),(1.21,3.365),(1.21,3.145),(0.99,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,3.145),(1.49,3.365),(1.71,3.365),(1.71,3.145),(1.49,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,3.145),(1.99,3.365),(2.21,3.365),(2.21,3.145),(1.99,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,3.145),(2.49,3.365),(2.71,3.365),(2.71,3.145),(2.49,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,3.645),(0.49,3.865),(0.71,3.865),(0.71,3.645),(0.49,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,3.645),(0.99,3.865),(1.21,3.865),(1.21,3.645),(0.99,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,3.645),(1.49,3.865),(1.71,3.865),(1.71,3.645),(1.49,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,3.645),(1.99,3.865),(2.21,3.865),(2.21,3.645),(1.99,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,3.645),(2.49,3.865),(2.71,3.865),(2.71,3.645),(2.49,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,4.145),(0.49,4.365),(0.71,4.365),(0.71,4.145),(0.49,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,4.145),(0.99,4.365),(1.21,4.365),(1.21,4.145),(0.99,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,4.145),(1.49,4.365),(1.71,4.365),(1.71,4.145),(1.49,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,4.145),(1.99,4.365),(2.21,4.365),(2.21,4.145),(1.99,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,4.145),(2.49,4.365),(2.71,4.365),(2.71,4.145),(2.49,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,4.645),(0.49,4.865),(0.71,4.865),(0.71,4.645),(0.49,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,4.645),(0.99,4.865),(1.21,4.865),(1.21,4.645),(0.99,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,4.645),(1.49,4.865),(1.71,4.865),(1.71,4.645),(1.49,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,4.645),(1.99,4.865),(2.21,4.865),(2.21,4.645),(1.99,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,4.645),(2.49,4.865),(2.71,4.865),(2.71,4.645),(2.49,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,5.145),(0.49,5.365),(0.71,5.365),(0.71,5.145),(0.49,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,5.145),(0.99,5.365),(1.21,5.365),(1.21,5.145),(0.99,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,5.145),(1.49,5.365),(1.71,5.365),(1.71,5.145),(1.49,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,5.145),(1.99,5.365),(2.21,5.365),(2.21,5.145),(1.99,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,5.145),(2.49,5.365),(2.71,5.365),(2.71,5.145),(2.49,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,5.645),(0.49,5.865),(0.71,5.865),(0.71,5.645),(0.49,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,5.645),(0.99,5.865),(1.21,5.865),(1.21,5.645),(0.99,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,5.645),(1.49,5.865),(1.71,5.865),(1.71,5.645),(1.49,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,5.645),(1.99,5.865),(2.21,5.865),(2.21,5.645),(1.99,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,5.645),(2.49,5.865),(2.71,5.865),(2.71,5.645),(2.49,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,6.145),(0.49,6.365),(0.71,6.365),(0.71,6.145),(0.49,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,6.145),(0.99,6.365),(1.21,6.365),(1.21,6.145),(0.99,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,6.145),(1.49,6.365),(1.71,6.365),(1.71,6.145),(1.49,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,6.145),(1.99,6.365),(2.21,6.365),(2.21,6.145),(1.99,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,6.145),(2.49,6.365),(2.71,6.365),(2.71,6.145),(2.49,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.49,6.645),(0.49,6.865),(0.71,6.865),(0.71,6.645),(0.49,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.99,6.645),(0.99,6.865),(1.21,6.865),(1.21,6.645),(0.99,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,6.645),(1.49,6.865),(1.71,6.865),(1.71,6.645),(1.49,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.99,6.645),(1.99,6.865),(2.21,6.865),(2.21,6.645),(1.99,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.49,6.645),(2.49,6.865),(2.71,6.865),(2.71,6.645),(2.49,6.645)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,0.2),(0.2,7.31),(3.0,7.31),(3.0,0.2),(0.2,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,8.05),(0.2,15.8),(3.0,15.8),(3.0,8.05),(0.2,8.05)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.42,14.71),(1.42,15.57),(1.78,15.57),(1.78,14.71),(1.42,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,14.78),(1.49,15.0),(1.71,15.0),(1.71,14.78),(1.49,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,15.28),(1.49,15.5),(1.71,15.5),(1.71,15.28),(1.49,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((1.42,0.43),(1.42,1.29),(1.78,1.29),(1.78,0.43),(1.42,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,0.5),(1.49,0.72),(1.71,0.72),(1.71,0.5),(1.49,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,1.0),(1.49,1.22),(1.71,1.22),(1.71,1.0),(1.49,1.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.49,1.66),(1.49,1.88),(1.71,1.88),(1.71,1.66),(1.49,1.66)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.12,1.59),(0.12,14.41),(3.08,14.41),(3.08,1.59),(0.12,1.59)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.26,0.2),(1.26,1.52),(1.94,1.52),(1.94,0.2),(1.26,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((1.26,14.48),(1.26,15.8),(1.94,15.8),(1.94,14.48),(1.26,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.02,14.71),(3.02,15.57),(3.38,15.57),(3.38,14.71),(3.02,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,14.78),(3.09,15.0),(3.31,15.0),(3.31,14.78),(3.09,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,15.28),(3.09,15.5),(3.31,15.5),(3.31,15.28),(3.09,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((3.02,0.43),(3.02,1.29),(3.38,1.29),(3.38,0.43),(3.02,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,0.5),(3.09,0.72),(3.31,0.72),(3.31,0.5),(3.09,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,1.0),(3.09,1.22),(3.31,1.22),(3.31,1.0),(3.09,1.0)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((2.86,0.2),(2.86,1.52),(3.54,1.52),(3.54,0.2),(2.86,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.86,14.48),(2.86,15.8),(3.54,15.8),(3.54,14.48),(2.86,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.53,8.56),(0.53,14.08),(0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(5.87,14.08),(5.87,8.56),(0.53,8.56)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,8.28),(0.36,15.57),(6.04,15.57),(6.04,8.28),(0.36,8.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,8.565),(0.59,8.785),(0.81,8.785),(0.81,8.565),(0.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,8.565),(1.09,8.785),(1.31,8.785),(1.31,8.565),(1.09,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,8.565),(1.59,8.785),(1.81,8.785),(1.81,8.565),(1.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,8.565),(2.09,8.785),(2.31,8.785),(2.31,8.565),(2.09,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,8.565),(2.59,8.785),(2.81,8.785),(2.81,8.565),(2.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,8.565),(3.09,8.785),(3.31,8.785),(3.31,8.565),(3.09,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,8.565),(3.59,8.785),(3.81,8.785),(3.81,8.565),(3.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,8.565),(4.09,8.785),(4.31,8.785),(4.31,8.565),(4.09,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,8.565),(4.59,8.785),(4.81,8.785),(4.81,8.565),(4.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,8.565),(5.09,8.785),(5.31,8.785),(5.31,8.565),(5.09,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,8.565),(5.59,8.785),(5.81,8.785),(5.81,8.565),(5.59,8.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,9.065),(0.59,9.285),(0.81,9.285),(0.81,9.065),(0.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,9.065),(1.09,9.285),(1.31,9.285),(1.31,9.065),(1.09,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,9.065),(1.59,9.285),(1.81,9.285),(1.81,9.065),(1.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,9.065),(2.09,9.285),(2.31,9.285),(2.31,9.065),(2.09,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,9.065),(2.59,9.285),(2.81,9.285),(2.81,9.065),(2.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,9.065),(3.09,9.285),(3.31,9.285),(3.31,9.065),(3.09,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,9.065),(3.59,9.285),(3.81,9.285),(3.81,9.065),(3.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,9.065),(4.09,9.285),(4.31,9.285),(4.31,9.065),(4.09,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,9.065),(4.59,9.285),(4.81,9.285),(4.81,9.065),(4.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,9.065),(5.09,9.285),(5.31,9.285),(5.31,9.065),(5.09,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,9.065),(5.59,9.285),(5.81,9.285),(5.81,9.065),(5.59,9.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,9.565),(0.59,9.785),(0.81,9.785),(0.81,9.565),(0.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,9.565),(1.09,9.785),(1.31,9.785),(1.31,9.565),(1.09,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,9.565),(1.59,9.785),(1.81,9.785),(1.81,9.565),(1.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,9.565),(2.09,9.785),(2.31,9.785),(2.31,9.565),(2.09,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,9.565),(2.59,9.785),(2.81,9.785),(2.81,9.565),(2.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,9.565),(3.09,9.785),(3.31,9.785),(3.31,9.565),(3.09,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,9.565),(3.59,9.785),(3.81,9.785),(3.81,9.565),(3.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,9.565),(4.09,9.785),(4.31,9.785),(4.31,9.565),(4.09,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,9.565),(4.59,9.785),(4.81,9.785),(4.81,9.565),(4.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,9.565),(5.09,9.785),(5.31,9.785),(5.31,9.565),(5.09,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,9.565),(5.59,9.785),(5.81,9.785),(5.81,9.565),(5.59,9.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,10.065),(0.59,10.285),(0.81,10.285),(0.81,10.065),(0.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,10.065),(1.09,10.285),(1.31,10.285),(1.31,10.065),(1.09,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,10.065),(1.59,10.285),(1.81,10.285),(1.81,10.065),(1.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,10.065),(2.09,10.285),(2.31,10.285),(2.31,10.065),(2.09,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,10.065),(2.59,10.285),(2.81,10.285),(2.81,10.065),(2.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,10.065),(3.09,10.285),(3.31,10.285),(3.31,10.065),(3.09,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,10.065),(3.59,10.285),(3.81,10.285),(3.81,10.065),(3.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,10.065),(4.09,10.285),(4.31,10.285),(4.31,10.065),(4.09,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,10.065),(4.59,10.285),(4.81,10.285),(4.81,10.065),(4.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,10.065),(5.09,10.285),(5.31,10.285),(5.31,10.065),(5.09,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,10.065),(5.59,10.285),(5.81,10.285),(5.81,10.065),(5.59,10.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,10.565),(0.59,10.785),(0.81,10.785),(0.81,10.565),(0.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,10.565),(1.09,10.785),(1.31,10.785),(1.31,10.565),(1.09,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,10.565),(1.59,10.785),(1.81,10.785),(1.81,10.565),(1.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,10.565),(2.09,10.785),(2.31,10.785),(2.31,10.565),(2.09,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,10.565),(2.59,10.785),(2.81,10.785),(2.81,10.565),(2.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,10.565),(3.09,10.785),(3.31,10.785),(3.31,10.565),(3.09,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,10.565),(3.59,10.785),(3.81,10.785),(3.81,10.565),(3.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,10.565),(4.09,10.785),(4.31,10.785),(4.31,10.565),(4.09,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,10.565),(4.59,10.785),(4.81,10.785),(4.81,10.565),(4.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,10.565),(5.09,10.785),(5.31,10.785),(5.31,10.565),(5.09,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,10.565),(5.59,10.785),(5.81,10.785),(5.81,10.565),(5.59,10.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,11.065),(0.59,11.285),(0.81,11.285),(0.81,11.065),(0.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,11.065),(1.09,11.285),(1.31,11.285),(1.31,11.065),(1.09,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,11.065),(1.59,11.285),(1.81,11.285),(1.81,11.065),(1.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,11.065),(2.09,11.285),(2.31,11.285),(2.31,11.065),(2.09,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,11.065),(2.59,11.285),(2.81,11.285),(2.81,11.065),(2.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,11.065),(3.09,11.285),(3.31,11.285),(3.31,11.065),(3.09,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,11.065),(3.59,11.285),(3.81,11.285),(3.81,11.065),(3.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,11.065),(4.09,11.285),(4.31,11.285),(4.31,11.065),(4.09,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,11.065),(4.59,11.285),(4.81,11.285),(4.81,11.065),(4.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,11.065),(5.09,11.285),(5.31,11.285),(5.31,11.065),(5.09,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,11.065),(5.59,11.285),(5.81,11.285),(5.81,11.065),(5.59,11.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,11.565),(0.59,11.785),(0.81,11.785),(0.81,11.565),(0.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,11.565),(1.09,11.785),(1.31,11.785),(1.31,11.565),(1.09,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,11.565),(1.59,11.785),(1.81,11.785),(1.81,11.565),(1.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,11.565),(2.09,11.785),(2.31,11.785),(2.31,11.565),(2.09,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,11.565),(2.59,11.785),(2.81,11.785),(2.81,11.565),(2.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,11.565),(3.09,11.785),(3.31,11.785),(3.31,11.565),(3.09,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,11.565),(3.59,11.785),(3.81,11.785),(3.81,11.565),(3.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,11.565),(4.09,11.785),(4.31,11.785),(4.31,11.565),(4.09,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,11.565),(4.59,11.785),(4.81,11.785),(4.81,11.565),(4.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,11.565),(5.09,11.785),(5.31,11.785),(5.31,11.565),(5.09,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,11.565),(5.59,11.785),(5.81,11.785),(5.81,11.565),(5.59,11.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,12.065),(0.59,12.285),(0.81,12.285),(0.81,12.065),(0.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,12.065),(1.09,12.285),(1.31,12.285),(1.31,12.065),(1.09,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,12.065),(1.59,12.285),(1.81,12.285),(1.81,12.065),(1.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,12.065),(2.09,12.285),(2.31,12.285),(2.31,12.065),(2.09,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,12.065),(2.59,12.285),(2.81,12.285),(2.81,12.065),(2.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,12.065),(3.09,12.285),(3.31,12.285),(3.31,12.065),(3.09,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,12.065),(3.59,12.285),(3.81,12.285),(3.81,12.065),(3.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,12.065),(4.09,12.285),(4.31,12.285),(4.31,12.065),(4.09,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,12.065),(4.59,12.285),(4.81,12.285),(4.81,12.065),(4.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,12.065),(5.09,12.285),(5.31,12.285),(5.31,12.065),(5.09,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,12.065),(5.59,12.285),(5.81,12.285),(5.81,12.065),(5.59,12.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,12.565),(0.59,12.785),(0.81,12.785),(0.81,12.565),(0.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,12.565),(1.09,12.785),(1.31,12.785),(1.31,12.565),(1.09,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,12.565),(1.59,12.785),(1.81,12.785),(1.81,12.565),(1.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,12.565),(2.09,12.785),(2.31,12.785),(2.31,12.565),(2.09,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,12.565),(2.59,12.785),(2.81,12.785),(2.81,12.565),(2.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,12.565),(3.09,12.785),(3.31,12.785),(3.31,12.565),(3.09,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,12.565),(3.59,12.785),(3.81,12.785),(3.81,12.565),(3.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,12.565),(4.09,12.785),(4.31,12.785),(4.31,12.565),(4.09,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,12.565),(4.59,12.785),(4.81,12.785),(4.81,12.565),(4.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,12.565),(5.09,12.785),(5.31,12.785),(5.31,12.565),(5.09,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,12.565),(5.59,12.785),(5.81,12.785),(5.81,12.565),(5.59,12.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,13.065),(0.59,13.285),(0.81,13.285),(0.81,13.065),(0.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,13.065),(1.09,13.285),(1.31,13.285),(1.31,13.065),(1.09,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,13.065),(1.59,13.285),(1.81,13.285),(1.81,13.065),(1.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,13.065),(2.09,13.285),(2.31,13.285),(2.31,13.065),(2.09,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,13.065),(2.59,13.285),(2.81,13.285),(2.81,13.065),(2.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,13.065),(3.09,13.285),(3.31,13.285),(3.31,13.065),(3.09,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,13.065),(3.59,13.285),(3.81,13.285),(3.81,13.065),(3.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,13.065),(4.09,13.285),(4.31,13.285),(4.31,13.065),(4.09,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,13.065),(4.59,13.285),(4.81,13.285),(4.81,13.065),(4.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,13.065),(5.09,13.285),(5.31,13.285),(5.31,13.065),(5.09,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,13.065),(5.59,13.285),(5.81,13.285),(5.81,13.065),(5.59,13.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,13.565),(0.59,13.785),(0.81,13.785),(0.81,13.565),(0.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,13.565),(1.09,13.785),(1.31,13.785),(1.31,13.565),(1.09,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,13.565),(1.59,13.785),(1.81,13.785),(1.81,13.565),(1.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,13.565),(2.09,13.785),(2.31,13.785),(2.31,13.565),(2.09,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,13.565),(2.59,13.785),(2.81,13.785),(2.81,13.565),(2.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,13.565),(3.09,13.785),(3.31,13.785),(3.31,13.565),(3.09,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,13.565),(3.59,13.785),(3.81,13.785),(3.81,13.565),(3.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,13.565),(4.09,13.785),(4.31,13.785),(4.31,13.565),(4.09,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,13.565),(4.59,13.785),(4.81,13.785),(4.81,13.565),(4.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,13.565),(5.09,13.785),(5.31,13.785),(5.31,13.565),(5.09,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,13.565),(5.59,13.785),(5.81,13.785),(5.81,13.565),(5.59,13.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,14.065),(0.59,14.285),(0.81,14.285),(0.81,14.065),(0.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,14.065),(1.09,14.285),(1.31,14.285),(1.31,14.065),(1.09,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,14.065),(1.59,14.285),(1.81,14.285),(1.81,14.065),(1.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,14.065),(2.09,14.285),(2.31,14.285),(2.31,14.065),(2.09,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,14.065),(2.59,14.285),(2.81,14.285),(2.81,14.065),(2.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,14.065),(3.09,14.285),(3.31,14.285),(3.31,14.065),(3.09,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,14.065),(3.59,14.285),(3.81,14.285),(3.81,14.065),(3.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,14.065),(4.09,14.285),(4.31,14.285),(4.31,14.065),(4.09,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,14.065),(4.59,14.285),(4.81,14.285),(4.81,14.065),(4.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,14.065),(5.09,14.285),(5.31,14.285),(5.31,14.065),(5.09,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,14.065),(5.59,14.285),(5.81,14.285),(5.81,14.065),(5.59,14.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,14.565),(0.59,14.785),(0.81,14.785),(0.81,14.565),(0.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,14.565),(1.09,14.785),(1.31,14.785),(1.31,14.565),(1.09,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,14.565),(1.59,14.785),(1.81,14.785),(1.81,14.565),(1.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,14.565),(2.09,14.785),(2.31,14.785),(2.31,14.565),(2.09,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,14.565),(2.59,14.785),(2.81,14.785),(2.81,14.565),(2.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,14.565),(3.09,14.785),(3.31,14.785),(3.31,14.565),(3.09,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,14.565),(3.59,14.785),(3.81,14.785),(3.81,14.565),(3.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,14.565),(4.09,14.785),(4.31,14.785),(4.31,14.565),(4.09,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,14.565),(4.59,14.785),(4.81,14.785),(4.81,14.565),(4.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,14.565),(5.09,14.785),(5.31,14.785),(5.31,14.565),(5.09,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,14.565),(5.59,14.785),(5.81,14.785),(5.81,14.565),(5.59,14.565)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,15.065),(0.59,15.285),(0.81,15.285),(0.81,15.065),(0.59,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,15.065),(1.09,15.285),(1.31,15.285),(1.31,15.065),(1.09,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,15.065),(1.59,15.285),(1.81,15.285),(1.81,15.065),(1.59,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,15.065),(2.09,15.285),(2.31,15.285),(2.31,15.065),(2.09,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,15.065),(2.59,15.285),(2.81,15.285),(2.81,15.065),(2.59,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,15.065),(3.09,15.285),(3.31,15.285),(3.31,15.065),(3.09,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,15.065),(3.59,15.285),(3.81,15.285),(3.81,15.065),(3.59,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,15.065),(4.09,15.285),(4.31,15.285),(4.31,15.065),(4.09,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,15.065),(4.59,15.285),(4.81,15.285),(4.81,15.065),(4.59,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,15.065),(5.09,15.285),(5.31,15.285),(5.31,15.065),(5.09,15.065)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,15.065),(5.59,15.285),(5.81,15.285),(5.81,15.065),(5.59,15.065)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.53,1.92),(0.53,6.87),(5.87,6.87),(5.87,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.36,0.43),(0.36,7.08),(6.04,7.08),(6.04,0.43),(0.36,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,0.645),(0.59,0.865),(0.81,0.865),(0.81,0.645),(0.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,0.645),(1.09,0.865),(1.31,0.865),(1.31,0.645),(1.09,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,0.645),(1.59,0.865),(1.81,0.865),(1.81,0.645),(1.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,0.645),(2.09,0.865),(2.31,0.865),(2.31,0.645),(2.09,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,0.645),(2.59,0.865),(2.81,0.865),(2.81,0.645),(2.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,0.645),(3.09,0.865),(3.31,0.865),(3.31,0.645),(3.09,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,0.645),(3.59,0.865),(3.81,0.865),(3.81,0.645),(3.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,0.645),(4.09,0.865),(4.31,0.865),(4.31,0.645),(4.09,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,0.645),(4.59,0.865),(4.81,0.865),(4.81,0.645),(4.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,0.645),(5.09,0.865),(5.31,0.865),(5.31,0.645),(5.09,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,0.645),(5.59,0.865),(5.81,0.865),(5.81,0.645),(5.59,0.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,1.145),(0.59,1.365),(0.81,1.365),(0.81,1.145),(0.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,1.145),(1.09,1.365),(1.31,1.365),(1.31,1.145),(1.09,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,1.145),(1.59,1.365),(1.81,1.365),(1.81,1.145),(1.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,1.145),(2.09,1.365),(2.31,1.365),(2.31,1.145),(2.09,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,1.145),(2.59,1.365),(2.81,1.365),(2.81,1.145),(2.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,1.145),(3.09,1.365),(3.31,1.365),(3.31,1.145),(3.09,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,1.145),(3.59,1.365),(3.81,1.365),(3.81,1.145),(3.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,1.145),(4.09,1.365),(4.31,1.365),(4.31,1.145),(4.09,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,1.145),(4.59,1.365),(4.81,1.365),(4.81,1.145),(4.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,1.145),(5.09,1.365),(5.31,1.365),(5.31,1.145),(5.09,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,1.145),(5.59,1.365),(5.81,1.365),(5.81,1.145),(5.59,1.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,1.645),(0.59,1.865),(0.81,1.865),(0.81,1.645),(0.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,1.645),(1.09,1.865),(1.31,1.865),(1.31,1.645),(1.09,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,1.645),(1.59,1.865),(1.81,1.865),(1.81,1.645),(1.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,1.645),(2.09,1.865),(2.31,1.865),(2.31,1.645),(2.09,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,1.645),(2.59,1.865),(2.81,1.865),(2.81,1.645),(2.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,1.645),(3.09,1.865),(3.31,1.865),(3.31,1.645),(3.09,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,1.645),(3.59,1.865),(3.81,1.865),(3.81,1.645),(3.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,1.645),(4.09,1.865),(4.31,1.865),(4.31,1.645),(4.09,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,1.645),(4.59,1.865),(4.81,1.865),(4.81,1.645),(4.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,1.645),(5.09,1.865),(5.31,1.865),(5.31,1.645),(5.09,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,1.645),(5.59,1.865),(5.81,1.865),(5.81,1.645),(5.59,1.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,2.145),(0.59,2.365),(0.81,2.365),(0.81,2.145),(0.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,2.145),(1.09,2.365),(1.31,2.365),(1.31,2.145),(1.09,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,2.145),(1.59,2.365),(1.81,2.365),(1.81,2.145),(1.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,2.145),(2.09,2.365),(2.31,2.365),(2.31,2.145),(2.09,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,2.145),(2.59,2.365),(2.81,2.365),(2.81,2.145),(2.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,2.145),(3.09,2.365),(3.31,2.365),(3.31,2.145),(3.09,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,2.145),(3.59,2.365),(3.81,2.365),(3.81,2.145),(3.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,2.145),(4.09,2.365),(4.31,2.365),(4.31,2.145),(4.09,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,2.145),(4.59,2.365),(4.81,2.365),(4.81,2.145),(4.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,2.145),(5.09,2.365),(5.31,2.365),(5.31,2.145),(5.09,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,2.145),(5.59,2.365),(5.81,2.365),(5.81,2.145),(5.59,2.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,2.645),(0.59,2.865),(0.81,2.865),(0.81,2.645),(0.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,2.645),(1.09,2.865),(1.31,2.865),(1.31,2.645),(1.09,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,2.645),(1.59,2.865),(1.81,2.865),(1.81,2.645),(1.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,2.645),(2.09,2.865),(2.31,2.865),(2.31,2.645),(2.09,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,2.645),(2.59,2.865),(2.81,2.865),(2.81,2.645),(2.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,2.645),(3.09,2.865),(3.31,2.865),(3.31,2.645),(3.09,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,2.645),(3.59,2.865),(3.81,2.865),(3.81,2.645),(3.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,2.645),(4.09,2.865),(4.31,2.865),(4.31,2.645),(4.09,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,2.645),(4.59,2.865),(4.81,2.865),(4.81,2.645),(4.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,2.645),(5.09,2.865),(5.31,2.865),(5.31,2.645),(5.09,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,2.645),(5.59,2.865),(5.81,2.865),(5.81,2.645),(5.59,2.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,3.145),(0.59,3.365),(0.81,3.365),(0.81,3.145),(0.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,3.145),(1.09,3.365),(1.31,3.365),(1.31,3.145),(1.09,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,3.145),(1.59,3.365),(1.81,3.365),(1.81,3.145),(1.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,3.145),(2.09,3.365),(2.31,3.365),(2.31,3.145),(2.09,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,3.145),(2.59,3.365),(2.81,3.365),(2.81,3.145),(2.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,3.145),(3.09,3.365),(3.31,3.365),(3.31,3.145),(3.09,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,3.145),(3.59,3.365),(3.81,3.365),(3.81,3.145),(3.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,3.145),(4.09,3.365),(4.31,3.365),(4.31,3.145),(4.09,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,3.145),(4.59,3.365),(4.81,3.365),(4.81,3.145),(4.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,3.145),(5.09,3.365),(5.31,3.365),(5.31,3.145),(5.09,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,3.145),(5.59,3.365),(5.81,3.365),(5.81,3.145),(5.59,3.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,3.645),(0.59,3.865),(0.81,3.865),(0.81,3.645),(0.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,3.645),(1.09,3.865),(1.31,3.865),(1.31,3.645),(1.09,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,3.645),(1.59,3.865),(1.81,3.865),(1.81,3.645),(1.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,3.645),(2.09,3.865),(2.31,3.865),(2.31,3.645),(2.09,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,3.645),(2.59,3.865),(2.81,3.865),(2.81,3.645),(2.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,3.645),(3.09,3.865),(3.31,3.865),(3.31,3.645),(3.09,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,3.645),(3.59,3.865),(3.81,3.865),(3.81,3.645),(3.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,3.645),(4.09,3.865),(4.31,3.865),(4.31,3.645),(4.09,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,3.645),(4.59,3.865),(4.81,3.865),(4.81,3.645),(4.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,3.645),(5.09,3.865),(5.31,3.865),(5.31,3.645),(5.09,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,3.645),(5.59,3.865),(5.81,3.865),(5.81,3.645),(5.59,3.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,4.145),(0.59,4.365),(0.81,4.365),(0.81,4.145),(0.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,4.145),(1.09,4.365),(1.31,4.365),(1.31,4.145),(1.09,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,4.145),(1.59,4.365),(1.81,4.365),(1.81,4.145),(1.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,4.145),(2.09,4.365),(2.31,4.365),(2.31,4.145),(2.09,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,4.145),(2.59,4.365),(2.81,4.365),(2.81,4.145),(2.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,4.145),(3.09,4.365),(3.31,4.365),(3.31,4.145),(3.09,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,4.145),(3.59,4.365),(3.81,4.365),(3.81,4.145),(3.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,4.145),(4.09,4.365),(4.31,4.365),(4.31,4.145),(4.09,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,4.145),(4.59,4.365),(4.81,4.365),(4.81,4.145),(4.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,4.145),(5.09,4.365),(5.31,4.365),(5.31,4.145),(5.09,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,4.145),(5.59,4.365),(5.81,4.365),(5.81,4.145),(5.59,4.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,4.645),(0.59,4.865),(0.81,4.865),(0.81,4.645),(0.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,4.645),(1.09,4.865),(1.31,4.865),(1.31,4.645),(1.09,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,4.645),(1.59,4.865),(1.81,4.865),(1.81,4.645),(1.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,4.645),(2.09,4.865),(2.31,4.865),(2.31,4.645),(2.09,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,4.645),(2.59,4.865),(2.81,4.865),(2.81,4.645),(2.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,4.645),(3.09,4.865),(3.31,4.865),(3.31,4.645),(3.09,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,4.645),(3.59,4.865),(3.81,4.865),(3.81,4.645),(3.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,4.645),(4.09,4.865),(4.31,4.865),(4.31,4.645),(4.09,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,4.645),(4.59,4.865),(4.81,4.865),(4.81,4.645),(4.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,4.645),(5.09,4.865),(5.31,4.865),(5.31,4.645),(5.09,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,4.645),(5.59,4.865),(5.81,4.865),(5.81,4.645),(5.59,4.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,5.145),(0.59,5.365),(0.81,5.365),(0.81,5.145),(0.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,5.145),(1.09,5.365),(1.31,5.365),(1.31,5.145),(1.09,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,5.145),(1.59,5.365),(1.81,5.365),(1.81,5.145),(1.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,5.145),(2.09,5.365),(2.31,5.365),(2.31,5.145),(2.09,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,5.145),(2.59,5.365),(2.81,5.365),(2.81,5.145),(2.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,5.145),(3.09,5.365),(3.31,5.365),(3.31,5.145),(3.09,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,5.145),(3.59,5.365),(3.81,5.365),(3.81,5.145),(3.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,5.145),(4.09,5.365),(4.31,5.365),(4.31,5.145),(4.09,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,5.145),(4.59,5.365),(4.81,5.365),(4.81,5.145),(4.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,5.145),(5.09,5.365),(5.31,5.365),(5.31,5.145),(5.09,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,5.145),(5.59,5.365),(5.81,5.365),(5.81,5.145),(5.59,5.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,5.645),(0.59,5.865),(0.81,5.865),(0.81,5.645),(0.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,5.645),(1.09,5.865),(1.31,5.865),(1.31,5.645),(1.09,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,5.645),(1.59,5.865),(1.81,5.865),(1.81,5.645),(1.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,5.645),(2.09,5.865),(2.31,5.865),(2.31,5.645),(2.09,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,5.645),(2.59,5.865),(2.81,5.865),(2.81,5.645),(2.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,5.645),(3.09,5.865),(3.31,5.865),(3.31,5.645),(3.09,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,5.645),(3.59,5.865),(3.81,5.865),(3.81,5.645),(3.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,5.645),(4.09,5.865),(4.31,5.865),(4.31,5.645),(4.09,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,5.645),(4.59,5.865),(4.81,5.865),(4.81,5.645),(4.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,5.645),(5.09,5.865),(5.31,5.865),(5.31,5.645),(5.09,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,5.645),(5.59,5.865),(5.81,5.865),(5.81,5.645),(5.59,5.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,6.145),(0.59,6.365),(0.81,6.365),(0.81,6.145),(0.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,6.145),(1.09,6.365),(1.31,6.365),(1.31,6.145),(1.09,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,6.145),(1.59,6.365),(1.81,6.365),(1.81,6.145),(1.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,6.145),(2.09,6.365),(2.31,6.365),(2.31,6.145),(2.09,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,6.145),(2.59,6.365),(2.81,6.365),(2.81,6.145),(2.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,6.145),(3.09,6.365),(3.31,6.365),(3.31,6.145),(3.09,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,6.145),(3.59,6.365),(3.81,6.365),(3.81,6.145),(3.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,6.145),(4.09,6.365),(4.31,6.365),(4.31,6.145),(4.09,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,6.145),(4.59,6.365),(4.81,6.365),(4.81,6.145),(4.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,6.145),(5.09,6.365),(5.31,6.365),(5.31,6.145),(5.09,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,6.145),(5.59,6.365),(5.81,6.365),(5.81,6.145),(5.59,6.145)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.59,6.645),(0.59,6.865),(0.81,6.865),(0.81,6.645),(0.59,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.09,6.645),(1.09,6.865),(1.31,6.865),(1.31,6.645),(1.09,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.59,6.645),(1.59,6.865),(1.81,6.865),(1.81,6.645),(1.59,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.09,6.645),(2.09,6.865),(2.31,6.865),(2.31,6.645),(2.09,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.59,6.645),(2.59,6.865),(2.81,6.865),(2.81,6.645),(2.59,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,6.645),(3.09,6.865),(3.31,6.865),(3.31,6.645),(3.09,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.59,6.645),(3.59,6.865),(3.81,6.865),(3.81,6.645),(3.59,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.09,6.645),(4.09,6.865),(4.31,6.865),(4.31,6.645),(4.09,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.59,6.645),(4.59,6.865),(4.81,6.865),(4.81,6.645),(4.59,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.09,6.645),(5.09,6.865),(5.31,6.865),(5.31,6.645),(5.09,6.645)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.59,6.645),(5.59,6.865),(5.81,6.865),(5.81,6.645),(5.59,6.645)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,0.2),(0.2,7.31),(6.2,7.31),(6.2,0.2),(0.2,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,8.05),(0.2,15.8),(6.2,15.8),(6.2,8.05),(0.2,8.05)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.02,14.71),(3.02,15.57),(3.38,15.57),(3.38,14.71),(3.02,14.71)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,14.78),(3.09,15.0),(3.31,15.0),(3.31,14.78),(3.09,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,15.28),(3.09,15.5),(3.31,15.5),(3.31,15.28),(3.09,15.28)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((3.02,0.43),(3.02,1.29),(3.38,1.29),(3.38,0.43),(3.02,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,0.5),(3.09,0.72),(3.31,0.72),(3.31,0.5),(3.09,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,1.0),(3.09,1.22),(3.31,1.22),(3.31,1.0),(3.09,1.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.09,1.66),(3.09,1.88),(3.31,1.88),(3.31,1.66),(3.09,1.66)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.12,1.59),(0.12,14.41),(6.28,14.41),(6.28,1.59),(0.12,1.59)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((2.86,0.2),(2.86,1.52),(3.54,1.52),(3.54,0.2),(2.86,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((2.86,14.48),(2.86,15.8),(3.54,15.8),(3.54,14.48),(2.86,14.48)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['diode_w1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(1.6,16.0),(1.6,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.63,8.28),(0.63,13.85),(0.97,13.85),(0.97,8.28),(0.63,8.28)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(2.2,16.6),(2.2,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,14.71),(0.62,15.57),(0.98,15.57),(0.98,14.71),(0.62,14.71)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,8.28),(0.62,13.85),(0.98,13.85),(0.98,8.28),(0.62,8.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,14.78),(0.69,15.0),(0.91,15.0),(0.91,14.78),(0.69,14.78)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,15.28),(0.69,15.5),(0.91,15.5),(0.91,15.28),(0.69,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,8.455),(0.69,8.675),(0.91,8.675),(0.91,8.455),(0.69,8.455)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,8.955),(0.69,9.175),(0.91,9.175),(0.91,8.955),(0.69,8.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,9.455),(0.69,9.675),(0.91,9.675),(0.91,9.455),(0.69,9.455)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,9.955),(0.69,10.175),(0.91,10.175),(0.91,9.955),(0.69,9.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.455),(0.69,10.675),(0.91,10.675),(0.91,10.455),(0.69,10.455)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,10.955),(0.69,11.175),(0.91,11.175),(0.91,10.955),(0.69,10.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.455),(0.69,11.675),(0.91,11.675),(0.91,11.455),(0.69,11.455)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,11.955),(0.69,12.175),(0.91,12.175),(0.91,11.955),(0.69,11.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.455),(0.69,12.675),(0.91,12.675),(0.91,12.455),(0.69,12.455)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,12.955),(0.69,13.175),(0.91,13.175),(0.91,12.955),(0.69,12.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,13.455),(0.69,13.675),(0.91,13.675),(0.91,13.455),(0.69,13.455)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.63,2.15),(0.63,7.08),(0.97,7.08),(0.97,2.15),(0.63,2.15)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(1.6,1.92),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.62,0.43),(0.62,1.29),(0.98,1.29),(0.98,0.43),(0.62,0.43)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.62,2.15),(0.62,7.08),(0.98,7.08),(0.98,2.15),(0.62,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,0.5),(0.69,0.72),(0.91,0.72),(0.91,0.5),(0.69,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,1.0),(0.69,1.22),(0.91,1.22),(0.91,1.0),(0.69,1.0)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.255),(0.69,2.475),(0.91,2.475),(0.91,2.255),(0.69,2.255)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,2.755),(0.69,2.975),(0.91,2.975),(0.91,2.755),(0.69,2.755)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.255),(0.69,3.475),(0.91,3.475),(0.91,3.255),(0.69,3.255)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,3.755),(0.69,3.975),(0.91,3.975),(0.91,3.755),(0.69,3.755)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.255),(0.69,4.475),(0.91,4.475),(0.91,4.255),(0.69,4.255)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,4.755),(0.69,4.975),(0.91,4.975),(0.91,4.755),(0.69,4.755)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,5.255),(0.69,5.475),(0.91,5.475),(0.91,5.255),(0.69,5.255)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,5.755),(0.69,5.975),(0.91,5.975),(0.91,5.755),(0.69,5.755)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,6.255),(0.69,6.475),(0.91,6.475),(0.91,6.255),(0.69,6.255)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.69,6.755),(0.69,6.975),(0.91,6.975),(0.91,6.755),(0.69,6.755)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(2.0,16.4),(2.0,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(1.605,16.005),(1.605,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,8.05),(0.46,14.08),(1.14,14.08),(1.14,8.05),(0.46,8.05)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.46,0.2),(0.46,1.52),(1.14,1.52),(1.14,0.2),(0.46,0.2)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,1.92),(0.46,7.31),(1.14,7.31),(1.14,1.92),(0.46,1.92)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.46,14.48),(0.46,15.8),(1.14,15.8),(1.14,14.48),(0.46,14.48)),
        )
        net = nets['i']
        createRL(
            tech, net, 'Metal1',
            ((0.67,2.15),(0.67,13.85),(0.93,13.85),(0.93,2.15),(0.67,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.8), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)

    cell = new_cells['zero_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((1.99,8.745),(1.99,14.08),(0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(2.33,14.08),(2.33,8.745),(1.99,8.745)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,15.28),(1.17,15.64),(2.03,15.64),(2.03,15.28),(1.17,15.28)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.46),(1.3,14.76),(2.34,14.76),(2.34,8.46),(1.3,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,15.35),(1.24,15.57),(1.46,15.57),(1.46,15.35),(1.24,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,15.35),(1.74,15.57),(1.96,15.57),(1.96,15.35),(1.74,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,8.75),(2.05,8.97),(2.27,8.97),(2.27,8.75),(2.05,8.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.25),(2.05,9.47),(2.27,9.47),(2.27,9.25),(2.05,9.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.75),(2.05,9.97),(2.27,9.97),(2.27,9.75),(2.05,9.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.25),(2.05,10.47),(2.27,10.47),(2.27,10.25),(2.05,10.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.75),(2.05,10.97),(2.27,10.97),(2.27,10.75),(2.05,10.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.25),(2.05,11.47),(2.27,11.47),(2.27,11.25),(2.05,11.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.75),(2.05,11.97),(2.27,11.97),(2.27,11.75),(2.05,11.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.25),(2.05,12.47),(2.27,12.47),(2.27,12.25),(2.05,12.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.75),(2.05,12.97),(2.27,12.97),(2.27,12.75),(2.05,12.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.25),(2.05,13.47),(2.27,13.47),(2.27,13.25),(2.05,13.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.75),(2.05,13.97),(2.27,13.97),(2.27,13.75),(2.05,13.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,14.25),(2.05,14.47),(2.27,14.47),(2.27,14.25),(2.05,14.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.87,1.92),(0.87,6.685),(1.21,6.685),(1.21,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.86,1.24),(0.86,6.9),(1.9,6.9),(1.9,1.24),(0.86,1.24)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,0.36),(1.17,0.72),(2.03,0.72),(2.03,0.36),(1.17,0.36)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.46),(0.93,1.68),(1.15,1.68),(1.15,1.46),(0.93,1.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.96),(0.93,2.18),(1.15,2.18),(1.15,1.96),(0.93,1.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.46),(0.93,2.68),(1.15,2.68),(1.15,2.46),(0.93,2.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.96),(0.93,3.18),(1.15,3.18),(1.15,2.96),(0.93,2.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.46),(0.93,3.68),(1.15,3.68),(1.15,3.46),(0.93,3.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.96),(0.93,4.18),(1.15,4.18),(1.15,3.96),(0.93,3.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.46),(0.93,4.68),(1.15,4.68),(1.15,4.46),(0.93,4.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.96),(0.93,5.18),(1.15,5.18),(1.15,4.96),(0.93,4.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.46),(0.93,5.68),(1.15,5.68),(1.15,5.46),(0.93,5.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.96),(0.93,6.18),(1.15,6.18),(1.15,5.96),(0.93,5.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,6.46),(0.93,6.68),(1.15,6.68),(1.15,6.46),(0.93,6.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,0.43),(1.24,0.65),(1.46,0.65),(1.46,0.43),(1.24,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,0.43),(1.74,0.65),(1.96,0.65),(1.96,0.43),(1.74,0.43)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.94,0.2),(0.94,0.88),(2.26,0.88),(2.26,0.2),(0.94,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.7,8.23),(0.7,14.99),(2.5,14.99),(2.5,8.23),(0.7,8.23)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.7,1.01),(0.7,7.13),(2.5,7.13),(2.5,1.01),(0.7,1.01)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.94,15.12),(0.94,15.8),(2.26,15.8),(2.26,15.12),(0.94,15.12)),
        )
        net = nets['zero']
        createRL(
            tech, net, 'COMP',
            ((1.9,1.24),(1.9,6.9),(2.34,6.9),(2.34,1.24),(1.9,1.24)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,7.8),(1.3,14.98),(1.9,14.98),(1.9,8.16),(2.34,8.16),(2.34,7.8),(1.3,7.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.305),(2.05,2.525),(2.27,2.525),(2.27,2.305),(2.05,2.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.805),(2.05,3.025),(2.27,3.025),(2.27,2.805),(2.05,2.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.305),(2.05,3.525),(2.27,3.525),(2.27,3.305),(2.05,3.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.805),(2.05,4.025),(2.27,4.025),(2.27,3.805),(2.05,3.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.305),(2.05,4.525),(2.27,4.525),(2.27,4.305),(2.05,4.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.805),(2.05,5.025),(2.27,5.025),(2.27,4.805),(2.05,4.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.305),(2.05,5.525),(2.27,5.525),(2.27,5.305),(2.05,5.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.805),(2.05,6.025),(2.27,6.025),(2.27,5.805),(2.05,5.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,6.305),(2.05,6.525),(2.27,6.525),(2.27,6.305),(2.05,6.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,7.87),(2.05,8.09),(2.27,8.09),(2.27,7.87),(2.05,7.87)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.99,2.15),(1.99,8.095),(2.33,8.095),(2.33,7.865),(2.25,7.865),(2.25,6.68),(2.33,6.68),(2.33,2.15),(1.99,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.12), u(0.26), u(2.15), u(8.095),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.12), u(0.26), u(2.15), u(8.095),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Poly2',
            ((1.3,1.02),(1.3,7.2),(0.86,7.2),(0.86,7.56),(1.9,7.56),(1.9,1.02),(1.3,1.02)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.86,8.46),(0.86,14.76),(1.3,14.76),(1.3,8.46),(0.86,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,8.94),(0.93,9.16),(1.15,9.16),(1.15,8.94),(0.93,8.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.44),(0.93,9.66),(1.15,9.66),(1.15,9.44),(0.93,9.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.94),(0.93,10.16),(1.15,10.16),(1.15,9.94),(0.93,9.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.44),(0.93,10.66),(1.15,10.66),(1.15,10.44),(0.93,10.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.94),(0.93,11.16),(1.15,11.16),(1.15,10.94),(0.93,10.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.44),(0.93,11.66),(1.15,11.66),(1.15,11.44),(0.93,11.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.94),(0.93,12.16),(1.15,12.16),(1.15,11.94),(0.93,11.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.44),(0.93,12.66),(1.15,12.66),(1.15,12.44),(0.93,12.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.94),(0.93,13.16),(1.15,13.16),(1.15,12.94),(0.93,12.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,13.44),(0.93,13.66),(1.15,13.66),(1.15,13.44),(0.93,13.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,7.27),(0.93,7.49),(1.15,7.49),(1.15,7.27),(0.93,7.27)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.87,7.265),(0.87,7.495),(0.95,7.495),(0.95,8.75),(0.87,8.75),(0.87,13.85),(1.21,13.85),(1.21,7.265),(0.87,7.265)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['zero'].setDirection(Net.Direction.OUT)

    cell = new_cells['one_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((1.99,8.745),(1.99,14.08),(0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(2.33,14.08),(2.33,8.745),(1.99,8.745)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,15.28),(1.17,15.64),(2.03,15.64),(2.03,15.28),(1.17,15.28)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.46),(1.3,14.76),(2.34,14.76),(2.34,8.46),(1.3,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,15.35),(1.24,15.57),(1.46,15.57),(1.46,15.35),(1.24,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,15.35),(1.74,15.57),(1.96,15.57),(1.96,15.35),(1.74,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,8.75),(2.05,8.97),(2.27,8.97),(2.27,8.75),(2.05,8.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.25),(2.05,9.47),(2.27,9.47),(2.27,9.25),(2.05,9.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.75),(2.05,9.97),(2.27,9.97),(2.27,9.75),(2.05,9.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.25),(2.05,10.47),(2.27,10.47),(2.27,10.25),(2.05,10.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.75),(2.05,10.97),(2.27,10.97),(2.27,10.75),(2.05,10.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.25),(2.05,11.47),(2.27,11.47),(2.27,11.25),(2.05,11.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.75),(2.05,11.97),(2.27,11.97),(2.27,11.75),(2.05,11.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.25),(2.05,12.47),(2.27,12.47),(2.27,12.25),(2.05,12.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.75),(2.05,12.97),(2.27,12.97),(2.27,12.75),(2.05,12.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.25),(2.05,13.47),(2.27,13.47),(2.27,13.25),(2.05,13.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.75),(2.05,13.97),(2.27,13.97),(2.27,13.75),(2.05,13.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,14.25),(2.05,14.47),(2.27,14.47),(2.27,14.25),(2.05,14.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.87,1.92),(0.87,6.685),(1.21,6.685),(1.21,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.86,1.24),(0.86,6.9),(1.9,6.9),(1.9,1.24),(0.86,1.24)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,0.36),(1.17,0.72),(2.03,0.72),(2.03,0.36),(1.17,0.36)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.46),(0.93,1.68),(1.15,1.68),(1.15,1.46),(0.93,1.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.96),(0.93,2.18),(1.15,2.18),(1.15,1.96),(0.93,1.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.46),(0.93,2.68),(1.15,2.68),(1.15,2.46),(0.93,2.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.96),(0.93,3.18),(1.15,3.18),(1.15,2.96),(0.93,2.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.46),(0.93,3.68),(1.15,3.68),(1.15,3.46),(0.93,3.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.96),(0.93,4.18),(1.15,4.18),(1.15,3.96),(0.93,3.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.46),(0.93,4.68),(1.15,4.68),(1.15,4.46),(0.93,4.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.96),(0.93,5.18),(1.15,5.18),(1.15,4.96),(0.93,4.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.46),(0.93,5.68),(1.15,5.68),(1.15,5.46),(0.93,5.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.96),(0.93,6.18),(1.15,6.18),(1.15,5.96),(0.93,5.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,6.46),(0.93,6.68),(1.15,6.68),(1.15,6.46),(0.93,6.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,0.43),(1.24,0.65),(1.46,0.65),(1.46,0.43),(1.24,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,0.43),(1.74,0.65),(1.96,0.65),(1.96,0.43),(1.74,0.43)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.94,0.2),(0.94,0.88),(2.26,0.88),(2.26,0.2),(0.94,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.7,8.23),(0.7,14.99),(2.5,14.99),(2.5,8.23),(0.7,8.23)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.7,1.01),(0.7,7.13),(2.5,7.13),(2.5,1.01),(0.7,1.01)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.94,15.12),(0.94,15.8),(2.26,15.8),(2.26,15.12),(0.94,15.12)),
        )
        net = nets['zero']
        createRL(
            tech, net, 'COMP',
            ((1.9,1.24),(1.9,6.9),(2.34,6.9),(2.34,1.24),(1.9,1.24)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,7.8),(1.3,14.98),(1.9,14.98),(1.9,8.16),(2.34,8.16),(2.34,7.8),(1.3,7.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.305),(2.05,2.525),(2.27,2.525),(2.27,2.305),(2.05,2.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.805),(2.05,3.025),(2.27,3.025),(2.27,2.805),(2.05,2.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.305),(2.05,3.525),(2.27,3.525),(2.27,3.305),(2.05,3.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.805),(2.05,4.025),(2.27,4.025),(2.27,3.805),(2.05,3.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.305),(2.05,4.525),(2.27,4.525),(2.27,4.305),(2.05,4.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.805),(2.05,5.025),(2.27,5.025),(2.27,4.805),(2.05,4.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.305),(2.05,5.525),(2.27,5.525),(2.27,5.305),(2.05,5.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.805),(2.05,6.025),(2.27,6.025),(2.27,5.805),(2.05,5.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,6.305),(2.05,6.525),(2.27,6.525),(2.27,6.305),(2.05,6.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,7.87),(2.05,8.09),(2.27,8.09),(2.27,7.87),(2.05,7.87)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.99,2.15),(1.99,8.095),(2.33,8.095),(2.33,7.865),(2.25,7.865),(2.25,6.68),(2.33,6.68),(2.33,2.15),(1.99,2.15)),
        )
        net = nets['one']
        createRL(
            tech, net, 'Poly2',
            ((1.3,1.02),(1.3,7.2),(0.86,7.2),(0.86,7.56),(1.9,7.56),(1.9,1.02),(1.3,1.02)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.86,8.46),(0.86,14.76),(1.3,14.76),(1.3,8.46),(0.86,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,8.94),(0.93,9.16),(1.15,9.16),(1.15,8.94),(0.93,8.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.44),(0.93,9.66),(1.15,9.66),(1.15,9.44),(0.93,9.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.94),(0.93,10.16),(1.15,10.16),(1.15,9.94),(0.93,9.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.44),(0.93,10.66),(1.15,10.66),(1.15,10.44),(0.93,10.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.94),(0.93,11.16),(1.15,11.16),(1.15,10.94),(0.93,10.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.44),(0.93,11.66),(1.15,11.66),(1.15,11.44),(0.93,11.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.94),(0.93,12.16),(1.15,12.16),(1.15,11.94),(0.93,11.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.44),(0.93,12.66),(1.15,12.66),(1.15,12.44),(0.93,12.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.94),(0.93,13.16),(1.15,13.16),(1.15,12.94),(0.93,12.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,13.44),(0.93,13.66),(1.15,13.66),(1.15,13.44),(0.93,13.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,7.27),(0.93,7.49),(1.15,7.49),(1.15,7.27),(0.93,7.27)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.87,7.265),(0.87,7.495),(0.95,7.495),(0.95,8.75),(0.87,8.75),(0.87,13.85),(1.21,13.85),(1.21,7.265),(0.87,7.265)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.08), u(0.26), u(7.265), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.08), u(0.26), u(7.265), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['one'].setDirection(Net.Direction.OUT)

    cell = new_cells['zeroone_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((1.99,8.745),(1.99,14.08),(0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(2.33,14.08),(2.33,8.745),(1.99,8.745)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,15.28),(1.17,15.64),(2.03,15.64),(2.03,15.28),(1.17,15.28)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.46),(1.3,14.76),(2.34,14.76),(2.34,8.46),(1.3,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,15.35),(1.24,15.57),(1.46,15.57),(1.46,15.35),(1.24,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,15.35),(1.74,15.57),(1.96,15.57),(1.96,15.35),(1.74,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,8.75),(2.05,8.97),(2.27,8.97),(2.27,8.75),(2.05,8.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.25),(2.05,9.47),(2.27,9.47),(2.27,9.25),(2.05,9.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.75),(2.05,9.97),(2.27,9.97),(2.27,9.75),(2.05,9.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.25),(2.05,10.47),(2.27,10.47),(2.27,10.25),(2.05,10.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.75),(2.05,10.97),(2.27,10.97),(2.27,10.75),(2.05,10.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.25),(2.05,11.47),(2.27,11.47),(2.27,11.25),(2.05,11.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.75),(2.05,11.97),(2.27,11.97),(2.27,11.75),(2.05,11.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.25),(2.05,12.47),(2.27,12.47),(2.27,12.25),(2.05,12.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.75),(2.05,12.97),(2.27,12.97),(2.27,12.75),(2.05,12.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.25),(2.05,13.47),(2.27,13.47),(2.27,13.25),(2.05,13.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.75),(2.05,13.97),(2.27,13.97),(2.27,13.75),(2.05,13.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,14.25),(2.05,14.47),(2.27,14.47),(2.27,14.25),(2.05,14.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.87,1.92),(0.87,6.685),(1.21,6.685),(1.21,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.86,1.24),(0.86,6.9),(1.9,6.9),(1.9,1.24),(0.86,1.24)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,0.36),(1.17,0.72),(2.03,0.72),(2.03,0.36),(1.17,0.36)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.46),(0.93,1.68),(1.15,1.68),(1.15,1.46),(0.93,1.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.96),(0.93,2.18),(1.15,2.18),(1.15,1.96),(0.93,1.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.46),(0.93,2.68),(1.15,2.68),(1.15,2.46),(0.93,2.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.96),(0.93,3.18),(1.15,3.18),(1.15,2.96),(0.93,2.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.46),(0.93,3.68),(1.15,3.68),(1.15,3.46),(0.93,3.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.96),(0.93,4.18),(1.15,4.18),(1.15,3.96),(0.93,3.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.46),(0.93,4.68),(1.15,4.68),(1.15,4.46),(0.93,4.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.96),(0.93,5.18),(1.15,5.18),(1.15,4.96),(0.93,4.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.46),(0.93,5.68),(1.15,5.68),(1.15,5.46),(0.93,5.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.96),(0.93,6.18),(1.15,6.18),(1.15,5.96),(0.93,5.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,6.46),(0.93,6.68),(1.15,6.68),(1.15,6.46),(0.93,6.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,0.43),(1.24,0.65),(1.46,0.65),(1.46,0.43),(1.24,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,0.43),(1.74,0.65),(1.96,0.65),(1.96,0.43),(1.74,0.43)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.94,0.2),(0.94,0.88),(2.26,0.88),(2.26,0.2),(0.94,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.7,8.23),(0.7,14.99),(2.5,14.99),(2.5,8.23),(0.7,8.23)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.7,1.01),(0.7,7.13),(2.5,7.13),(2.5,1.01),(0.7,1.01)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.94,15.12),(0.94,15.8),(2.26,15.8),(2.26,15.12),(0.94,15.12)),
        )
        net = nets['zero']
        createRL(
            tech, net, 'COMP',
            ((1.9,1.24),(1.9,6.9),(2.34,6.9),(2.34,1.24),(1.9,1.24)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,7.8),(1.3,14.98),(1.9,14.98),(1.9,8.16),(2.34,8.16),(2.34,7.8),(1.3,7.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.305),(2.05,2.525),(2.27,2.525),(2.27,2.305),(2.05,2.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.805),(2.05,3.025),(2.27,3.025),(2.27,2.805),(2.05,2.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.305),(2.05,3.525),(2.27,3.525),(2.27,3.305),(2.05,3.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.805),(2.05,4.025),(2.27,4.025),(2.27,3.805),(2.05,3.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.305),(2.05,4.525),(2.27,4.525),(2.27,4.305),(2.05,4.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.805),(2.05,5.025),(2.27,5.025),(2.27,4.805),(2.05,4.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.305),(2.05,5.525),(2.27,5.525),(2.27,5.305),(2.05,5.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.805),(2.05,6.025),(2.27,6.025),(2.27,5.805),(2.05,5.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,6.305),(2.05,6.525),(2.27,6.525),(2.27,6.305),(2.05,6.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,7.87),(2.05,8.09),(2.27,8.09),(2.27,7.87),(2.05,7.87)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.99,2.15),(1.99,8.095),(2.33,8.095),(2.33,7.865),(2.25,7.865),(2.25,6.68),(2.33,6.68),(2.33,2.15),(1.99,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.12), u(0.26), u(2.15), u(8.095),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.12), u(0.26), u(2.15), u(8.095),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Poly2',
            ((1.3,1.02),(1.3,7.2),(0.86,7.2),(0.86,7.56),(1.9,7.56),(1.9,1.02),(1.3,1.02)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.86,8.46),(0.86,14.76),(1.3,14.76),(1.3,8.46),(0.86,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,8.94),(0.93,9.16),(1.15,9.16),(1.15,8.94),(0.93,8.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.44),(0.93,9.66),(1.15,9.66),(1.15,9.44),(0.93,9.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.94),(0.93,10.16),(1.15,10.16),(1.15,9.94),(0.93,9.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.44),(0.93,10.66),(1.15,10.66),(1.15,10.44),(0.93,10.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.94),(0.93,11.16),(1.15,11.16),(1.15,10.94),(0.93,10.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.44),(0.93,11.66),(1.15,11.66),(1.15,11.44),(0.93,11.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.94),(0.93,12.16),(1.15,12.16),(1.15,11.94),(0.93,11.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.44),(0.93,12.66),(1.15,12.66),(1.15,12.44),(0.93,12.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.94),(0.93,13.16),(1.15,13.16),(1.15,12.94),(0.93,12.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,13.44),(0.93,13.66),(1.15,13.66),(1.15,13.44),(0.93,13.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,7.27),(0.93,7.49),(1.15,7.49),(1.15,7.27),(0.93,7.27)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.87,7.265),(0.87,7.495),(0.95,7.495),(0.95,8.75),(0.87,8.75),(0.87,13.85),(1.21,13.85),(1.21,7.265),(0.87,7.265)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.08), u(0.26), u(7.265), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.08), u(0.26), u(7.265), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['zero'].setDirection(Net.Direction.OUT)
        nets['one'].setDirection(Net.Direction.OUT)

    cell = new_cells['decap_w0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((1.99,8.745),(1.99,14.08),(0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(2.33,14.08),(2.33,8.745),(1.99,8.745)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,15.28),(1.17,15.64),(2.03,15.64),(2.03,15.28),(1.17,15.28)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.3,8.46),(1.3,14.76),(2.34,14.76),(2.34,8.46),(1.3,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,15.35),(1.24,15.57),(1.46,15.57),(1.46,15.35),(1.24,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,15.35),(1.74,15.57),(1.96,15.57),(1.96,15.35),(1.74,15.35)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,8.75),(2.05,8.97),(2.27,8.97),(2.27,8.75),(2.05,8.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.25),(2.05,9.47),(2.27,9.47),(2.27,9.25),(2.05,9.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,9.75),(2.05,9.97),(2.27,9.97),(2.27,9.75),(2.05,9.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.25),(2.05,10.47),(2.27,10.47),(2.27,10.25),(2.05,10.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,10.75),(2.05,10.97),(2.27,10.97),(2.27,10.75),(2.05,10.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.25),(2.05,11.47),(2.27,11.47),(2.27,11.25),(2.05,11.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,11.75),(2.05,11.97),(2.27,11.97),(2.27,11.75),(2.05,11.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.25),(2.05,12.47),(2.27,12.47),(2.27,12.25),(2.05,12.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,12.75),(2.05,12.97),(2.27,12.97),(2.27,12.75),(2.05,12.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.25),(2.05,13.47),(2.27,13.47),(2.27,13.25),(2.05,13.25)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,13.75),(2.05,13.97),(2.27,13.97),(2.27,13.75),(2.05,13.75)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,14.25),(2.05,14.47),(2.27,14.47),(2.27,14.25),(2.05,14.25)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(0.87,1.92),(0.87,6.685),(1.21,6.685),(1.21,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'COMP',
            ((0.86,1.24),(0.86,6.9),(1.9,6.9),(1.9,1.24),(0.86,1.24)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.17,0.36),(1.17,0.72),(2.03,0.72),(2.03,0.36),(1.17,0.36)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.46),(0.93,1.68),(1.15,1.68),(1.15,1.46),(0.93,1.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,1.96),(0.93,2.18),(1.15,2.18),(1.15,1.96),(0.93,1.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.46),(0.93,2.68),(1.15,2.68),(1.15,2.46),(0.93,2.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,2.96),(0.93,3.18),(1.15,3.18),(1.15,2.96),(0.93,2.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.46),(0.93,3.68),(1.15,3.68),(1.15,3.46),(0.93,3.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,3.96),(0.93,4.18),(1.15,4.18),(1.15,3.96),(0.93,3.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.46),(0.93,4.68),(1.15,4.68),(1.15,4.46),(0.93,4.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,4.96),(0.93,5.18),(1.15,5.18),(1.15,4.96),(0.93,4.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.46),(0.93,5.68),(1.15,5.68),(1.15,5.46),(0.93,5.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,5.96),(0.93,6.18),(1.15,6.18),(1.15,5.96),(0.93,5.96)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,6.46),(0.93,6.68),(1.15,6.68),(1.15,6.46),(0.93,6.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.24,0.43),(1.24,0.65),(1.46,0.65),(1.46,0.43),(1.24,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.74,0.43),(1.74,0.65),(1.96,0.65),(1.96,0.43),(1.74,0.43)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.94,0.2),(0.94,0.88),(2.26,0.88),(2.26,0.2),(0.94,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.7,8.23),(0.7,14.99),(2.5,14.99),(2.5,8.23),(0.7,8.23)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.7,1.01),(0.7,7.13),(2.5,7.13),(2.5,1.01),(0.7,1.01)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.94,15.12),(0.94,15.8),(2.26,15.8),(2.26,15.12),(0.94,15.12)),
        )
        net = nets['zero']
        createRL(
            tech, net, 'COMP',
            ((1.9,1.24),(1.9,6.9),(2.34,6.9),(2.34,1.24),(1.9,1.24)),
        )
        createRL(
            tech, net, 'Poly2',
            ((1.3,7.8),(1.3,14.98),(1.9,14.98),(1.9,8.16),(2.34,8.16),(2.34,7.8),(1.3,7.8)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.305),(2.05,2.525),(2.27,2.525),(2.27,2.305),(2.05,2.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,2.805),(2.05,3.025),(2.27,3.025),(2.27,2.805),(2.05,2.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.305),(2.05,3.525),(2.27,3.525),(2.27,3.305),(2.05,3.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,3.805),(2.05,4.025),(2.27,4.025),(2.27,3.805),(2.05,3.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.305),(2.05,4.525),(2.27,4.525),(2.27,4.305),(2.05,4.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,4.805),(2.05,5.025),(2.27,5.025),(2.27,4.805),(2.05,4.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.305),(2.05,5.525),(2.27,5.525),(2.27,5.305),(2.05,5.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,5.805),(2.05,6.025),(2.27,6.025),(2.27,5.805),(2.05,5.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,6.305),(2.05,6.525),(2.27,6.525),(2.27,6.305),(2.05,6.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,7.87),(2.05,8.09),(2.27,8.09),(2.27,7.87),(2.05,7.87)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.99,2.15),(1.99,8.095),(2.33,8.095),(2.33,7.865),(2.25,7.865),(2.25,6.68),(2.33,6.68),(2.33,2.15),(1.99,2.15)),
        )
        net = nets['one']
        createRL(
            tech, net, 'Poly2',
            ((1.3,1.02),(1.3,7.2),(0.86,7.2),(0.86,7.56),(1.9,7.56),(1.9,1.02),(1.3,1.02)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.86,8.46),(0.86,14.76),(1.3,14.76),(1.3,8.46),(0.86,8.46)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,8.94),(0.93,9.16),(1.15,9.16),(1.15,8.94),(0.93,8.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.44),(0.93,9.66),(1.15,9.66),(1.15,9.44),(0.93,9.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,9.94),(0.93,10.16),(1.15,10.16),(1.15,9.94),(0.93,9.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.44),(0.93,10.66),(1.15,10.66),(1.15,10.44),(0.93,10.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,10.94),(0.93,11.16),(1.15,11.16),(1.15,10.94),(0.93,10.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.44),(0.93,11.66),(1.15,11.66),(1.15,11.44),(0.93,11.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,11.94),(0.93,12.16),(1.15,12.16),(1.15,11.94),(0.93,11.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.44),(0.93,12.66),(1.15,12.66),(1.15,12.44),(0.93,12.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,12.94),(0.93,13.16),(1.15,13.16),(1.15,12.94),(0.93,12.94)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,13.44),(0.93,13.66),(1.15,13.66),(1.15,13.44),(0.93,13.44)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.93,7.27),(0.93,7.49),(1.15,7.49),(1.15,7.27),(0.93,7.27)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.87,7.265),(0.87,7.495),(0.95,7.495),(0.95,8.75),(0.87,8.75),(0.87,13.85),(1.21,13.85),(1.21,7.265),(0.87,7.265)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['inv_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i']
        createRL(
            tech, net, 'Metal1',
            ((0.23,2.15),(0.23,13.85),(0.49,13.85),(0.49,7.795),(0.66,7.795),(0.66,7.565),(0.49,7.565),(0.49,2.15),(0.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.745),(1.02,7.5),(0.31,7.5),(0.31,7.86),(1.02,7.86),(1.02,14.305),(1.62,14.305),(1.62,1.745),(1.02,1.745)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.38,7.57),(0.38,7.79),(0.6,7.79),(0.6,7.57),(0.38,7.57)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,3.565),(1.62,3.565),(1.62,1.965),(0.72,1.965),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.98,0.43),(1.98,0.79),(2.84,0.79),(2.84,0.43),(1.98,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,0.5),(2.05,0.72),(2.27,0.72),(2.27,0.5),(2.05,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.55,0.5),(2.55,0.72),(2.77,0.72),(2.77,0.5),(2.55,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((1.82,14.98),(1.82,15.8),(3.0,15.8),(3.0,14.98),(1.82,14.98)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,3.795),(2.22,3.795),(2.22,1.735),(0.88,1.735),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.82,0.2),(1.82,1.02),(3.0,1.02),(3.0,0.2),(1.82,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,10.655),(0.2,14.605),(0.88,14.605),(0.88,14.315),(2.22,14.315),(2.22,10.655),(0.2,10.655)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((1.98,15.21),(1.98,15.57),(2.84,15.57),(2.84,15.21),(1.98,15.21)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,10.885),(0.36,14.375),(0.72,14.375),(0.72,14.085),(1.62,14.085),(1.62,10.885),(0.36,10.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,15.28),(2.05,15.5),(2.27,15.5),(2.27,15.28),(2.05,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.55,15.28),(2.55,15.5),(2.77,15.5),(2.77,15.28),(2.55,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,10.885),(1.62,14.085),(2.06,14.085),(2.06,10.885),(1.62,10.885)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,1.965),(1.62,3.565),(2.06,3.565),(2.06,1.965),(1.62,1.965)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.125),(1.77,11.345),(1.99,11.345),(1.99,11.125),(1.77,11.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.625),(1.77,11.845),(1.99,11.845),(1.99,11.625),(1.77,11.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.125),(1.77,12.345),(1.99,12.345),(1.99,12.125),(1.77,12.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.625),(1.77,12.845),(1.99,12.845),(1.99,12.625),(1.77,12.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.125),(1.77,13.345),(1.99,13.345),(1.99,13.125),(1.77,13.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.625),(1.77,13.845),(1.99,13.845),(1.99,13.625),(1.77,13.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.155),(1.77,2.375),(1.99,2.375),(1.99,2.155),(1.77,2.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.655),(1.77,2.875),(1.99,2.875),(1.99,2.655),(1.77,2.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.155),(1.77,3.375),(1.99,3.375),(1.99,3.155),(1.77,3.155)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,13.85),(2.05,13.85),(2.05,11.12),(1.97,11.12),(1.97,3.38),(2.05,3.38),(2.05,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i']
        createRL(
            tech, net, 'Metal1',
            ((0.23,2.15),(0.23,13.85),(0.49,13.85),(0.49,7.795),(0.66,7.795),(0.66,7.565),(0.49,7.565),(0.49,2.15),(0.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.855),(1.02,7.5),(0.31,7.5),(0.31,7.86),(1.02,7.86),(1.02,14.335),(1.62,14.335),(1.62,1.855),(1.02,1.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.38,7.57),(0.38,7.79),(0.6,7.79),(0.6,7.57),(0.38,7.57)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,4.955),(1.62,4.955),(1.62,2.075),(0.72,2.075),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.98,0.43),(1.98,0.79),(2.84,0.79),(2.84,0.43),(1.98,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,0.5),(2.05,0.72),(2.27,0.72),(2.27,0.5),(2.05,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.55,0.5),(2.55,0.72),(2.77,0.72),(2.77,0.5),(2.55,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.2,1.92),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((1.82,14.98),(1.82,15.8),(3.0,15.8),(3.0,14.98),(1.82,14.98)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,5.185),(2.22,5.185),(2.22,1.845),(0.88,1.845),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((1.82,0.2),(1.82,1.02),(3.0,1.02),(3.0,0.2),(1.82,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.125),(0.2,14.605),(0.88,14.605),(0.88,14.345),(2.22,14.345),(2.22,8.125),(0.2,8.125)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(3.6,16.4),(3.6,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(3.205,16.005),(3.205,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.355),(0.36,14.375),(0.72,14.375),(0.72,14.115),(1.62,14.115),(1.62,8.355),(0.36,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.98,15.21),(1.98,15.57),(2.84,15.57),(2.84,15.21),(1.98,15.21)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.05,15.28),(2.05,15.5),(2.27,15.5),(2.27,15.28),(2.05,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.55,15.28),(2.55,15.5),(2.77,15.5),(2.77,15.28),(2.55,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(3.2,16.0),(3.2,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(3.8,16.6),(3.8,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,2.075),(1.62,4.955),(2.06,4.955),(2.06,2.075),(1.62,2.075)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,8.355),(1.62,14.115),(2.06,14.115),(2.06,8.355),(1.62,8.355)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.155),(1.77,2.375),(1.99,2.375),(1.99,2.155),(1.77,2.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.655),(1.77,2.875),(1.99,2.875),(1.99,2.655),(1.77,2.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.155),(1.77,3.375),(1.99,3.375),(1.99,3.155),(1.77,3.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.655),(1.77,3.875),(1.99,3.875),(1.99,3.655),(1.77,3.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.155),(1.77,4.375),(1.99,4.375),(1.99,4.155),(1.77,4.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.655),(1.77,4.875),(1.99,4.875),(1.99,4.655),(1.77,4.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,8.625),(1.77,8.845),(1.99,8.845),(1.99,8.625),(1.77,8.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.125),(1.77,9.345),(1.99,9.345),(1.99,9.125),(1.77,9.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.625),(1.77,9.845),(1.99,9.845),(1.99,9.625),(1.77,9.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.125),(1.77,10.345),(1.99,10.345),(1.99,10.125),(1.77,10.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.625),(1.77,10.845),(1.99,10.845),(1.99,10.625),(1.77,10.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.125),(1.77,11.345),(1.99,11.345),(1.99,11.125),(1.77,11.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.625),(1.77,11.845),(1.99,11.845),(1.99,11.625),(1.77,11.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.125),(1.77,12.345),(1.99,12.345),(1.99,12.125),(1.77,12.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.625),(1.77,12.845),(1.99,12.845),(1.99,12.625),(1.77,12.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.125),(1.77,13.345),(1.99,13.345),(1.99,13.125),(1.77,13.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.625),(1.77,13.845),(1.99,13.845),(1.99,13.625),(1.77,13.625)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,13.85),(2.05,13.85),(2.05,8.62),(1.97,8.62),(1.97,4.88),(2.05,4.88),(2.05,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.800000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i']
        createRL(
            tech, net, 'Metal1',
            ((0.23,2.15),(0.23,13.85),(0.49,13.85),(0.49,7.795),(0.66,7.795),(0.66,7.565),(0.49,7.565),(0.49,2.15),(0.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.855),(1.02,7.5),(0.31,7.5),(0.31,7.86),(1.02,7.86),(1.02,14.335),(1.62,14.335),(1.62,7.86),(2.14,7.86),(2.14,14.335),(2.74,14.335),(2.74,1.855),(2.14,1.855),(2.14,7.5),(1.62,7.5),(1.62,1.855),(1.02,1.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.38,7.57),(0.38,7.79),(0.6,7.79),(0.6,7.57),(0.38,7.57)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((3.58,0.43),(3.58,0.79),(4.44,0.79),(4.44,0.43),(3.58,0.43)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.04,1.625),(3.04,2.075),(2.14,2.075),(2.14,4.955),(3.4,4.955),(3.4,1.625),(3.04,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,4.955),(1.62,4.955),(1.62,2.075),(0.72,2.075),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.65,0.5),(3.65,0.72),(3.87,0.72),(3.87,0.5),(3.65,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.15,0.5),(4.15,0.72),(4.37,0.72),(4.37,0.5),(4.15,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,1.695),(3.11,1.915),(3.33,1.915),(3.33,1.695),(3.11,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(4.8,1.92),(4.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((3.42,14.98),(3.42,15.8),(4.6,15.8),(4.6,14.98),(3.42,14.98)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,5.185),(3.56,5.185),(3.56,1.395),(2.88,1.395),(2.88,1.845),(0.88,1.845),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.125),(0.2,14.605),(0.88,14.605),(0.88,14.345),(2.88,14.345),(2.88,14.605),(3.56,14.605),(3.56,8.125),(0.2,8.125)),
        )
        createRL(
            tech, net, 'Pplus',
            ((3.42,0.2),(3.42,1.02),(4.6,1.02),(4.6,0.2),(3.42,0.2)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(5.2,16.4),(5.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(4.805,16.005),(4.805,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.355),(0.36,14.375),(0.72,14.375),(0.72,14.115),(1.62,14.115),(1.62,8.355),(0.36,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.58,15.21),(3.58,15.57),(4.44,15.57),(4.44,15.21),(3.58,15.21)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,8.355),(2.14,14.115),(3.04,14.115),(3.04,14.375),(3.4,14.375),(3.4,8.355),(2.14,8.355)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,14.085),(3.11,14.305),(3.33,14.305),(3.33,14.085),(3.11,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.65,15.28),(3.65,15.5),(3.87,15.5),(3.87,15.28),(3.65,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.15,15.28),(4.15,15.5),(4.37,15.5),(4.37,15.28),(4.15,15.28)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(4.8,16.0),(4.8,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(5.4,16.6),(5.4,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,8.355),(1.62,14.115),(2.14,14.115),(2.14,8.355),(1.62,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,2.075),(1.62,4.955),(2.14,4.955),(2.14,2.075),(1.62,2.075)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.155),(1.77,2.375),(1.99,2.375),(1.99,2.155),(1.77,2.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.655),(1.77,2.875),(1.99,2.875),(1.99,2.655),(1.77,2.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.155),(1.77,3.375),(1.99,3.375),(1.99,3.155),(1.77,3.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.655),(1.77,3.875),(1.99,3.875),(1.99,3.655),(1.77,3.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.155),(1.77,4.375),(1.99,4.375),(1.99,4.155),(1.77,4.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.655),(1.77,4.875),(1.99,4.875),(1.99,4.655),(1.77,4.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,8.625),(1.77,8.845),(1.99,8.845),(1.99,8.625),(1.77,8.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.125),(1.77,9.345),(1.99,9.345),(1.99,9.125),(1.77,9.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.625),(1.77,9.845),(1.99,9.845),(1.99,9.625),(1.77,9.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.125),(1.77,10.345),(1.99,10.345),(1.99,10.125),(1.77,10.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.625),(1.77,10.845),(1.99,10.845),(1.99,10.625),(1.77,10.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.125),(1.77,11.345),(1.99,11.345),(1.99,11.125),(1.77,11.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.625),(1.77,11.845),(1.99,11.845),(1.99,11.625),(1.77,11.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.125),(1.77,12.345),(1.99,12.345),(1.99,12.125),(1.77,12.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.625),(1.77,12.845),(1.99,12.845),(1.99,12.625),(1.77,12.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.125),(1.77,13.345),(1.99,13.345),(1.99,13.125),(1.77,13.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.625),(1.77,13.845),(1.99,13.845),(1.99,13.625),(1.77,13.625)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,13.85),(2.05,13.85),(2.05,8.62),(1.97,8.62),(1.97,4.88),(2.05,4.88),(2.05,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i']
        createRL(
            tech, net, 'Metal1',
            ((0.23,2.15),(0.23,13.85),(0.49,13.85),(0.49,7.795),(0.66,7.795),(0.66,7.565),(0.49,7.565),(0.49,2.15),(0.23,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.36), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.855),(1.02,7.5),(0.31,7.5),(0.31,7.86),(1.02,7.86),(1.02,14.335),(1.62,14.335),(1.62,7.86),(2.14,7.86),(2.14,14.335),(2.74,14.335),(2.74,7.86),(3.7,7.86),(3.7,14.335),(4.3,14.335),(4.3,7.86),(4.82,7.86),(4.82,14.335),(5.42,14.335),(5.42,1.855),(4.82,1.855),(4.82,7.5),(4.3,7.5),(4.3,1.855),(3.7,1.855),(3.7,7.5),(2.74,7.5),(2.74,1.855),(2.14,1.855),(2.14,7.5),(1.62,7.5),(1.62,1.855),(1.02,1.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.38,7.57),(0.38,7.79),(0.6,7.79),(0.6,7.57),(0.38,7.57)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,4.955),(1.62,4.955),(1.62,2.075),(0.72,2.075),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.78,0.43),(6.78,0.79),(7.64,0.79),(7.64,0.43),(6.78,0.43)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.72,1.625),(5.72,2.075),(4.82,2.075),(4.82,4.955),(6.08,4.955),(6.08,1.625),(5.72,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.04,1.625),(3.04,2.075),(2.14,2.075),(2.14,4.955),(4.3,4.955),(4.3,2.075),(3.4,2.075),(3.4,1.625),(3.04,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.79,1.695),(5.79,1.915),(6.01,1.915),(6.01,1.695),(5.79,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,1.695),(3.11,1.915),(3.33,1.915),(3.33,1.695),(3.11,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.85,0.5),(6.85,0.72),(7.07,0.72),(7.07,0.5),(6.85,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.35,0.5),(7.35,0.72),(7.57,0.72),(7.57,0.5),(7.35,0.5)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,5.185),(6.24,5.185),(6.24,1.395),(5.56,1.395),(5.56,1.845),(3.56,1.845),(3.56,1.395),(2.88,1.395),(2.88,1.845),(0.88,1.845),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Nplus',
            ((6.62,14.98),(6.62,15.8),(7.8,15.8),(7.8,14.98),(6.62,14.98)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.125),(0.2,14.605),(0.88,14.605),(0.88,14.345),(2.88,14.345),(2.88,14.605),(3.56,14.605),(3.56,14.345),(5.56,14.345),(5.56,14.605),(6.24,14.605),(6.24,8.125),(0.2,8.125)),
        )
        createRL(
            tech, net, 'Pplus',
            ((6.62,0.2),(6.62,1.02),(7.8,1.02),(7.8,0.2),(6.62,0.2)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.355),(0.36,14.375),(0.72,14.375),(0.72,14.115),(1.62,14.115),(1.62,8.355),(0.36,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.82,8.355),(4.82,14.115),(5.72,14.115),(5.72,14.375),(6.08,14.375),(6.08,8.355),(4.82,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,8.355),(2.14,14.115),(3.04,14.115),(3.04,14.375),(3.4,14.375),(3.4,14.115),(4.3,14.115),(4.3,8.355),(2.14,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((6.78,15.21),(6.78,15.57),(7.64,15.57),(7.64,15.21),(6.78,15.21)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,14.085),(3.11,14.305),(3.33,14.305),(3.33,14.085),(3.11,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.85,15.28),(6.85,15.5),(7.07,15.5),(7.07,15.28),(6.85,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.35,15.28),(7.35,15.5),(7.57,15.5),(7.57,15.28),(7.35,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.79,14.085),(5.79,14.305),(6.01,14.305),(6.01,14.085),(5.79,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(8.6,16.6),(8.6,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((4.3,8.355),(4.3,14.115),(4.82,14.115),(4.82,8.355),(4.3,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,8.355),(1.62,14.115),(2.14,14.115),(2.14,8.355),(1.62,8.355)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,2.075),(4.3,4.955),(4.82,4.955),(4.82,2.075),(4.3,2.075)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,2.075),(1.62,4.955),(2.14,4.955),(2.14,2.075),(1.62,2.075)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.155),(4.45,2.375),(4.67,2.375),(4.67,2.155),(4.45,2.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.655),(4.45,2.875),(4.67,2.875),(4.67,2.655),(4.45,2.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.155),(4.45,3.375),(4.67,3.375),(4.67,3.155),(4.45,3.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.655),(4.45,3.875),(4.67,3.875),(4.67,3.655),(4.45,3.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,4.155),(4.45,4.375),(4.67,4.375),(4.67,4.155),(4.45,4.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,4.655),(4.45,4.875),(4.67,4.875),(4.67,4.655),(4.45,4.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,8.625),(4.45,8.845),(4.67,8.845),(4.67,8.625),(4.45,8.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.125),(4.45,9.345),(4.67,9.345),(4.67,9.125),(4.45,9.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.625),(4.45,9.845),(4.67,9.845),(4.67,9.625),(4.45,9.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.125),(4.45,10.345),(4.67,10.345),(4.67,10.125),(4.45,10.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.625),(4.45,10.845),(4.67,10.845),(4.67,10.625),(4.45,10.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.125),(4.45,11.345),(4.67,11.345),(4.67,11.125),(4.45,11.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.625),(4.45,11.845),(4.67,11.845),(4.67,11.625),(4.45,11.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.125),(4.45,12.345),(4.67,12.345),(4.67,12.125),(4.45,12.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.625),(4.45,12.845),(4.67,12.845),(4.67,12.625),(4.45,12.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,13.125),(4.45,13.345),(4.67,13.345),(4.67,13.125),(4.45,13.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,13.625),(4.45,13.845),(4.67,13.845),(4.67,13.625),(4.45,13.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.155),(1.77,2.375),(1.99,2.375),(1.99,2.155),(1.77,2.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.655),(1.77,2.875),(1.99,2.875),(1.99,2.655),(1.77,2.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.155),(1.77,3.375),(1.99,3.375),(1.99,3.155),(1.77,3.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.655),(1.77,3.875),(1.99,3.875),(1.99,3.655),(1.77,3.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.155),(1.77,4.375),(1.99,4.375),(1.99,4.155),(1.77,4.155)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,4.655),(1.77,4.875),(1.99,4.875),(1.99,4.655),(1.77,4.655)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,8.625),(1.77,8.845),(1.99,8.845),(1.99,8.625),(1.77,8.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.125),(1.77,9.345),(1.99,9.345),(1.99,9.125),(1.77,9.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.625),(1.77,9.845),(1.99,9.845),(1.99,9.625),(1.77,9.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.125),(1.77,10.345),(1.99,10.345),(1.99,10.125),(1.77,10.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.625),(1.77,10.845),(1.99,10.845),(1.99,10.625),(1.77,10.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.125),(1.77,11.345),(1.99,11.345),(1.99,11.125),(1.77,11.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.625),(1.77,11.845),(1.99,11.845),(1.99,11.625),(1.77,11.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.125),(1.77,12.345),(1.99,12.345),(1.99,12.125),(1.77,12.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.625),(1.77,12.845),(1.99,12.845),(1.99,12.625),(1.77,12.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.125),(1.77,13.345),(1.99,13.345),(1.99,13.125),(1.77,13.125)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.625),(1.77,13.845),(1.99,13.845),(1.99,13.625),(1.77,13.625)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,13.85),(2.05,13.85),(2.05,8.62),(1.97,8.62),(1.97,7.81),(4.39,7.81),(4.39,13.85),(4.73,13.85),(4.73,2.15),(4.39,2.15),(4.39,7.55),(1.97,7.55),(1.97,4.88),(2.05,4.88),(2.05,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.84), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.800000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'ni': Net.create(cell, 'ni'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['ni']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.615),(0.36,10.215),(0.8,10.215),(0.8,8.615),(0.36,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,3.705),(0.36,4.505),(0.8,4.505),(0.8,3.705),(0.36,3.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,3.995),(0.43,4.215),(0.65,4.215),(0.65,3.995),(0.43,3.995)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,8.805),(0.43,9.025),(0.65,9.025),(0.65,8.805),(0.43,8.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.305),(0.43,9.525),(0.65,9.525),(0.65,9.305),(0.43,9.305)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.805),(0.43,10.025),(0.65,10.025),(0.65,9.805),(0.43,9.805)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,6.45),(0.43,6.67),(0.65,6.67),(0.65,6.45),(0.43,6.45)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.37,3.705),(0.37,10.215),(0.71,10.215),(0.71,3.705),(0.37,3.705)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.405),(2.14,6.38),(0.36,6.38),(0.36,6.74),(2.14,6.74),(2.14,14.595),(2.74,14.595),(2.74,1.405),(2.14,1.405)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((1.54,1.395),(1.54,3.475),(0.2,3.475),(0.2,4.735),(3.34,4.735),(3.34,1.395),(1.54,1.395)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.27,14.98),(0.27,15.8),(4.53,15.8),(4.53,14.98),(0.27,14.98)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.385),(0.2,10.445),(1.54,10.445),(1.54,14.605),(3.34,14.605),(3.34,8.385),(0.2,8.385)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.27,0.2),(0.27,1.02),(4.53,1.02),(4.53,0.2),(0.27,0.2)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(5.2,16.4),(5.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(4.805,16.005),(4.805,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(5.4,16.6),(5.4,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.8,8.615),(0.8,10.215),(1.7,10.215),(1.7,14.375),(2.74,14.375),(2.74,8.615),(0.8,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.43,15.21),(0.43,15.57),(4.37,15.57),(4.37,15.21),(0.43,15.21)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,14.085),(1.77,14.305),(1.99,14.305),(1.99,14.085),(1.77,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.54,15.28),(0.54,15.5),(0.76,15.5),(0.76,15.28),(0.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.04,15.28),(1.04,15.5),(1.26,15.5),(1.26,15.28),(1.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.54,15.28),(1.54,15.5),(1.76,15.5),(1.76,15.28),(1.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.04,15.28),(2.04,15.5),(2.26,15.5),(2.26,15.28),(2.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.54,15.28),(2.54,15.5),(2.76,15.5),(2.76,15.28),(2.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.04,15.28),(3.04,15.5),(3.26,15.5),(3.26,15.28),(3.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.54,15.28),(3.54,15.5),(3.76,15.5),(3.76,15.28),(3.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.04,15.28),(4.04,15.5),(4.26,15.5),(4.26,15.28),(4.04,15.28)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(4.8,16.0),(4.8,14.08),(0.0,14.08)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((1.7,1.625),(1.7,3.705),(0.8,3.705),(0.8,4.505),(2.74,4.505),(2.74,1.625),(1.7,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.43,0.43),(0.43,0.79),(4.37,0.79),(4.37,0.43),(0.43,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.54,0.5),(0.54,0.72),(0.76,0.72),(0.76,0.5),(0.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.04,0.5),(1.04,0.72),(1.26,0.72),(1.26,0.5),(1.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.54,0.5),(1.54,0.72),(1.76,0.72),(1.76,0.5),(1.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.04,0.5),(2.04,0.72),(2.26,0.72),(2.26,0.5),(2.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.54,0.5),(2.54,0.72),(2.76,0.72),(2.76,0.5),(2.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.04,0.5),(3.04,0.72),(3.26,0.72),(3.26,0.5),(3.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.54,0.5),(3.54,0.72),(3.76,0.72),(3.76,0.5),(3.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.04,0.5),(4.04,0.72),(4.26,0.72),(4.26,0.5),(4.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,1.695),(1.77,1.915),(1.99,1.915),(1.99,1.695),(1.77,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(4.8,1.92),(4.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'Poly2',
            ((0.8,3.485),(0.8,5.165),(1.4,5.165),(1.4,3.485),(0.8,3.485)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.8,7.955),(0.8,10.435),(1.4,10.435),(1.4,7.955),(0.8,7.955)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,8.025),(0.945,8.245),(1.165,8.245),(1.165,8.025),(0.945,8.025)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,4.875),(0.945,5.095),(1.165,5.095),(1.165,4.875),(0.945,4.875)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.94,2.15),(0.94,13.85),(1.2,13.85),(1.2,2.15),(0.94,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((2.74,8.615),(2.74,14.375),(3.18,14.375),(3.18,8.615),(2.74,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.74,1.625),(2.74,4.505),(3.18,4.505),(3.18,1.625),(2.74,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,8.87),(2.89,9.09),(3.11,9.09),(3.11,8.87),(2.89,8.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.37),(2.89,9.59),(3.11,9.59),(3.11,9.37),(2.89,9.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.87),(2.89,10.09),(3.11,10.09),(3.11,9.87),(2.89,9.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.37),(2.89,10.59),(3.11,10.59),(3.11,10.37),(2.89,10.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.87),(2.89,11.09),(3.11,11.09),(3.11,10.87),(2.89,10.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.37),(2.89,11.59),(3.11,11.59),(3.11,11.37),(2.89,11.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.87),(2.89,12.09),(3.11,12.09),(3.11,11.87),(2.89,11.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.37),(2.89,12.59),(3.11,12.59),(3.11,12.37),(2.89,12.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.87),(2.89,13.09),(3.11,13.09),(3.11,12.87),(2.89,12.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,13.37),(2.89,13.59),(3.11,13.59),(3.11,13.37),(2.89,13.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.47),(2.89,2.69),(3.11,2.69),(3.11,2.47),(2.89,2.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.97),(2.89,3.19),(3.11,3.19),(3.11,2.97),(2.89,2.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.47),(2.89,3.69),(3.11,3.69),(3.11,3.47),(2.89,3.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.97),(2.89,4.19),(3.11,4.19),(3.11,3.97),(2.89,3.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.83,2.155),(2.83,13.845),(3.17,13.845),(3.17,8.615),(3.09,8.615),(3.09,4.505),(3.17,4.505),(3.17,2.155),(2.83,2.155)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.800000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'ni': Net.create(cell, 'ni'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['ni']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.615),(0.36,11.815),(0.8,11.815),(0.8,8.615),(0.36,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,2.905),(0.36,4.505),(0.8,4.505),(0.8,2.905),(0.36,2.905)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,8.855),(0.43,9.075),(0.65,9.075),(0.65,8.855),(0.43,8.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.355),(0.43,9.575),(0.65,9.575),(0.65,9.355),(0.43,9.355)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.855),(0.43,10.075),(0.65,10.075),(0.65,9.855),(0.43,9.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,10.355),(0.43,10.575),(0.65,10.575),(0.65,10.355),(0.43,10.355)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,10.855),(0.43,11.075),(0.65,11.075),(0.65,10.855),(0.43,10.855)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,11.355),(0.43,11.575),(0.65,11.575),(0.65,11.355),(0.43,11.355)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,6.45),(0.43,6.67),(0.65,6.67),(0.65,6.45),(0.43,6.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,3.095),(0.43,3.315),(0.65,3.315),(0.65,3.095),(0.43,3.095)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,3.595),(0.43,3.815),(0.65,3.815),(0.65,3.595),(0.43,3.595)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,4.095),(0.43,4.315),(0.65,4.315),(0.65,4.095),(0.43,4.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.37,2.905),(0.37,11.815),(0.71,11.815),(0.71,2.905),(0.37,2.905)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.405),(2.14,6.38),(0.36,6.38),(0.36,6.74),(2.14,6.74),(2.14,14.595),(2.74,14.595),(2.74,6.74),(3.26,6.74),(3.26,14.595),(3.86,14.595),(3.86,1.405),(3.26,1.405),(3.26,6.38),(2.74,6.38),(2.74,1.405),(2.14,1.405)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((1.54,1.395),(1.54,2.675),(0.2,2.675),(0.2,4.735),(4.46,4.735),(4.46,1.395),(1.54,1.395)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.27,14.98),(0.27,15.8),(4.53,15.8),(4.53,14.98),(0.27,14.98)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.385),(0.2,12.045),(1.54,12.045),(1.54,14.605),(4.46,14.605),(4.46,8.385),(0.2,8.385)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.27,0.2),(0.27,1.02),(4.53,1.02),(4.53,0.2),(0.27,0.2)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(5.2,16.4),(5.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(4.805,16.005),(4.805,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(5.4,16.6),(5.4,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.8,8.615),(0.8,11.815),(1.7,11.815),(1.7,14.375),(2.74,14.375),(2.74,8.615),(0.8,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.43,15.21),(0.43,15.57),(4.37,15.57),(4.37,15.21),(0.43,15.21)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.26,8.615),(3.26,14.375),(4.3,14.375),(4.3,8.615),(3.26,8.615)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,8.885),(4.01,9.105),(4.23,9.105),(4.23,8.885),(4.01,8.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,9.385),(4.01,9.605),(4.23,9.605),(4.23,9.385),(4.01,9.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,9.885),(4.01,10.105),(4.23,10.105),(4.23,9.885),(4.01,9.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,10.385),(4.01,10.605),(4.23,10.605),(4.23,10.385),(4.01,10.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,10.885),(4.01,11.105),(4.23,11.105),(4.23,10.885),(4.01,10.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,11.385),(4.01,11.605),(4.23,11.605),(4.23,11.385),(4.01,11.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,11.885),(4.01,12.105),(4.23,12.105),(4.23,11.885),(4.01,11.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,12.385),(4.01,12.605),(4.23,12.605),(4.23,12.385),(4.01,12.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,12.885),(4.01,13.105),(4.23,13.105),(4.23,12.885),(4.01,12.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,13.385),(4.01,13.605),(4.23,13.605),(4.23,13.385),(4.01,13.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,13.885),(4.01,14.105),(4.23,14.105),(4.23,13.885),(4.01,13.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,14.085),(1.77,14.305),(1.99,14.305),(1.99,14.085),(1.77,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.54,15.28),(0.54,15.5),(0.76,15.5),(0.76,15.28),(0.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.04,15.28),(1.04,15.5),(1.26,15.5),(1.26,15.28),(1.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.54,15.28),(1.54,15.5),(1.76,15.5),(1.76,15.28),(1.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.04,15.28),(2.04,15.5),(2.26,15.5),(2.26,15.28),(2.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.54,15.28),(2.54,15.5),(2.76,15.5),(2.76,15.28),(2.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.04,15.28),(3.04,15.5),(3.26,15.5),(3.26,15.28),(3.04,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.54,15.28),(3.54,15.5),(3.76,15.5),(3.76,15.28),(3.54,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.04,15.28),(4.04,15.5),(4.26,15.5),(4.26,15.28),(4.04,15.28)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.95,8.615),(3.95,14.08),(0.0,14.08),(0.0,16.0),(4.8,16.0),(4.8,14.08),(4.29,14.08),(4.29,8.615),(3.95,8.615)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((3.26,1.625),(3.26,4.505),(4.3,4.505),(4.3,1.625),(3.26,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.7,1.625),(1.7,2.905),(0.8,2.905),(0.8,4.505),(2.74,4.505),(2.74,1.625),(1.7,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.43,0.43),(0.43,0.79),(4.37,0.79),(4.37,0.43),(0.43,0.43)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.54,0.5),(0.54,0.72),(0.76,0.72),(0.76,0.5),(0.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.04,0.5),(1.04,0.72),(1.26,0.72),(1.26,0.5),(1.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.54,0.5),(1.54,0.72),(1.76,0.72),(1.76,0.5),(1.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.04,0.5),(2.04,0.72),(2.26,0.72),(2.26,0.5),(2.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.54,0.5),(2.54,0.72),(2.76,0.72),(2.76,0.5),(2.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.04,0.5),(3.04,0.72),(3.26,0.72),(3.26,0.5),(3.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.54,0.5),(3.54,0.72),(3.76,0.72),(3.76,0.5),(3.54,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.04,0.5),(4.04,0.72),(4.26,0.72),(4.26,0.5),(4.04,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,1.705),(4.01,1.925),(4.23,1.925),(4.23,1.705),(4.01,1.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,2.205),(4.01,2.425),(4.23,2.425),(4.23,2.205),(4.01,2.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,2.705),(4.01,2.925),(4.23,2.925),(4.23,2.705),(4.01,2.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,3.205),(4.01,3.425),(4.23,3.425),(4.23,3.205),(4.01,3.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,3.705),(4.01,3.925),(4.23,3.925),(4.23,3.705),(4.01,3.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,4.205),(4.01,4.425),(4.23,4.425),(4.23,4.205),(4.01,4.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,1.695),(1.77,1.915),(1.99,1.915),(1.99,1.695),(1.77,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.95,1.92),(3.95,4.505),(4.29,4.505),(4.29,1.92),(4.8,1.92),(4.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'Poly2',
            ((0.8,7.955),(0.8,12.035),(1.4,12.035),(1.4,7.955),(0.8,7.955)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.8,2.685),(0.8,5.165),(1.4,5.165),(1.4,2.685),(0.8,2.685)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,8.025),(0.945,8.245),(1.165,8.245),(1.165,8.025),(0.945,8.025)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,4.875),(0.945,5.095),(1.165,5.095),(1.165,4.875),(0.945,4.875)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.94,2.15),(0.94,13.85),(1.2,13.85),(1.2,2.15),(0.94,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((2.74,1.625),(2.74,4.505),(3.26,4.505),(3.26,1.625),(2.74,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.74,8.615),(2.74,14.375),(3.26,14.375),(3.26,8.615),(2.74,8.615)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,8.87),(2.89,9.09),(3.11,9.09),(3.11,8.87),(2.89,8.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.37),(2.89,9.59),(3.11,9.59),(3.11,9.37),(2.89,9.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.87),(2.89,10.09),(3.11,10.09),(3.11,9.87),(2.89,9.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.37),(2.89,10.59),(3.11,10.59),(3.11,10.37),(2.89,10.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.87),(2.89,11.09),(3.11,11.09),(3.11,10.87),(2.89,10.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.37),(2.89,11.59),(3.11,11.59),(3.11,11.37),(2.89,11.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.87),(2.89,12.09),(3.11,12.09),(3.11,11.87),(2.89,11.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.37),(2.89,12.59),(3.11,12.59),(3.11,12.37),(2.89,12.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.87),(2.89,13.09),(3.11,13.09),(3.11,12.87),(2.89,12.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,13.37),(2.89,13.59),(3.11,13.59),(3.11,13.37),(2.89,13.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.47),(2.89,2.69),(3.11,2.69),(3.11,2.47),(2.89,2.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.97),(2.89,3.19),(3.11,3.19),(3.11,2.97),(2.89,2.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.47),(2.89,3.69),(3.11,3.69),(3.11,3.47),(2.89,3.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.97),(2.89,4.19),(3.11,4.19),(3.11,3.97),(2.89,3.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.83,2.155),(2.83,13.845),(3.17,13.845),(3.17,8.615),(3.09,8.615),(3.09,4.505),(3.17,4.505),(3.17,2.155),(2.83,2.155)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'ni': Net.create(cell, 'ni'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['ni']
        createRL(
            tech, net, 'COMP',
            ((0.36,8.615),(0.36,13.845),(0.4,13.845),(0.4,14.375),(0.8,14.375),(0.8,8.615),(0.36,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.4,1.625),(0.4,2.155),(0.36,2.155),(0.36,4.505),(0.8,4.505),(0.8,1.625),(0.4,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,2.47),(0.43,2.69),(0.65,2.69),(0.65,2.47),(0.43,2.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,2.97),(0.43,3.19),(0.65,3.19),(0.65,2.97),(0.43,2.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,3.47),(0.43,3.69),(0.65,3.69),(0.65,3.47),(0.43,3.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,3.97),(0.43,4.19),(0.65,4.19),(0.65,3.97),(0.43,3.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,6.45),(0.43,6.67),(0.65,6.67),(0.65,6.45),(0.43,6.45)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,8.87),(0.43,9.09),(0.65,9.09),(0.65,8.87),(0.43,8.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.37),(0.43,9.59),(0.65,9.59),(0.65,9.37),(0.43,9.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,9.87),(0.43,10.09),(0.65,10.09),(0.65,9.87),(0.43,9.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,10.37),(0.43,10.59),(0.65,10.59),(0.65,10.37),(0.43,10.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,10.87),(0.43,11.09),(0.65,11.09),(0.65,10.87),(0.43,10.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,11.37),(0.43,11.59),(0.65,11.59),(0.65,11.37),(0.43,11.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,11.87),(0.43,12.09),(0.65,12.09),(0.65,11.87),(0.43,11.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,12.37),(0.43,12.59),(0.65,12.59),(0.65,12.37),(0.43,12.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,12.87),(0.43,13.09),(0.65,13.09),(0.65,12.87),(0.43,12.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,13.37),(0.43,13.59),(0.65,13.59),(0.65,13.37),(0.43,13.37)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.37,2.155),(0.37,13.845),(0.71,13.845),(0.71,2.155),(0.37,2.155)),
        )
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.405),(2.14,6.38),(0.36,6.38),(0.36,6.74),(2.14,6.74),(2.14,14.595),(2.74,14.595),(2.74,6.74),(3.26,6.74),(3.26,14.595),(3.86,14.595),(3.86,6.74),(4.38,6.74),(4.38,14.595),(4.98,14.595),(4.98,6.74),(5.5,6.74),(5.5,14.595),(6.1,14.595),(6.1,1.405),(5.5,1.405),(5.5,6.38),(4.98,6.38),(4.98,1.405),(4.38,1.405),(4.38,6.38),(3.86,6.38),(3.86,1.405),(3.26,1.405),(3.26,6.38),(2.74,6.38),(2.74,1.405),(2.14,1.405)),
        )
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.27,14.98),(0.27,15.8),(7.73,15.8),(7.73,14.98),(0.27,14.98)),
        )
        createRL(
            tech, net, 'Nplus',
            ((0.24,1.395),(0.24,1.925),(0.2,1.925),(0.2,4.735),(6.7,4.735),(6.7,1.395),(0.24,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.27,0.2),(0.27,1.02),(7.73,1.02),(7.73,0.2),(0.27,0.2)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.385),(0.2,14.075),(0.24,14.075),(0.24,14.605),(6.7,14.605),(6.7,8.385),(0.2,8.385)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(8.6,16.6),(8.6,7.68),(-0.6,7.68)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.8,8.615),(0.8,14.375),(2.74,14.375),(2.74,8.615),(0.8,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.26,8.615),(3.26,14.375),(4.98,14.375),(4.98,8.615),(3.26,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.43,15.21),(0.43,15.57),(7.57,15.57),(7.57,15.21),(0.43,15.21)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.5,8.615),(5.5,14.375),(6.54,14.375),(6.54,8.615),(5.5,8.615)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,8.885),(4.01,9.105),(4.23,9.105),(4.23,8.885),(4.01,8.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,9.385),(4.01,9.605),(4.23,9.605),(4.23,9.385),(4.01,9.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,9.885),(4.01,10.105),(4.23,10.105),(4.23,9.885),(4.01,9.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,10.385),(4.01,10.605),(4.23,10.605),(4.23,10.385),(4.01,10.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,10.885),(4.01,11.105),(4.23,11.105),(4.23,10.885),(4.01,10.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,11.385),(4.01,11.605),(4.23,11.605),(4.23,11.385),(4.01,11.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,11.885),(4.01,12.105),(4.23,12.105),(4.23,11.885),(4.01,11.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,12.385),(4.01,12.605),(4.23,12.605),(4.23,12.385),(4.01,12.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,12.885),(4.01,13.105),(4.23,13.105),(4.23,12.885),(4.01,12.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,13.385),(4.01,13.605),(4.23,13.605),(4.23,13.385),(4.01,13.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,13.885),(4.01,14.105),(4.23,14.105),(4.23,13.885),(4.01,13.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,14.085),(1.77,14.305),(1.99,14.305),(1.99,14.085),(1.77,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,8.885),(6.25,9.105),(6.47,9.105),(6.47,8.885),(6.25,8.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,9.385),(6.25,9.605),(6.47,9.605),(6.47,9.385),(6.25,9.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,9.885),(6.25,10.105),(6.47,10.105),(6.47,9.885),(6.25,9.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,10.385),(6.25,10.605),(6.47,10.605),(6.47,10.385),(6.25,10.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,10.885),(6.25,11.105),(6.47,11.105),(6.47,10.885),(6.25,10.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,11.385),(6.25,11.605),(6.47,11.605),(6.47,11.385),(6.25,11.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,11.885),(6.25,12.105),(6.47,12.105),(6.47,11.885),(6.25,11.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,12.385),(6.25,12.605),(6.47,12.605),(6.47,12.385),(6.25,12.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,12.885),(6.25,13.105),(6.47,13.105),(6.47,12.885),(6.25,12.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,13.385),(6.25,13.605),(6.47,13.605),(6.47,13.385),(6.25,13.385)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,13.885),(6.25,14.105),(6.47,14.105),(6.47,13.885),(6.25,13.885)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.64,15.28),(0.64,15.5),(0.86,15.5),(0.86,15.28),(0.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.14,15.28),(1.14,15.5),(1.36,15.5),(1.36,15.28),(1.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.64,15.28),(1.64,15.5),(1.86,15.5),(1.86,15.28),(1.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.14,15.28),(2.14,15.5),(2.36,15.5),(2.36,15.28),(2.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.64,15.28),(2.64,15.5),(2.86,15.5),(2.86,15.28),(2.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.14,15.28),(3.14,15.5),(3.36,15.5),(3.36,15.28),(3.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.64,15.28),(3.64,15.5),(3.86,15.5),(3.86,15.28),(3.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.14,15.28),(4.14,15.5),(4.36,15.5),(4.36,15.28),(4.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.64,15.28),(4.64,15.5),(4.86,15.5),(4.86,15.28),(4.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.14,15.28),(5.14,15.5),(5.36,15.5),(5.36,15.28),(5.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.64,15.28),(5.64,15.5),(5.86,15.5),(5.86,15.28),(5.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.14,15.28),(6.14,15.5),(6.36,15.5),(6.36,15.28),(6.14,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.64,15.28),(6.64,15.5),(6.86,15.5),(6.86,15.28),(6.64,15.28)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.14,15.28),(7.14,15.5),(7.36,15.5),(7.36,15.28),(7.14,15.28)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.95,8.615),(3.95,14.08),(0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(6.53,14.08),(6.53,8.615),(6.19,8.615),(6.19,14.08),(4.29,14.08),(4.29,8.615),(3.95,8.615)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.43,0.43),(0.43,0.79),(7.57,0.79),(7.57,0.43),(0.43,0.43)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.8,1.625),(0.8,4.505),(2.74,4.505),(2.74,1.625),(0.8,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.26,1.625),(3.26,4.505),(4.98,4.505),(4.98,1.625),(3.26,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.5,1.625),(5.5,4.505),(6.54,4.505),(6.54,1.625),(5.5,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,1.705),(6.25,1.925),(6.47,1.925),(6.47,1.705),(6.25,1.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,2.205),(6.25,2.425),(6.47,2.425),(6.47,2.205),(6.25,2.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,2.705),(6.25,2.925),(6.47,2.925),(6.47,2.705),(6.25,2.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,3.205),(6.25,3.425),(6.47,3.425),(6.47,3.205),(6.25,3.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,3.705),(6.25,3.925),(6.47,3.925),(6.47,3.705),(6.25,3.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.25,4.205),(6.25,4.425),(6.47,4.425),(6.47,4.205),(6.25,4.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,1.705),(4.01,1.925),(4.23,1.925),(4.23,1.705),(4.01,1.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,2.205),(4.01,2.425),(4.23,2.425),(4.23,2.205),(4.01,2.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,2.705),(4.01,2.925),(4.23,2.925),(4.23,2.705),(4.01,2.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,3.205),(4.01,3.425),(4.23,3.425),(4.23,3.205),(4.01,3.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,3.705),(4.01,3.925),(4.23,3.925),(4.23,3.705),(4.01,3.705)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.01,4.205),(4.01,4.425),(4.23,4.425),(4.23,4.205),(4.01,4.205)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,1.695),(1.77,1.915),(1.99,1.915),(1.99,1.695),(1.77,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.64,0.5),(0.64,0.72),(0.86,0.72),(0.86,0.5),(0.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.14,0.5),(1.14,0.72),(1.36,0.72),(1.36,0.5),(1.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.64,0.5),(1.64,0.72),(1.86,0.72),(1.86,0.5),(1.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.14,0.5),(2.14,0.72),(2.36,0.72),(2.36,0.5),(2.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.64,0.5),(2.64,0.72),(2.86,0.72),(2.86,0.5),(2.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.14,0.5),(3.14,0.72),(3.36,0.72),(3.36,0.5),(3.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.64,0.5),(3.64,0.72),(3.86,0.72),(3.86,0.5),(3.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.14,0.5),(4.14,0.72),(4.36,0.72),(4.36,0.5),(4.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.64,0.5),(4.64,0.72),(4.86,0.72),(4.86,0.5),(4.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.14,0.5),(5.14,0.72),(5.36,0.72),(5.36,0.5),(5.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.64,0.5),(5.64,0.72),(5.86,0.72),(5.86,0.5),(5.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.14,0.5),(6.14,0.72),(6.36,0.72),(6.36,0.5),(6.14,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((6.64,0.5),(6.64,0.72),(6.86,0.72),(6.86,0.5),(6.64,0.5)),
        )
        createRL(
            tech, net, 'Contact',
            ((7.14,0.5),(7.14,0.72),(7.36,0.72),(7.36,0.5),(7.14,0.5)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(3.95,1.92),(3.95,4.505),(4.29,4.505),(4.29,1.92),(6.19,1.92),(6.19,4.505),(6.53,4.505),(6.53,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'Poly2',
            ((0.8,7.955),(0.8,14.595),(1.4,14.595),(1.4,7.955),(0.8,7.955)),
        )
        createRL(
            tech, net, 'Poly2',
            ((0.8,1.405),(0.8,5.165),(1.4,5.165),(1.4,1.405),(0.8,1.405)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,8.025),(0.945,8.245),(1.165,8.245),(1.165,8.025),(0.945,8.025)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.945,4.875),(0.945,5.095),(1.165,5.095),(1.165,4.875),(0.945,4.875)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.94,2.15),(0.94,13.85),(1.2,13.85),(1.2,2.15),(0.94,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.07), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'COMP',
            ((2.74,8.615),(2.74,14.375),(3.26,14.375),(3.26,8.615),(2.74,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.98,8.615),(4.98,14.375),(5.5,14.375),(5.5,8.615),(4.98,8.615)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.74,1.625),(2.74,4.505),(3.26,4.505),(3.26,1.625),(2.74,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.98,1.625),(4.98,4.505),(5.5,4.505),(5.5,1.625),(4.98,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,2.47),(5.13,2.69),(5.35,2.69),(5.35,2.47),(5.13,2.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,2.97),(5.13,3.19),(5.35,3.19),(5.35,2.97),(5.13,2.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,3.47),(5.13,3.69),(5.35,3.69),(5.35,3.47),(5.13,3.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,3.97),(5.13,4.19),(5.35,4.19),(5.35,3.97),(5.13,3.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.47),(2.89,2.69),(3.11,2.69),(3.11,2.47),(2.89,2.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.97),(2.89,3.19),(3.11,3.19),(3.11,2.97),(2.89,2.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.47),(2.89,3.69),(3.11,3.69),(3.11,3.47),(2.89,3.47)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.97),(2.89,4.19),(3.11,4.19),(3.11,3.97),(2.89,3.97)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,8.87),(2.89,9.09),(3.11,9.09),(3.11,8.87),(2.89,8.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.37),(2.89,9.59),(3.11,9.59),(3.11,9.37),(2.89,9.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.87),(2.89,10.09),(3.11,10.09),(3.11,9.87),(2.89,9.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.37),(2.89,10.59),(3.11,10.59),(3.11,10.37),(2.89,10.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.87),(2.89,11.09),(3.11,11.09),(3.11,10.87),(2.89,10.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.37),(2.89,11.59),(3.11,11.59),(3.11,11.37),(2.89,11.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.87),(2.89,12.09),(3.11,12.09),(3.11,11.87),(2.89,11.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.37),(2.89,12.59),(3.11,12.59),(3.11,12.37),(2.89,12.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.87),(2.89,13.09),(3.11,13.09),(3.11,12.87),(2.89,12.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,13.37),(2.89,13.59),(3.11,13.59),(3.11,13.37),(2.89,13.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,8.87),(5.13,9.09),(5.35,9.09),(5.35,8.87),(5.13,8.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,9.37),(5.13,9.59),(5.35,9.59),(5.35,9.37),(5.13,9.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,9.87),(5.13,10.09),(5.35,10.09),(5.35,9.87),(5.13,9.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,10.37),(5.13,10.59),(5.35,10.59),(5.35,10.37),(5.13,10.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,10.87),(5.13,11.09),(5.35,11.09),(5.35,10.87),(5.13,10.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,11.37),(5.13,11.59),(5.35,11.59),(5.35,11.37),(5.13,11.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,11.87),(5.13,12.09),(5.35,12.09),(5.35,11.87),(5.13,11.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,12.37),(5.13,12.59),(5.35,12.59),(5.35,12.37),(5.13,12.37)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,12.87),(5.13,13.09),(5.35,13.09),(5.35,12.87),(5.13,12.87)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.13,13.37),(5.13,13.59),(5.35,13.59),(5.35,13.37),(5.13,13.37)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.83,2.155),(2.83,13.845),(3.17,13.845),(3.17,8.615),(3.09,8.615),(3.09,8.385),(5.07,8.385),(5.07,13.845),(5.41,13.845),(5.41,8.615),(5.33,8.615),(5.33,4.505),(5.41,4.505),(5.41,2.155),(5.07,2.155),(5.07,4.735),(3.09,4.735),(3.09,4.505),(3.17,4.505),(3.17,2.155),(2.83,2.155)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.96), u(0.26), u(2.155), u(13.845),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['nand2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.800000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'int0': Net.create(cell, 'int0'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,5.35),(1.62,5.35),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,2.15),(2.14,5.35),(2.74,5.35),(2.74,2.15),(2.14,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(4.8,1.92),(4.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,5.58),(3.34,5.58),(3.34,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,10.42),(0.2,14.605),(0.88,14.605),(0.88,14.08),(2.88,14.08),(2.88,14.605),(3.56,14.605),(3.56,10.42),(0.2,10.42)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(5.2,16.4),(5.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(4.805,16.005),(4.805,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,10.65),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,10.65),(0.36,10.65)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,10.65),(2.14,13.85),(3.04,13.85),(3.04,14.375),(3.4,14.375),(3.4,10.65),(2.14,10.65)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,14.085),(3.11,14.305),(3.33,14.305),(3.33,14.085),(3.11,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(4.8,16.0),(4.8,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(5.4,16.6),(5.4,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,5.35),(2.14,5.35),(2.14,2.15),(1.62,2.15)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,10.65),(1.62,13.85),(2.14,13.85),(2.14,10.65),(1.62,10.65)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.74,2.15),(2.74,5.35),(3.18,5.35),(3.18,2.15),(2.74,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.39),(2.89,2.61),(3.11,2.61),(3.11,2.39),(2.89,2.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,2.89),(2.89,3.11),(3.11,3.11),(3.11,2.89),(2.89,2.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.39),(2.89,3.61),(3.11,3.61),(3.11,3.39),(2.89,3.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,3.89),(2.89,4.11),(3.11,4.11),(3.11,3.89),(2.89,3.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,4.39),(2.89,4.61),(3.11,4.61),(3.11,4.39),(2.89,4.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,4.89),(2.89,5.11),(3.11,5.11),(3.11,4.89),(2.89,4.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.89),(1.77,11.11),(1.99,11.11),(1.99,10.89),(1.77,10.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.39),(1.77,11.61),(1.99,11.61),(1.99,11.39),(1.77,11.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.89),(1.77,12.11),(1.99,12.11),(1.99,11.89),(1.77,11.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.39),(1.77,12.61),(1.99,12.61),(1.99,12.39),(1.77,12.39)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.89),(1.77,13.11),(1.99,13.11),(1.99,12.89),(1.77,12.89)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.39),(1.77,13.61),(1.99,13.61),(1.99,13.39),(1.77,13.39)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.83,2.15),(2.83,10.65),(1.71,10.65),(1.71,13.85),(3.09,13.85),(3.09,5.35),(3.17,5.35),(3.17,2.15),(2.83,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.96), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.96), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,2.15),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,10.42),(2.38,10.42),(2.38,2.15),(2.12,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(2.15), u(10.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(2.15), u(10.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nand3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'int0': Net.create(cell, 'int0'),
            'int1': Net.create(cell, 'int1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((3.7,2.15),(3.7,6.15),(4.3,6.15),(4.3,2.15),(3.7,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,2.15),(2.14,6.15),(2.74,6.15),(2.74,2.15),(2.14,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,6.15),(1.62,6.15),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,6.38),(4.9,6.38),(4.9,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,9.62),(0.2,14.605),(0.88,14.605),(0.88,14.08),(2.88,14.08),(2.88,14.605),(3.56,14.605),(3.56,14.08),(4.9,14.08),(4.9,9.62),(0.2,9.62)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,9.85),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,9.85),(0.36,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,9.85),(2.14,13.85),(3.04,13.85),(3.04,14.375),(3.4,14.375),(3.4,13.85),(4.3,13.85),(4.3,9.85),(2.14,9.85)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,14.085),(3.11,14.305),(3.33,14.305),(3.33,14.085),(3.11,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,6.15),(2.14,6.15),(2.14,2.15),(1.62,2.15)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,9.85),(1.62,13.85),(2.14,13.85),(2.14,9.85),(1.62,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,9.85),(4.3,13.85),(4.74,13.85),(4.74,9.85),(4.3,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,2.15),(4.3,6.15),(4.74,6.15),(4.74,2.15),(4.3,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.29),(4.45,2.51),(4.67,2.51),(4.67,2.29),(4.45,2.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.79),(4.45,3.01),(4.67,3.01),(4.67,2.79),(4.45,2.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.29),(4.45,3.51),(4.67,3.51),(4.67,3.29),(4.45,3.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.79),(4.45,4.01),(4.67,4.01),(4.67,3.79),(4.45,3.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,4.29),(4.45,4.51),(4.67,4.51),(4.67,4.29),(4.45,4.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,4.79),(4.45,5.01),(4.67,5.01),(4.67,4.79),(4.45,4.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,5.29),(4.45,5.51),(4.67,5.51),(4.67,5.29),(4.45,5.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,5.79),(4.45,6.01),(4.67,6.01),(4.67,5.79),(4.45,5.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.99),(1.77,10.21),(1.99,10.21),(1.99,9.99),(1.77,9.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.49),(1.77,10.71),(1.99,10.71),(1.99,10.49),(1.77,10.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.99),(1.77,11.21),(1.99,11.21),(1.99,10.99),(1.77,10.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.49),(1.77,11.71),(1.99,11.71),(1.99,11.49),(1.77,11.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.99),(1.77,12.21),(1.99,12.21),(1.99,11.99),(1.77,11.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.49),(1.77,12.71),(1.99,12.71),(1.99,12.49),(1.77,12.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.99),(1.77,13.21),(1.99,13.21),(1.99,12.99),(1.77,12.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.49),(1.77,13.71),(1.99,13.71),(1.99,13.49),(1.77,13.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.99),(4.45,10.21),(4.67,10.21),(4.67,9.99),(4.45,9.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.49),(4.45,10.71),(4.67,10.71),(4.67,10.49),(4.45,10.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.99),(4.45,11.21),(4.67,11.21),(4.67,10.99),(4.45,10.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.49),(4.45,11.71),(4.67,11.71),(4.67,11.49),(4.45,11.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.99),(4.45,12.21),(4.67,12.21),(4.67,11.99),(4.45,11.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.49),(4.45,12.71),(4.67,12.71),(4.67,12.49),(4.45,12.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.99),(4.45,13.21),(4.67,13.21),(4.67,12.99),(4.45,12.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,13.49),(4.45,13.71),(4.67,13.71),(4.67,13.49),(4.45,13.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.39,2.15),(4.39,9.85),(1.71,9.85),(1.71,13.85),(4.73,13.85),(4.73,9.85),(4.65,9.85),(4.65,6.15),(4.73,6.15),(4.73,2.15),(4.39,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.52), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.52), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int1']
        createRL(
            tech, net, 'COMP',
            ((2.74,2.15),(2.74,6.15),(3.7,6.15),(3.7,2.15),(2.74,2.15)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,2.15),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,9.62),(2.38,9.62),(2.38,2.15),(2.12,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(2.15), u(9.62),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(2.15), u(9.62),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((3.7,1.93),(3.7,7.5),(3.59,7.5),(3.59,7.86),(3.7,7.86),(3.7,14.07),(4.3,14.07),(4.3,1.93),(3.7,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.66,7.57),(3.66,7.79),(3.88,7.79),(3.88,7.57),(3.66,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.68,2.15),(3.68,7.565),(3.6,7.565),(3.6,7.795),(3.68,7.795),(3.68,9.62),(3.94,9.62),(3.94,2.15),(3.68,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.81), u(0.26), u(2.15), u(9.62),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.81), u(0.26), u(2.15), u(9.62),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nand4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'int0': Net.create(cell, 'int0'),
            'int1': Net.create(cell, 'int1'),
            'int2': Net.create(cell, 'int2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((3.7,2.15),(3.7,6.15),(4.3,6.15),(4.3,2.15),(3.7,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,2.15),(2.14,6.15),(2.74,6.15),(2.74,2.15),(2.14,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,6.15),(1.62,6.15),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.82,2.15),(4.82,6.15),(5.42,6.15),(5.42,2.15),(4.82,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,6.38),(6.02,6.38),(6.02,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,9.62),(0.2,14.605),(0.88,14.605),(0.88,14.08),(2.88,14.08),(2.88,14.605),(3.56,14.605),(3.56,14.08),(5.56,14.08),(5.56,14.605),(6.24,14.605),(6.24,9.62),(0.2,9.62)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((4.82,9.85),(4.82,13.85),(5.72,13.85),(5.72,14.375),(6.08,14.375),(6.08,9.85),(4.82,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,9.85),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,9.85),(0.36,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,9.85),(2.14,13.85),(3.04,13.85),(3.04,14.375),(3.4,14.375),(3.4,13.85),(4.3,13.85),(4.3,9.85),(2.14,9.85)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,14.085),(3.11,14.305),(3.33,14.305),(3.33,14.085),(3.11,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.79,14.085),(5.79,14.305),(6.01,14.305),(6.01,14.085),(5.79,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(8.6,16.6),(8.6,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,6.15),(2.14,6.15),(2.14,2.15),(1.62,2.15)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((5.42,2.15),(5.42,6.15),(5.86,6.15),(5.86,2.15),(5.42,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,9.85),(1.62,13.85),(2.14,13.85),(2.14,9.85),(1.62,9.85)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,9.85),(4.3,13.85),(4.82,13.85),(4.82,9.85),(4.3,9.85)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,2.29),(5.57,2.51),(5.79,2.51),(5.79,2.29),(5.57,2.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,2.79),(5.57,3.01),(5.79,3.01),(5.79,2.79),(5.57,2.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,3.29),(5.57,3.51),(5.79,3.51),(5.79,3.29),(5.57,3.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,3.79),(5.57,4.01),(5.79,4.01),(5.79,3.79),(5.57,3.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,4.29),(5.57,4.51),(5.79,4.51),(5.79,4.29),(5.57,4.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,4.79),(5.57,5.01),(5.79,5.01),(5.79,4.79),(5.57,4.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,5.29),(5.57,5.51),(5.79,5.51),(5.79,5.29),(5.57,5.29)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,5.79),(5.57,6.01),(5.79,6.01),(5.79,5.79),(5.57,5.79)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,9.99),(1.77,10.21),(1.99,10.21),(1.99,9.99),(1.77,9.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.49),(1.77,10.71),(1.99,10.71),(1.99,10.49),(1.77,10.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,10.99),(1.77,11.21),(1.99,11.21),(1.99,10.99),(1.77,10.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.49),(1.77,11.71),(1.99,11.71),(1.99,11.49),(1.77,11.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,11.99),(1.77,12.21),(1.99,12.21),(1.99,11.99),(1.77,11.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.49),(1.77,12.71),(1.99,12.71),(1.99,12.49),(1.77,12.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,12.99),(1.77,13.21),(1.99,13.21),(1.99,12.99),(1.77,12.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,13.49),(1.77,13.71),(1.99,13.71),(1.99,13.49),(1.77,13.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.99),(4.45,10.21),(4.67,10.21),(4.67,9.99),(4.45,9.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.49),(4.45,10.71),(4.67,10.71),(4.67,10.49),(4.45,10.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.99),(4.45,11.21),(4.67,11.21),(4.67,10.99),(4.45,10.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.49),(4.45,11.71),(4.67,11.71),(4.67,11.49),(4.45,11.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.99),(4.45,12.21),(4.67,12.21),(4.67,11.99),(4.45,11.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.49),(4.45,12.71),(4.67,12.71),(4.67,12.49),(4.45,12.49)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.99),(4.45,13.21),(4.67,13.21),(4.67,12.99),(4.45,12.99)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,13.49),(4.45,13.71),(4.67,13.71),(4.67,13.49),(4.45,13.49)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.51,2.15),(5.51,9.85),(1.71,9.85),(1.71,13.85),(5.77,13.85),(5.77,6.15),(5.85,6.15),(5.85,2.15),(5.51,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.64), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.64), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int1']
        createRL(
            tech, net, 'COMP',
            ((2.74,2.15),(2.74,6.15),(3.7,6.15),(3.7,2.15),(2.74,2.15)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,2.15),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,9.62),(2.38,9.62),(2.38,2.15),(2.12,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(2.15), u(9.62),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(2.15), u(9.62),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int2']
        createRL(
            tech, net, 'COMP',
            ((4.3,2.15),(4.3,6.15),(4.82,6.15),(4.82,2.15),(4.3,2.15)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((3.7,1.93),(3.7,7.5),(3.59,7.5),(3.59,7.86),(3.7,7.86),(3.7,14.07),(4.3,14.07),(4.3,1.93),(3.7,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.66,7.57),(3.66,7.79),(3.88,7.79),(3.88,7.57),(3.66,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.68,2.15),(3.68,7.565),(3.6,7.565),(3.6,7.795),(3.68,7.795),(3.68,9.62),(3.94,9.62),(3.94,2.15),(3.68,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.81), u(0.26), u(2.15), u(9.62),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.81), u(0.26), u(2.15), u(9.62),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'Poly2',
            ((4.82,1.93),(4.82,7.5),(4.71,7.5),(4.71,7.86),(4.82,7.86),(4.82,14.07),(5.42,14.07),(5.42,1.93),(4.82,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.78,7.57),(4.78,7.79),(5.0,7.79),(5.0,7.57),(4.78,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.8,2.15),(4.8,7.565),(4.72,7.565),(4.72,7.795),(4.8,7.795),(4.8,9.62),(5.06,9.62),(5.06,2.15),(4.8,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.93), u(0.26), u(2.15), u(9.62),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.93), u(0.26), u(2.15), u(9.62),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.800000000000001), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'int0': Net.create(cell, 'int0'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,3.75),(1.62,3.75),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.04,1.625),(3.04,2.15),(2.14,2.15),(2.14,3.75),(3.4,3.75),(3.4,1.625),(3.04,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,1.695),(3.11,1.915),(3.33,1.915),(3.33,1.695),(3.11,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(4.8,1.92),(4.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,3.98),(3.56,3.98),(3.56,1.395),(2.88,1.395),(2.88,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.82),(0.2,14.605),(0.88,14.605),(0.88,14.08),(3.34,14.08),(3.34,8.82),(0.2,8.82)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(5.2,16.4),(5.2,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(4.805,16.005),(4.805,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((2.14,9.05),(2.14,13.85),(2.74,13.85),(2.74,9.05),(2.14,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,9.05),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,9.05),(0.36,9.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(4.8,16.0),(4.8,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(5.4,16.6),(5.4,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.4), u(4.8), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((2.74,9.05),(2.74,13.85),(3.18,13.85),(3.18,9.05),(2.74,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,3.75),(2.14,3.75),(2.14,2.15),(1.62,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.34),(2.89,9.56),(3.11,9.56),(3.11,9.34),(2.89,9.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,9.84),(2.89,10.06),(3.11,10.06),(3.11,9.84),(2.89,9.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.34),(2.89,10.56),(3.11,10.56),(3.11,10.34),(2.89,10.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,10.84),(2.89,11.06),(3.11,11.06),(3.11,10.84),(2.89,10.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.34),(2.89,11.56),(3.11,11.56),(3.11,11.34),(2.89,11.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,11.84),(2.89,12.06),(3.11,12.06),(3.11,11.84),(2.89,11.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.34),(2.89,12.56),(3.11,12.56),(3.11,12.34),(2.89,12.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,12.84),(2.89,13.06),(3.11,13.06),(3.11,12.84),(2.89,12.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.89,13.34),(2.89,13.56),(3.11,13.56),(3.11,13.34),(2.89,13.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.34),(1.77,2.56),(1.99,2.56),(1.99,2.34),(1.77,2.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.84),(1.77,3.06),(1.99,3.06),(1.99,2.84),(1.77,2.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.34),(1.77,3.56),(1.99,3.56),(1.99,3.34),(1.77,3.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,3.75),(2.83,3.75),(2.83,13.85),(3.17,13.85),(3.17,9.05),(3.09,9.05),(3.09,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.96), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.96), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,9.05),(1.62,13.85),(2.14,13.85),(2.14,9.05),(1.62,9.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,3.98),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,13.85),(2.38,13.85),(2.38,3.98),(2.12,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nor3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.4), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'int0': Net.create(cell, 'int0'),
            'int1': Net.create(cell, 'int1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,3.75),(1.62,3.75),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.04,1.625),(3.04,2.15),(2.14,2.15),(2.14,3.75),(4.3,3.75),(4.3,2.15),(3.4,2.15),(3.4,1.625),(3.04,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,1.695),(3.11,1.915),(3.33,1.915),(3.33,1.695),(3.11,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(6.4,1.92),(6.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,3.98),(4.9,3.98),(4.9,1.92),(3.56,1.92),(3.56,1.395),(2.88,1.395),(2.88,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.82),(0.2,14.605),(0.88,14.605),(0.88,14.08),(4.9,14.08),(4.9,8.82),(0.2,8.82)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(6.8,16.4),(6.8,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(6.405,16.005),(6.405,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((0.36,9.05),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,9.05),(0.36,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.7,9.05),(3.7,13.85),(4.3,13.85),(4.3,9.05),(3.7,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,9.05),(2.14,13.85),(2.74,13.85),(2.74,9.05),(2.14,9.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(6.4,16.0),(6.4,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(7.0,16.6),(7.0,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.2), u(6.4), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((4.3,9.05),(4.3,13.85),(4.74,13.85),(4.74,9.05),(4.3,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,2.15),(4.3,3.75),(4.74,3.75),(4.74,2.15),(4.3,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,3.75),(2.14,3.75),(2.14,2.15),(1.62,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.34),(4.45,2.56),(4.67,2.56),(4.67,2.34),(4.45,2.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.84),(4.45,3.06),(4.67,3.06),(4.67,2.84),(4.45,2.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.34),(4.45,3.56),(4.67,3.56),(4.67,3.34),(4.45,3.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.34),(4.45,9.56),(4.67,9.56),(4.67,9.34),(4.45,9.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,9.84),(4.45,10.06),(4.67,10.06),(4.67,9.84),(4.45,9.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.34),(4.45,10.56),(4.67,10.56),(4.67,10.34),(4.45,10.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,10.84),(4.45,11.06),(4.67,11.06),(4.67,10.84),(4.45,10.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.34),(4.45,11.56),(4.67,11.56),(4.67,11.34),(4.45,11.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,11.84),(4.45,12.06),(4.67,12.06),(4.67,11.84),(4.45,11.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.34),(4.45,12.56),(4.67,12.56),(4.67,12.34),(4.45,12.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,12.84),(4.45,13.06),(4.67,13.06),(4.67,12.84),(4.45,12.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,13.34),(4.45,13.56),(4.67,13.56),(4.67,13.34),(4.45,13.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.34),(1.77,2.56),(1.99,2.56),(1.99,2.34),(1.77,2.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.84),(1.77,3.06),(1.99,3.06),(1.99,2.84),(1.77,2.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.34),(1.77,3.56),(1.99,3.56),(1.99,3.34),(1.77,3.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,3.75),(4.39,3.75),(4.39,13.85),(4.73,13.85),(4.73,9.05),(4.65,9.05),(4.65,3.75),(4.73,3.75),(4.73,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.52), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.52), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,9.05),(1.62,13.85),(2.14,13.85),(2.14,9.05),(1.62,9.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,3.98),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,13.85),(2.38,13.85),(2.38,3.98),(2.12,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int1']
        createRL(
            tech, net, 'COMP',
            ((2.74,9.05),(2.74,13.85),(3.7,13.85),(3.7,9.05),(2.74,9.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((3.7,1.93),(3.7,7.5),(3.59,7.5),(3.59,7.86),(3.7,7.86),(3.7,14.07),(4.3,14.07),(4.3,1.93),(3.7,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.66,7.57),(3.66,7.79),(3.88,7.79),(3.88,7.57),(3.66,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.68,3.98),(3.68,7.565),(3.6,7.565),(3.6,7.795),(3.68,7.795),(3.68,13.85),(3.94,13.85),(3.94,3.98),(3.68,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.81), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.81), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nor4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(16.0),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'int0': Net.create(cell, 'int0'),
            'int1': Net.create(cell, 'int1'),
            'int2': Net.create(cell, 'int2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'COMP',
            ((5.72,1.625),(5.72,2.15),(4.82,2.15),(4.82,3.75),(6.08,3.75),(6.08,1.625),(5.72,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.04,1.625),(3.04,2.15),(2.14,2.15),(2.14,3.75),(4.3,3.75),(4.3,2.15),(3.4,2.15),(3.4,1.625),(3.04,1.625)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,1.625),(0.36,3.75),(1.62,3.75),(1.62,2.15),(0.72,2.15),(0.72,1.625),(0.36,1.625)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.79,1.695),(5.79,1.915),(6.01,1.915),(6.01,1.695),(5.79,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.11,1.695),(3.11,1.915),(3.33,1.915),(3.33,1.695),(3.11,1.695)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,1.695),(0.43,1.915),(0.65,1.915),(0.65,1.695),(0.43,1.695)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.92),(8.0,1.92),(8.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.92),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'Nplus',
            ((0.2,1.395),(0.2,3.98),(6.24,3.98),(6.24,1.395),(5.56,1.395),(5.56,1.92),(3.56,1.92),(3.56,1.395),(2.88,1.395),(2.88,1.92),(0.88,1.92),(0.88,1.395),(0.2,1.395)),
        )
        createRL(
            tech, net, 'Pplus',
            ((0.2,8.82),(0.2,14.605),(0.88,14.605),(0.88,14.08),(6.02,14.08),(6.02,8.82),(0.2,8.82)),
        )
        createRL(
            tech, net, 'Dualgate',
            ((-0.4,-0.4),(-0.4,16.4),(8.4,16.4),(8.4,-0.4),(-0.4,-0.4)),
        )
        createRL(
            tech, net, 'V5_XTOR',
            ((-0.005,-0.005),(-0.005,16.005),(8.005,16.005),(8.005,-0.005),(-0.005,-0.005)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'COMP',
            ((4.82,9.05),(4.82,13.85),(5.42,13.85),(5.42,9.05),(4.82,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((2.14,9.05),(2.14,13.85),(2.74,13.85),(2.74,9.05),(2.14,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((3.7,9.05),(3.7,13.85),(4.3,13.85),(4.3,9.05),(3.7,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((0.36,9.05),(0.36,14.375),(0.72,14.375),(0.72,13.85),(1.62,13.85),(1.62,9.05),(0.36,9.05)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.43,14.085),(0.43,14.305),(0.65,14.305),(0.65,14.085),(0.43,14.085)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,14.08),(0.0,16.0),(8.0,16.0),(8.0,14.08),(0.0,14.08)),
        )
        createRL(
            tech, net, 'Nwell',
            ((-0.6,7.68),(-0.6,16.6),(8.6,16.6),(8.6,7.68),(-0.6,7.68)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(14.08), u(16.0),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'COMP',
            ((1.62,2.15),(1.62,3.75),(2.14,3.75),(2.14,2.15),(1.62,2.15)),
        )
        createRL(
            tech, net, 'COMP',
            ((5.42,9.05),(5.42,13.85),(5.86,13.85),(5.86,9.05),(5.42,9.05)),
        )
        createRL(
            tech, net, 'COMP',
            ((4.3,2.15),(4.3,3.75),(4.82,3.75),(4.82,2.15),(4.3,2.15)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,9.34),(5.57,9.56),(5.79,9.56),(5.79,9.34),(5.57,9.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,9.84),(5.57,10.06),(5.79,10.06),(5.79,9.84),(5.57,9.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,10.34),(5.57,10.56),(5.79,10.56),(5.79,10.34),(5.57,10.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,10.84),(5.57,11.06),(5.79,11.06),(5.79,10.84),(5.57,10.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,11.34),(5.57,11.56),(5.79,11.56),(5.79,11.34),(5.57,11.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,11.84),(5.57,12.06),(5.79,12.06),(5.79,11.84),(5.57,11.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,12.34),(5.57,12.56),(5.79,12.56),(5.79,12.34),(5.57,12.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,12.84),(5.57,13.06),(5.79,13.06),(5.79,12.84),(5.57,12.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((5.57,13.34),(5.57,13.56),(5.79,13.56),(5.79,13.34),(5.57,13.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.34),(4.45,2.56),(4.67,2.56),(4.67,2.34),(4.45,2.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,2.84),(4.45,3.06),(4.67,3.06),(4.67,2.84),(4.45,2.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.45,3.34),(4.45,3.56),(4.67,3.56),(4.67,3.34),(4.45,3.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.34),(1.77,2.56),(1.99,2.56),(1.99,2.34),(1.77,2.34)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,2.84),(1.77,3.06),(1.99,3.06),(1.99,2.84),(1.77,2.84)),
        )
        createRL(
            tech, net, 'Contact',
            ((1.77,3.34),(1.77,3.56),(1.99,3.56),(1.99,3.34),(1.77,3.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.71,2.15),(1.71,3.75),(5.51,3.75),(5.51,13.85),(5.85,13.85),(5.85,9.05),(5.77,9.05),(5.77,2.15),(1.71,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(5.64), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.64), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'Poly2',
            ((1.02,1.93),(1.02,7.5),(0.91,7.5),(0.91,7.86),(1.02,7.86),(1.02,14.07),(1.62,14.07),(1.62,1.93),(1.02,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((0.98,7.57),(0.98,7.79),(1.2,7.79),(1.2,7.57),(0.98,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.0,2.15),(1.0,7.565),(0.92,7.565),(0.92,7.795),(1.0,7.795),(1.0,13.85),(1.26,13.85),(1.26,2.15),(1.0,2.15)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.13), u(0.26), u(2.15), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int0']
        createRL(
            tech, net, 'COMP',
            ((1.62,9.05),(1.62,13.85),(2.14,13.85),(2.14,9.05),(1.62,9.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'Poly2',
            ((2.14,1.93),(2.14,7.5),(2.03,7.5),(2.03,7.86),(2.14,7.86),(2.14,14.07),(2.74,14.07),(2.74,1.93),(2.14,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((2.1,7.57),(2.1,7.79),(2.32,7.79),(2.32,7.57),(2.1,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.12,3.98),(2.12,7.565),(2.04,7.565),(2.04,7.795),(2.12,7.795),(2.12,13.85),(2.38,13.85),(2.38,3.98),(2.12,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.25), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int1']
        createRL(
            tech, net, 'COMP',
            ((2.74,9.05),(2.74,13.85),(3.7,13.85),(3.7,9.05),(2.74,9.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'Poly2',
            ((3.7,1.93),(3.7,7.5),(3.59,7.5),(3.59,7.86),(3.7,7.86),(3.7,14.07),(4.3,14.07),(4.3,1.93),(3.7,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((3.66,7.57),(3.66,7.79),(3.88,7.79),(3.88,7.57),(3.66,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.68,3.98),(3.68,7.565),(3.6,7.565),(3.6,7.795),(3.68,7.795),(3.68,13.85),(3.94,13.85),(3.94,3.98),(3.68,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(3.81), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.81), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['int2']
        createRL(
            tech, net, 'COMP',
            ((4.3,9.05),(4.3,13.85),(4.82,13.85),(4.82,9.05),(4.3,9.05)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'Poly2',
            ((4.82,1.93),(4.82,7.5),(4.71,7.5),(4.71,7.86),(4.82,7.86),(4.82,14.07),(5.42,14.07),(5.42,1.93),(4.82,1.93)),
        )
        createRL(
            tech, net, 'Contact',
            ((4.78,7.57),(4.78,7.79),(5.0,7.79),(5.0,7.57),(4.78,7.57)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.8,3.98),(4.8,7.565),(4.72,7.565),(4.72,7.795),(4.8,7.795),(4.8,13.85),(5.06,13.85),(5.06,3.98),(4.8,3.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1_Label'),
            u(4.93), u(0.26), u(3.98), u(13.85),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.93), u(0.26), u(3.98), u(13.85),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    af.wrapLibrary(lib, 0)

    return lib

def setup():
    lib = _load()
    _routing()
    try:
        from .StdCell5V0Lib_fix import fix
    except:
        pass
    else:
        fix(lib)

    return lib
